/*
 * Mocha 
 * Copyright (c) 2005 IT Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file AppSndConfig.h
 *
 * This file define configures of Application Sound Manager.
 *
 * @author	mobum
 */
/*:Associate with "Application Sound Manager" */

#ifndef _APP_SND_CONFIG_H_
#define _APP_SND_CONFIG_H_

#include "Shp.h"
#include "EventMgr.h"
#include "AvPlayer.h"
#include "AppScenario.h"


// Debug structure
#if defined(_APP_SND_DEBUG)
#	define	APP_SND_DEBUG_STRUCT	\
	const char*			pszFile;	\
	int					nLine;
#else	// _APP_SND_DEBUG
#	define	APP_SND_DEBUG_STRUCT		///<  Debug structure
#endif	// !_APP_SND_DEBUG

// Measure elapsed time
#if defined(_APP_SND_MEASURE_ELAPSED_TIME)

#	define	APP_SND_MEASURE_TIME_START(strIdentifier) \
	{\
		const char*	pszIdentifier	= strIdentifier; \
		UINT32	uTmElapsed		= 0;\
		uTmElapsed = TmGetElapsedTime();
#	define	APP_SND_MEASURE_TIME_END() \
		uTmElapsed	= TmGetElapsedTime() - uTmElapsed;\
		SysDebug((MID_APPSNDMGR|DBG_APPSNDMGR_MEASURE, "(%s)'s Elapsed Time (%d)!!\n", pszIdentifier, uTmElapsed));\
	}

#else // _APP_SND_MEASURE_ELAPSED_TIME

#	define	APP_SND_MEASURE_TIME_START(strIdentifier)
#	define	APP_SND_MEASURE_TIME_END()

#endif // !_APP_SND_MEASURE_ELAPSED_TIME


#endif // _APP_SND_CONFIG_H_
