/*
 * Mocha
 * Copyright (c) 2000-2003 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/*:Associate with "Boot Manager" */

#ifndef _BOOT_ECOM_H_
#define _BOOT_ECOM_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * ECOM Interface
 */
ECOM_INTERFACE(EBootMgr)
{
	DECLARE_EBASE()

	void (*Boot)(char* szConfigFile, void* pParams, void (*initCallback)(void));
	void (*Shutdown)(void);
	void (*Reset)(void);
	void (*SetPowerSaveMode)(BmCPUType iCPU, UINT32 cases, BOOL bOn, char* szFileName, int nLine);
	void (*SetPowerSaveTimeout)(BmCPUType iCPU, ULONG timeout, char* szFileName, int nLine);
	void (*SetPowerSaveState)(BmCPUType iCPU, BmPowerSaveState psState);
	BOOL (*IsAlwaysOff)(BmCPUType iCPU);
	BmPowerSaveState (*GetPowerSaveState)(BmCPUType iCPU);
	BOOL (*RestartPowerSaveTimer)(BmCPUType iCPU);
	BOOL (*IsAwake)(BmCPUType iCPU);
	BOOL (*SetAwake)(BmCPUType iCPU, BOOL bLcdOn);
};

/*
 * Interface Accessor
 */
// Native/DLL Call
#if (defined(_SHP_SIMUL) && defined(_SHP_CALL_DLL_BOOTMGR)) || (defined(_SHP_DLL) && ! defined(_SHP_DLL_BOOTMGR) && ! defined(_SHP_CALL_DLL_BOOTMGR))
#	define BmDispatch					(__BmGetVtbl()->Dispatch)
#	define BmBoot					(__BmGetVtbl()->Boot)
#	define BmShutdown				(__BmGetVtbl()->Shutdown)
#	define BmReset					(__BmGetVtbl()->Reset)
#	define BmSetPowerSaveMode		(__BmGetVtbl()->SetPowerSaveMode)
#	define BmSetPowerSaveTimeout	(__BmGetVtbl()->SetPowerSaveTimeout)
#	define BmSetPowerSaveState		(__BmGetVtbl()->SetPowerSaveState)
#	define BmGetPowerSaveState		(__BmGetVtbl()->GetPowerSaveState)
#	define BmRestartPowerSaveTimer	(__BmGetVtbl()->RestartPowerSaveTimer)
#	define BmIsAwake				(__BmGetVtbl()->IsAwake)
#	define BmSetAwake				(__BmGetVtbl()->SetAwake)
#endif // _SHP_DLL

/*
 * ECOM Type
 */
typedef struct
{
	DECLARE_ECOM_VTBL(EBootMgr)
	UINT32		refCount;

} TBootMgr;

extern TBootMgr bootMgr;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _BOOT_ECOM_H_
