/*
 * Mocha
 * Copyright (c) 2000-2003 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */

/*:Associate with "Device Manager" */

#ifndef _DEV_PHONE_STATUS_H_
#define _DEV_PHONE_STATUS_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "DevTypes.h"

/**
 * Define a type of a phone status item
 */
typedef enum
{
	PS_LCDTYPE,
	PS_MAX
} PhoneStatusType;

/**
	Define a type of a phone accessory.(such as TA, ear-mic, and etc)
*/
typedef enum
{
	PS_DEV_USB,			/**< Specifies USB data cable */
} PhoneStatusDevType;

 typedef enum 
{
	PSV_MSG_NONE			= 0x00000000,		/**< Not available */
}PhsMsgIconType;

/* This enumeration is defined only for PS_PSTYPE */
typedef enum 
{
	PSV_NET_APP_NO_TRANSMIT,			/**< Specifies no transmit status */
}PhsNetAppType;

/* This enumeration is defined only for PS_PSAPPTYPE */
typedef enum 
{
	PSV_NET_APP_EX_NORMAL_MODE,
}PhsNetAppExType;

/* This enumeration is defined only for PS_PCBROWSING */
typedef enum 
{
	PSV_PCB_IDLE,				// Display no icon, not connected to PC
}PhsPcBrowsingType;

/**
 * This is Application List that need to share there Status with other Application.
 */
typedef enum
{
	PHS_NET_APP_MAX
}PhsNetAppList;

typedef enum
{
	PHS_LCD_VERTICAL,
	PHS_LCD_HORIZONTAL
}PhsLcdType;

/**
	Define a type of handsfree status
*/
typedef enum
{
    HFK_INUSE,		/**< In use */
    HFK_INHOOK,		/**< Hook On/Off */
    EARPHONE_INUSE	/**< In use */
} HfkStatusType;

/*
 * ECOM Interface
 */
#include "DevPhoneStatusECOM.h"


#ifdef __cplusplus
}
#endif  /* __cplusplus */

#endif // _DEV_PHONE_STATUS_H_
