/*
 * Mocha
 * Copyright (c) 2002 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */

#ifndef _DLL_TYPES_H_
#define _DLL_TYPES_H_

#include "SysBase.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef    enum {
	DLL_LOCATION_INVALID = -1,
	DLL_LOCATION_FILE,
	DLL_LOCATION_FLASH,
	DLL_LOCATION_RAM
} DllRoc;

typedef EcomDispatch (*DLL_BASE_INIT_FN_TYPE)(EcomFactory*, DID);

typedef struct
{
	EcomDispatch pDispatch;
	ADDR sb;
} DllDispatchStub;

typedef struct
{
	ADDR start;
	ADDR size;
} Seg;

typedef struct
{
	BOOL					valid;
	BOOL					bBuiltIn;	// True if the DLL is built in Mocha
	Seg						elf;		// The start address of ELF image loaded in memory
										// Used on unloading
	Seg						rwZI;
	EcomDispatch			pDispatch;
} DllLoadedInfo;

typedef enum
{
	DLL_STATE_UNKNOWN,
	DLL_STATE_RUNNING,
	DLL_STATE_ZOMBIE
} DLL_STATE;

// Especially, this is used in LDT and DDT.
typedef struct 
{
	int listSize;
	DID* pList;
	int validEntries;
} DidEList;		// Capital E means "Enhanced"


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _DLL_TYPES_H_ */