/*
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */

/*:Associate with "File Manager" */

#ifndef	_FILE_MGR_H_
#define _FILE_MGR_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "Shp.h"
#include "OsAL.h"
#include "MemMgr.h"
#include "TimeMgr.h"

/*
 * Access Modes
 */
#define FM_CREATE				0x0001		
#define FM_READ					0x0002
#define FM_WRITE				0x0004
#define FM_TRUNCATE				0x0008
#define FM_APPEND				0x0010
#define FM_NOSHARE				0x0020
#define FM_DIRECTIO				0x0040
#define FM_CONCRETE_WRITE		0x0080
#define FM_NOUPDATE_TIME 		0x0100


/**
 *  	  DirectoryEntry Type
 */
typedef enum
{
	FM_INVALID_TYPE =0x0000,
	FM_FILE_TYPE = 0x0001,
	FM_DIR_TYPE = 0x0002,
	FM_UNKNOWN_TYPE = 0x0003,
	FM_TYPE_MAX = 0xFF000000
} FmEntryType;

/**
 * file system type
 */
typedef enum
{
	FM_FS_MAX =10
} FmFsType;

typedef enum
{
	FM_PARTITION_MAX
} FmPartitionType;

typedef struct
{
	ULONG		attribute;			/** file attribute like directory or file, hidden, readonly, system, ...	*/
} FmFileAttribute;

typedef struct
{
	FmEntryType	type;					/** File or Directory*/
} FmDirEntry;

typedef struct
{
	FmFsType	fsType;
	UINT64		availableSize;
	UINT64		allocatedSize;
} FmVolumeStat;


typedef struct
{
	UINT64			availableSize;
	UINT64			allocatedSize;
	UINT64			reservedSize;
	UINT64			diskSize;
} FmQuotaStat;

typedef struct
{
	FmEntryType entryType;
} FmOpenEntry;

typedef HObj		HFile;
typedef HObj		HDir;
typedef HObj		HOpenQuery;

/*
 * ECOM Interface
 */
#include "FmECOM.h"


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	// _FILE_MGR_H_
