/*
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */

/*:Associate with "Memory Manager" */

#ifndef	_MEM_ECOM_H_
#define _MEM_ECOM_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * ECOM Interface
 */
ECOM_INTERFACE(EMemMgr)
{
	DECLARE_EBASE()


	void*		(*VirtualAlloc)	(size_t size);
	BOOL		(*VirtualFree)	(void *pMem);
	UINT32		(*VirtualGetAvailableSize)	(void);


	void*		(*AllocTraceEx)(int iHeap, size_t size, char* szFileName, int nLine);
	void		(*FreeTraceEx)(int iHeap, void* pMem, char* szFileName, int nLine);
	void*		(*CallocTraceEx)(int iHeap, UINT elemCount, UINT elemSize, char* szFileName, int nLine);
	void*		(*ReAllocTraceEx)(int iHeap, void* pMem, size_t size, char* szFileName, int nLine);
	MemStat*	(*GetStatEx)(int iHeap);
};

// Native/DLL Call
#if (defined(_SHP_SIMUL) && defined(_SHP_CALL_DLL_MEMMGR)) || (defined(_SHP_DLL) && ! defined(_SHP_DLL_MEMMGR) && ! defined(_SHP_CALL_DLL_MEMMGR))

#	define MemVirtualAlloc							(__MemGetVtbl()->VirtualAlloc)
#	define MemVirtualFree							(__MemGetVtbl()->VirtualFree)
#	define MemVirtualGetAvailableSize				(__MemGetVtbl()->VirtualGetAvailableSize)

#	define MemAlloc(size)							(__MemGetVtbl()->AllocTraceEx)(HEAP_APP, size, __FILE__, __LINE__)
#	define MemFree(pMem)							((__MemGetVtbl()->FreeTraceEx)(HEAP_APP, pMem, __FILE__, __LINE__), pMem = NULL)
#	define MemCalloc(elemCount, elemSize)			(__MemGetVtbl()->CallocTraceEx)(HEAP_APP, elemCount, elemSize, __FILE__, __LINE__)
#	define MemReAlloc(pMem, size)					(__MemGetVtbl()->ReAllocTraceEx)(HEAP_APP, pMem, size, __FILE__, __LINE__)
#	define MemGetStat() 							(__MemGetVtbl()->GetStatEx(HEAP_APP))
#endif

/*
 * ECOM Type
 */
typedef struct
{
	DECLARE_ECOM_VTBL(EMemMgr)
} TMemMgr;

extern TMemMgr	memMgr;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	// _MEM_ECOM_H_
