/*
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */

/*:Associate with "System Manager" */

#ifndef _SYS_ASSERT_H_
#define _SYS_ASSERT_H_

#include "SysDebug.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define _SysSuicide(type, reason, expr)\
	{\
		_SysAssertReport(type, reason, expr, __FILE__, __LINE__);\
	}

#	define SysAssert(expr)
#	define SysAssertf(expr, format, X)


	#	define SysRequire(expr)																\
	if (!(expr)) {																			\
		SysDebug((MID_EXCEPTION, "INVALID_PARAM (%d lines in %s)\n", __FILE__, __LINE__));	\
		SysSetLastError(SYSERR_INVALID_PARAMETER);											\
		return;																				\
	} else {;}
	#	define SysRequireEx(expr, retValue)													\
	if (!(expr)) {																			\
		SysDebug((MID_EXCEPTION, "INVALID_PARAM (%d lines in %s)\n", __FILE__, __LINE__));	\
		SysSetLastError(SYSERR_INVALID_PARAMETER);											\
		return retValue;																	\
	} else {;}
	#	define SysRequiref(expr, X)																\
	if (!(expr)) {																			\
		SysDebug((MID_EXCEPTION, "INVALID_PARAM (%d lines in %s)\n", __FILE__, __LINE__));	\
		SysSetLastError(SYSERR_INVALID_PARAMETER);											\
		return;																				\
	} else {;}
	#	define SysRequireExf(expr, retValue, X)													\
	if (!(expr)) {																			\
		SysDebug((MID_EXCEPTION, "INVALID_PARAM (%d lines in %s)\n", __FILE__, __LINE__));	\
		SysSetLastError(SYSERR_INVALID_PARAMETER);											\
		return retValue;																	\
	} else {;}


#	define SysEnsure(expr)

#	define SysCheck(expr)				if (!(expr)) {;} else {;}
#	define SysCheckf(expr, format, X)	if (!(expr)) {;} else {;}

/*
 * NEVER_GET_HERE: Always enabled.
 */
#define SysNeverGetHere()\
	_SysSuicide(ASSERTION_NEVER_GET_HERE, "ASSERTION_NEVER_GET_HERE", "NEVER_GET_HERE");

// The below "{}" MUST exist. Otherwise it occurs a big problem such as the case of "if SysNeverGetHeref".
#define SysNeverGetHeref(X)\
	{ _SysSaveAssertMsg X;\
	_SysSuicide(ASSERTION_NEVER_GET_HERE, "ASSERTION_NEVER_GET_HERE", "NEVER_GET_HERE"); }

#ifdef __cplusplus
}
#endif  /* __cplusplus */

#endif // _SYS_ASSERT_H_
