/*
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */
/**
 * This file includes the all static component/module/class IDs of SHP.
 *
 * @author	Joon Sung Hong (jshong@swc.sec.samsung.co.kr)
 */

#ifndef _SYS_COMP_IDS_H_
#define _SYS_COMP_IDS_H_

#define MID_BASE_VAL	 0x0	// to save bit changed from 0x10000 by jmcho
/*
 * Module IDs
 */
typedef enum
{
	/*
	 * Core
	 */
	MID_SYSBASE			= MID_BASE_VAL /* ALL_CASES */+ SET_IDENT(0), /* MUST be incremented from zero and without skipping */
	MID_OSAL			= MID_BASE_VAL + SET_IDENT(1),
	MID_MEMMGR			= MID_BASE_VAL + SET_IDENT(2),		/* Memory Manager */
	MID_FILEMGR			= MID_BASE_VAL + SET_IDENT(3),		/* File Manager */
	MID_DBMGR			= MID_BASE_VAL + SET_IDENT(4),		/* Database Manager */
	MID_DB2MGR			= MID_BASE_VAL + SET_IDENT(5),		/* DB2 Manager */
	MID_NVMGR			= MID_BASE_VAL + SET_IDENT(6),		/* Non-volatile Memory Manager */
	MID_REGMGR			= MID_BASE_VAL + SET_IDENT(7),		/* Registry Manager */
	MID_TIMEMGR			= MID_BASE_VAL + SET_IDENT(8),		/* Time Manager */
	MID_EVENTMGR		= MID_BASE_VAL + SET_IDENT(9),		/* Event Manager */
	MID_BOOTMGR			= MID_BASE_VAL + SET_IDENT(10),		/* Boot Manager */
	MID_DIAGMGR			= MID_BASE_VAL + SET_IDENT(11),		/* Diagnostic Manager */
	MID_DLLMGR			= MID_BASE_VAL + SET_IDENT(12),		/* DLL Manager */
	MID_QSMGR			= MID_BASE_VAL + SET_IDENT(13),		/* Quick Search Manager */
	MID_COMPMGR			= MID_BASE_VAL + SET_IDENT(14),		/* Compress Manager */
	MID_CORE_DUMMY1		= MID_BASE_VAL + SET_IDENT(15),		/* DUMMY1 */
	MID_CORE_DUMMY2		= MID_BASE_VAL + SET_IDENT(16),		/* DUMMY2 */

	// Devices
	MID_CLOCK			= MID_BASE_VAL + SET_IDENT(17),		/* Clock Device Driver */
	MID_EEPROM			= MID_BASE_VAL + SET_IDENT(18),		/* EEPROM Device Driver */
	MID_FIFO			= MID_BASE_VAL + SET_IDENT(19),		/* FIFO Device Driver */
	MID_FLASHMEM		= MID_BASE_VAL + SET_IDENT(20),		/* Flash Memory Device Driver */
	MID_FLIP			= MID_BASE_VAL + SET_IDENT(21),		/* Flip Device Driver */
	MID_LED				= MID_BASE_VAL + SET_IDENT(22),		/* LED Device Driver */
	MID_PHONESTATUS		= MID_BASE_VAL + SET_IDENT(23),		/* PhoneStatus Device Driver */
	MID_POS				= MID_BASE_VAL + SET_IDENT(24),		/* Position Device Driver */
	MID_SIM				= MID_BASE_VAL + SET_IDENT(25),		/* SIM Device Driver */
	MID_VIBRATOR		= MID_BASE_VAL + SET_IDENT(26),		/* Vibrator Device Driver */
	MID_CAMERA			= MID_BASE_VAL + SET_IDENT(27),		/* Camera Device Driver */
	MID_MMC				= MID_BASE_VAL + SET_IDENT(28),
	MID_DEVMGR			= MID_BASE_VAL + SET_IDENT(29),		/* Device Manager */
	MID_LCD				= MID_BASE_VAL + SET_IDENT(30),		/* LCD Device Driver */
	MID_KEYPAD			= MID_BASE_VAL + SET_IDENT(31),		/* Keypad Device Driver */
	MID_UART			= MID_BASE_VAL + SET_IDENT(32),		/* UART Device Driver */
	MID_USB				= MID_BASE_VAL + SET_IDENT(33),		/* USB Device Driver */
	MID_BLUETOOTH		= MID_BASE_VAL + SET_IDENT(34),		/* Bluetooth Device Driver */
	MID_IRDA			= MID_BASE_VAL + SET_IDENT(35),		/* IrDA Device Driver */
	MID_DEVICE_DUMMY1	= MID_BASE_VAL + SET_IDENT(36),		/* DUMMY1 */
	MID_DEVICE_DUMMY2	= MID_BASE_VAL + SET_IDENT(37),		/* DUMMY2 */

	/*
	 * GWES
	 */
	// GWES Core
	MID_CRAYON			= MID_BASE_VAL + SET_IDENT(38),		/* Graphics/Font */
	MID_LANGPACK		= MID_BASE_VAL + SET_IDENT(39),		/* Language */
	MID_WINCORE			= MID_BASE_VAL + SET_IDENT(40),		/* Window Manager */
	MID_WINSET			= MID_BASE_VAL + SET_IDENT(41),		/* Window Set */
	MID_DISPAL			= MID_BASE_VAL + SET_IDENT(42),		/* GWESTestApp */
	MID_SCRMGR			= MID_BASE_VAL + SET_IDENT(43),		/* DUMMY2 */

	/*
	 * AVMS
	 */
	MID_AVMEDIA			= MID_BASE_VAL + SET_IDENT(75),		/* A/V Media */
	MID_H32X			= MID_BASE_VAL + SET_IDENT(76),		/* H.323, H.324M System Control */
	MID_IMGCODEC		= MID_BASE_VAL + SET_IDENT(77),		/* Image CODEC */
	// Devices
	MID_SOUND			= MID_BASE_VAL + SET_IDENT(78),		/* Sound Device Driver */
	// Multimedia
	MID_AGL				= MID_BASE_VAL + SET_IDENT(79),		/* Advertising Graphics Library */
	MID_VGE				= MID_BASE_VAL + SET_IDENT(80),		/* Vector Graphics */
	MID_M3D				= MID_BASE_VAL + SET_IDENT(81),		/* 3D Graphics */
	MID_AVMS_DUMMY1		= MID_BASE_VAL + SET_IDENT(83),		/* DUMMY1 */
	MID_AVMS_DUMMY2		= MID_BASE_VAL + SET_IDENT(84),		/* DUMMY2 */

	/*
	 * Application Framework
	 */
	MID_APPMGR			= MID_BASE_VAL + SET_IDENT(85),		/* Application Manager */
	MID_RSRCMGR			= MID_BASE_VAL + SET_IDENT(86),		/* Resource Manager */
	MID_LOCMGR			= MID_BASE_VAL + SET_IDENT(87),		/* Locale Manager */
	MID_APPKEYMGR		= MID_BASE_VAL + SET_IDENT(88),		/* App key Manager */
	MID_APPSNDMGR		= MID_BASE_VAL + SET_IDENT(89),		/* App key Manager */

	/*
	 * Application Service
	 */
	MID_BRSVC			= MID_BASE_VAL + SET_IDENT(102),	/* Brower Service such as bookmark */

	/*
	 * Network Applications
	 */
	MID_BROWSER			= MID_BASE_VAL + SET_IDENT(136),		/* WAP 2.0 Browser */
	/*
	 * Misc.
	 */
	MID_EXCEPTION		= MID_BASE_VAL + SET_IDENT(183),		/* Exception */
	MID_SYSTEM			= MID_BASE_VAL + SET_IDENT(184),		/*System */
	MID_PERF			= MID_BASE_VAL + SET_IDENT(185),		/* Performance */

	/*
	*	Search
	*/
	MID_SEARCH			= MID_BASE_VAL + SET_IDENT(186),		/* Search*/


	MID_MISC_DUMMY1		= MID_BASE_VAL + SET_IDENT(187),		/* DUMMY1 */

	MID_USER1			= MID_BASE_VAL + SET_IDENT(208),		/* User-defined */
	MID_USER2			= MID_BASE_VAL + SET_IDENT(209),
	MID_USER3			= MID_BASE_VAL + SET_IDENT(210),
	MID_USER4			= MID_BASE_VAL + SET_IDENT(211),
	MID_USER5			= MID_BASE_VAL + SET_IDENT(212),

	/*
	 * Settings
	 */
	MID_SETTING			= MID_BASE_VAL + SET_IDENT(213),
	MID_SETTINGSVC		= MID_BASE_VAL + SET_IDENT(214),
	MID_SETTINGS_DUMMY1	= MID_BASE_VAL + SET_IDENT(215),
	MID_SETTINGS_DUMMY2	= MID_BASE_VAL + SET_IDENT(216),
	MID_SETTINGS_DUMMY3	= MID_BASE_VAL + SET_IDENT(217),

	MID_MAX 			= MID_BASE_VAL + SET_IDENT(221)
} SysModuleID;

/*
 * Class IDs
 */
#define ECOM_VERSION		0x01000000        // Most significant 8-bits are version
#define CID_BASE			(ECOM_VERSION)
#define CID_OEM				(ECOM_VERSION + 0x1000)
#define CID_OEM_APP			(ECOM_VERSION + 0x2000)
#define CID_RANGE			(0x00000FFF)

typedef enum
{
	/*
	 * Core
	 */
	// AnsiC
	CID_ANSIC = CID_BASE,
	// SysBase
	CID_SYSBASE,
	// OSAL
	CID_OSAL,
	// Core Services
	CID_MEMMGR,
	CID_FILEMGR,
	CID_DBMGR,
	CID_DB2MGR,
	CID_NVMGR,
	CID_REGMGR,
	CID_TIMEMGR,
	CID_EVENTMGR,
	CID_BOOTMGR,
	CID_DIAGMGR,
	CID_DLLMGR,
	CID_QSMGR,

	// Devices
	CID_CLOCK,
	CID_EEPROM,
	CID_FIFO,
	CID_FLASHMEM,
	CID_FLIP,
	CID_LED,
	CID_PHONESTATUS,
	CID_POS,
	CID_SIM,
	CID_VIBRATOR,
	CID_CAMERA,
	CID_DEVMGR,

	/*
	 * GWES
	 */
	CID_GWESCORE,
	CID_GWESWINSET,
	CID_LCD,
	CID_KEYPAD,

	/*
	 * AVMS
	 */
	CID_AVMEDIA,
	CID_H32X,
	CID_IMGCODEC,
	CID_SOUND,

	/*
	 * Application Framework
	 */
	CID_APPMGR,
	CID_RSRCMGR,
	CID_APPUISVCMGR,
	CID_LOCMGR,
        CID_APPKEYMGR,
	CID_APPSNDMGR,

	/*
	 * Template
	 */
	CID_ECOM_TMPL,
	CID_MIXED_TMPL,

	/*
	 * Misc.
	 */
	CID_WEBCONTROL,
	CID_LIBXML,
	CID_URLLOADER,

	CID_USER1,
	CID_USER2,
	CID_USER3,
	CID_USER4,
	CID_USER5,

	CID_MAX
} SysClassID;

#define DID_MOCHA_BUILT_IN		0x1
#define INVALID_DID				INVALID_HOBJ

typedef enum
{
	SYS_MODULE_STATUS_UNINITIALIZED,
	SYS_MODULE_STATUS_INITIALIZED,
	SYS_MODULE_STATUS_FORMATTING,
	SYS_MODULE_STATUS_TERMINATED,
	SYS_MODULE_STATUS_ACTIVATED,
	SYS_MODULE_STATUS_DEACTIVATED,
	SYS_MODULE_STATUS_STARTUPANI_STARTED,
	SYS_MODULE_STATUS_STARTUPANI_ENDED,
	SYS_MODULE_STATUS_MAX,
}SysModuleStatus;

/*
 * Virtual Table Accessors
 */
// Core
#define __AcGetVtbl()			SysGetVtbl(CID_ANSIC, AnsiC)
#define	__SysGetVtbl()			SysGetVtbl(CID_SYSBASE, SysBase)
#define __OsGetVtbl()			SysGetVtbl(CID_OSAL, OsAL)
#define __MemGetVtbl()			SysGetVtbl(CID_MEMMGR, MemMgr)
#define __FmGetVtbl()			SysGetVtbl(CID_FILEMGR, FileMgr)
#define __DbGetVtbl()			SysGetVtbl(CID_DBMGR, DbMgr)
#define __Db2GetVtbl()			SysGetVtbl(CID_DB2MGR, Db2Mgr)
#define __NvGetVtbl()			SysGetVtbl(CID_NVMGR, NvMgr)
#define __RegGetVtbl()			SysGetVtbl(CID_REGMGR, RegMgr)
#define __TmGetVtbl()			SysGetVtbl(CID_TIMEMGR, TimeMgr)
#define __EmGetVtbl()			SysGetVtbl(CID_EVENTMGR, EventMgr)
#define __BmGetVtbl()			SysGetVtbl(CID_BOOTMGR, BootMgr)
#define __DiagGetVtbl()			SysGetVtbl(CID_DIAGMGR, DiagMgr)
#define __DllGetVtbl()			SysGetVtbl(CID_DLLMGR, DllMgr)
#define __QsGetVtbl()			SysGetVtbl(CID_QSMGR, QsMgr)

#define __ClkGetVtbl()			SysGetVtbl(CID_CLOCK, DevClk)
#define __E2pGetVtbl()			SysGetVtbl(CID_EEPROM, DevEEPROM)
#define __FifoGetVtbl()			SysGetVtbl(CID_FIFO, DevFIFO)
#define __FlashGetVtbl()		SysGetVtbl(CID_FLASHMEM, DevFlash)
#define __FlipGetVtbl()			SysGetVtbl(CID_FLIP, DevFlip)
#define __LedGetVtbl()			SysGetVtbl(CID_LED, DevLED)
#define	__PhsGetVtbl()			SysGetVtbl(CID_PHONESTATUS, DevPhoneStatus)
#define __SimGetVtbl()			SysGetVtbl(CID_SIM, DevSIM)
#define __VibGetVtbl()			SysGetVtbl(CID_VIBRATOR, DevVibrator)
#define __CamGetVtbl()			SysGetVtbl(CID_CAMERA, DevCam)
#define __DmGetVtbl()			SysGetVtbl(CID_DEVMGR, DevMgr)

// GWES
#define __WmGetVtbl()			SysGetVtbl(CID_GWESCORE, GWESCore)
#define __WsGetVtbl()			SysGetVtbl(CID_GWESWINSET, GWESWinSet)
#define __LcdGetVtbl()			SysGetVtbl(CID_LCD, DevLCD)
#define __KeyGetVtbl()			SysGetVtbl(CID_KEYPAD, DevKey)

// Communication
#define __TapiGetVtbl()			SysGetVtbl(CID_TAPI, TAPI)
#define __ProtoGetVtbl()		SysGetVtbl(CID_PROTOMGR, ProtoMgr)
#define __ConnGetVtbl()			SysGetVtbl(CID_CONNMGR, ConnMgr)
#define __SocketGetVtbl()		SysGetVtbl(CID_SOCKET, Socket)
#define __HttpGetVtbl()			SysGetVtbl(CID_HTTP, HTTP)
#define __WapGetVtbl()			SysGetVtbl(CID_WAP, WAP)
#define __PushGetVtbl()			SysGetVtbl(CID_PUSH, PUSH)
#define __UartGetVtbl()			SysGetVtbl(CID_UART, DevUART)
#define __UsbGetVtbl()			SysGetVtbl(CID_USB, DevUSB)
#define __IrdaGetVtbl()			SysGetVtbl(CID_IRDA, DevIRDA)
#define __HexGetVtbl()			SysGetVtbl(CID_HEXMGR, HexMgr)

// AVMS
#define __AvGetVtbl()			SysGetVtbl(CID_AVMEDIA, AvMedia)
#define __H32xGetVtbl()			SysGetVtbl(CID_H32X, H32X)
#define __ImgGetVtbl()			SysGetVtbl(CID_IMGCODEC, ImgCODEC)
#define __SndGetVtbl()			SysGetVtbl(CID_SOUND, DevSound)

// Application Framework
#define __AppGetVtbl()			SysGetVtbl(CID_APPMGR, AppMgr)
#define __RsrcGetVtbl()			SysGetVtbl(CID_RSRCMGR, RsrcMgr)
#define __LocGetVtbl()			SysGetVtbl(CID_LOCMGR, LocMgr)
#define __AppUiSvcGetVtbl()		SysGetVtbl(CID_APPUISVCMGR, AppUiSvc)
#define __AppKeyGetVtbl()		SysGetVtbl(CID_APPKEYMGR, AppKeyMgr)
#define __AppSndGetVtbl()		SysGetVtbl(CID_APPSNDMGR, AppSndMgr)

#define __WebControlGetVtbl()			SysGetVtbl(CID_WEBCONTROL, WebControl)
#define __LibxmlGetVtbl()			SysGetVtbl(CID_LIBXML, Libxml)
#define __UrlLoaderGetVtbl()				SysGetVtbl(CID_URLLOADER, UrlLoader)

#endif // _SYS_COMP_IDS_H_
