/*
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */

#ifndef	_SYS_DLL_IDS_H_
#define _SYS_DLL_IDS_H_

#include "ShpTypes.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define GET_DID_COM(X)			(GETMSK(X, 12, MASKL12))
#define SET_DID_COM(X)			((UINT32)((X & MASKL12) << 12))

#define GET_DID_PROG(X)			(GETMSK(X, 0, MASKL12))
#define SET_DID_PROG(X)			((UINT32)(X & MASKL12))


#define DID_COM_ECOM			0x0			// Special DID_COM for ECOM DLLs
#define DID_COM_MOCHA			0x111
#define DID_COM_TMPL			0x222
#define DID_COM_OUTSOURCE		0x333
#define DID_COM_TEST			0x444


/* 
 * Mocha Built-in Applications Set
 */
typedef enum
{
	DID_WEBKIT			= SET_DID_COM(DID_COM_MOCHA) + SET_DID_PROG(0x104),		/* Webkit Service */

} SysMochaAppDIDs;



#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	// _SYS_DLL_IDS_H_
