/*
 * Mocha
 * Copyright (c) 2000-2003 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */

/*:Associate with "Time Manager" */

#ifndef	_TIME_MGR_H_
#define _TIME_MGR_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "Shp.h"
#include "DevClk.h"
#include "EventMgr.h"

typedef struct
{
	int		year;
	int		month;
	int		day;
} TmDate;

typedef struct
{
	int		hour;
	int		minute;
	int		second;
}TmTime;

typedef struct
{
	int		year;
	int		month;
	int		day;
	int		hour;
	int		minute;
	int		second;
} TmDateTime;

typedef struct
{
	ULONG	second;
	ULONG	millisecond;
} TmMilliSec;

#define TM_TZ_NAME_LEN_MAX		16


typedef struct
{
	char	szName[TM_TZ_NAME_LEN_MAX];
	int		offsetMinute;			

	BOOL	bDaylightSavings;		
	char	szDsName[TM_TZ_NAME_LEN_MAX];
	int		dsStartMonth;				
	int		dsStartWeek;				
	int		dsStartDayOfWeek;			
	int		dsStartHour;				
	int		dsEndMonth;					
	int		dsEndWeek;					
	int		dsEndDayOfWeek;		
	int		dsEndHour;			
	int		dsOffsetMinute;		
} TmTimeZone;

#define TmAlarmCallback		WmAlarmCallback

/*
 * ECOM Interface
 */
#include "TimeECOM.h"



#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	// _TIME_MGR_H_
