/*
 * SHP (Samsung Handset Platform)
 * Copyright (c) 2001, 2002 ITC, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */
 /**
 * @file		ProtoPDG.h
 * @brief		This file defines Protocol Manager for PDG (Packet Data Gateway).
 * @version	1.0
 */

#ifndef _PROTO_PDG_H_
#define _PROTO_PDG_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "Shp.h"

/* Default UDP socket for UE-PDG tunneling establishment */
#define PROTO_PDG_DEFAULT_PORT				500


/* DHCP information on WLAN */
typedef struct
{
	IPV4Addr				pdgAddr;		/**< PDG address from PDG discovery */
	Port					port       ;            /**< PDG port number to connect */
} ProtoPdgInfo;

/* PDG main event from NDS/IP */
typedef enum
{
	PROTO_PDG_EVENT_TUNNEL_UP		= 1,
	PROTO_PDG_EVENT_TUNNEL_DOWN	= 2
} ProtoPdgEvent;


BOOL         ProtoStartPDG(HProtocol hProtocol, ProtoPdgInfo* pPdgInfo);
BOOL         ProtoStopPDG(HProtocol hProtocol);
BOOL         ProtoGetPdgInfo(ProtoIpcfgInfo* pPdgInfo);

#ifdef __cplusplus
}
#endif  /* __cplusplus */

#endif // _PROTO_PDG_H_

