/**
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */

/**
 *  This file defines browser string ID of SHP
 * 
 * @file       BrShpRsrcBitmap.h
 * @author     Hosung You (hosung.you@samsung.com)
 */
/**
 * @addtogroup BR_PLATFORM
 * @{
 */

 
#ifndef _BR_SHP_RSRC_BITMAP_H_
#define _BR_SHP_RSRC_BITMAP_H_

#include "RsrcBitmap.h"
/* Added by amitg@samsung.com 
   to get the definition of 
   NTOUCH Flag 
 */
#include "BrConfig.h"
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
	


BEGIN_RSRC_BITMAP_IDS()
IDB_BOOKMARK_ICON_NORMAL,
IDB_BOOKMARK_ICON_EMBEDED,
IDB_BOOKMARK_FOLDER,

// Added by nohsk. 2008.04.16
#if defined ( _BROWSER_NTOUCH_UI )
IDB_01_TITLE_ARROW_LEFT,
IDB_01_TITLE_ARROW_LEFT_FOCUS,
IDB_01_TITLE_ARROW_LEFT_DIM,
IDB_01_TITLE_ARROW_RIGHT,
IDB_01_TITLE_ARROW_RIGHT_FOCUS,
IDB_01_TITLE_ARROW_RIGHT_DIM,
IDB_15_BACKTOWAP,
IDB_15_BACKTOWAP_PRESS,
IDB_15_BROWSER_TAP_01_FOCUS,
IDB_15_BROWSER_TAP_01_UNFOCUS,
IDB_15_BROWSER_TAP_02_FOCUS,
IDB_15_BROWSER_TAP_02_UNFOCUS,
IDB_15_BROWSER_TOOLBAR1,			// Q-Bowl(F700) 
IDB_15_BROWSER_TOOLBAR1_F,
IDB_15_BROWSER_TOOLBAR1_H_F,
IDB_15_BROWSER_TOOLBAR1_H,
IDB_15_BROWSER_TOOLBAR2,
IDB_15_BROWSER_TOOLBAR2_F,
IDB_15_BROWSER_TOOLBAR2_H_F,
IDB_15_BROWSER_TOOLBAR2_H,
IDB_15_BROWSER_TOOLBAR3,
IDB_15_BROWSER_TOOLBAR3_F,
IDB_15_BROWSER_TOOLBAR3_H_F,
IDB_15_BROWSER_TOOLBAR3_H,
IDB_15_BROWSER_TOOLBAR4,
IDB_15_BROWSER_TOOLBAR4_F,
IDB_15_BROWSER_TOOLBAR4_H_F,
IDB_15_BROWSER_TOOLBAR4_H,
IDB_15_BROWSER_TOOLBAR5,
IDB_15_BROWSER_TOOLBAR5_F,
IDB_15_BROWSER_TOOLBAR5_H_F,
IDB_15_BROWSER_TOOLBAR5_H,
IDB_15_BROWSER_ZOOM_IN,
IDB_15_BROWSER_ZOOM_IN_PRESS,
IDB_15_BROWSER_ZOOM_OUT,
IDB_15_BROWSER_ZOOM_OUT_PRESS,
IDB_15_TILTE_BG_01,
IDB_15_TILTE_BG_02,
IDB_15_TITLE_HOME_BUTTON,
IDB_15_TITLE_HOME_BUTTON_FOCUS,
IDB_15_TITLE_RELOAD_BUTTON,
IDB_15_TITLE_RELOAD_BUTTON_FOCUS,
IDB_15_TITLE_STOP_BUTTON,
IDB_15_TITLE_STOP_BUTTON_FOCUS,
IDB_15_TITLE_SEARCH_BUTTON,
IDB_15_TITLE_SEARCH_BUTTON_FOCUS,
IDB_15_TITLE_SEARCH_BUTTON_DIM,
IDB_15_BROWSER_WIDGET,
IDB_15_BROWSER_WIDGET_FOCUS,
IDB_15_BROWSER_WIDGET_H,
IDB_15_BROWSER_WIDGET_H_F,
#if defined ( _BROWSER_CONCEPT_AMERICA )
IDB_15_BROWSER_WIDGET_FULL,
IDB_15_BROWSER_WIDGET_FULL_F,
#endif
IDB_08_SETTINGS_EDIT_UNFOCUS,
IDB_08_SETTINGS_EDIT_FOCUS,
IDB_BROWSER_ADVANCED_N,	
IDB_BROWSER_ADVANCED_ON,
IDB_BROWSER_BOOKMARK_N,
IDB_BROWSER_BOOKMARK_ON,
IDB_BROWSER_SETTINGS_N,
IDB_BROWSER_SETTINGS_ON,
IDB_BROWSER_ENTER_URL_N,
IDB_BROWSER_ENTER_URL_ON,
IDB_BROWSER_HISTORY_N,
IDB_BROWSER_HISTORY_ON,
IDB_BROWSER_HOME_N,
IDB_BROWSER_HOME_ON,
IDB_BROWSER_SAVED_PAGES_N,
IDB_BROWSER_SAVED_PAGES_ON,

// 3rd Menu Icon: Added by nohsk. 2008.02.05
IDB_BROWSER_6_1_CLEAR_CACHE,
IDB_BROWSER_6_1_CLEAR_CACHE_ON,
IDB_BROWSER_6_2_EMPTY_COOKIES,
IDB_BROWSER_6_2_EMPTY_COOKIES_ON,
IDB_BROWSER_6_3_COOKIE_OPTIONS,
IDB_BROWSER_6_3_COOKIE_OPTIONS_ON,
IDB_BROWSER_6_4_DELETE_HISTORY,
IDB_BROWSER_6_4_DELETE_HISTORY_ON,
IDB_BROWSER_6_5_PREFERENCES,
IDB_BROWSER_6_5_PREFERENCES_ON,
IDB_BROWSER_6_6_PROFILES,
IDB_BROWSER_6_6_PROFILES_ON,
IDB_BROWSER_6_7_ABOUT_BROWSER,
IDB_BROWSER_6_7_ABOUT_BROWSER_ON,
IDB_BROWSER_6_8_PAGE_DETAILS,
IDB_BROWSER_6_8_PAGE_DETAILS_ON,
IDB_BROWSER_6_9_CERTIFICATES,
IDB_BROWSER_6_9_CERTIFICATES_ON,
#endif

// Media Mall : Added by nohsk. 2008.06.13
#if defined ( _BR_OPERATOR_CINGULAR )
IDB_MEDIA_MALL_TONES,
IDB_MEDIA_MALL_TONES_F,
IDB_MEDIA_MALL_GAMES,
IDB_MEDIA_MALL_GAMES_F,
IDB_MEDIA_MALL_GRAPICS,
IDB_MEDIA_MALL_GRAPICS_F,
IDB_MEDIA_MALL_MULTIMEDIA,
IDB_MEDIA_MALL_MULTIMEDIA_F,
IDB_MEDIA_MALL_APPLICATIONS,
IDB_MEDIA_MALL_APPLICATIONS_F,
IDB_MEDIA_MALL_VIDEO,
IDB_MEDIA_MALL_VIDEO_F,
IDB_MEDIA_MALL_MEDIA_NET_HOME,
IDB_MEDIA_MALL_MEDIA_NET_HOME_F,
#endif

IDB_MTV_ILDE_BG,
IDB_MTV_CONNECTING,
IDB_MTV_CONNECTED,
IDB_MTV_BUFFERING_01,
IDB_MTV_BUFFERING_02,
IDB_MTV_BUFFERING_03,
IDB_MTV_BUFFERING_04,
IDB_MTV_BUFFERING_05,
IDB_MTV_BUFFERING_06,
IDB_MTV_BUFFERING_07,
IDB_MTV_BUFFERING_08,
IDB_MTV_BUFFERING_09,
IDB_MTV_BUFFERING_10,
IDB_MTV_BUFFERING_11,
IDB_MTV_BUFFERING_12,
IDB_MTV_BUFFERING_13,
IDB_MTV_BUFFERING_14,
IDB_MTV_BUFFERING_15,
IDB_MTV_BUFFERING_16,
IDB_MTV_BUFFERING_17,
IDB_MTV_BUFFERING_18,
IDB_MTV_BUFFERING_19,
IDB_MTV_BUFFERING_20,

END_RSRC_BITMAP_IDS()




// Cancel
BEGIN_RSRC_BITMAP_IDS()
IDB_13_CD_CANCEL_01,
IDB_13_CD_CANCEL_02,
IDB_13_CD_CANCEL_03,

#if defined ( _BROWSER_NTOUCH_UI )
IDB_13_CD_CANCEL_04,
IDB_13_CD_CANCEL_05,
#endif

END_RSRC_BITMAP_IDS()


// Check
BEGIN_RSRC_BITMAP_IDS()
IDB_13_CD_CHECKING_01,
IDB_13_CD_CHECKING_02,
IDB_13_CD_CHECKING_03,
IDB_13_CD_CHECKING_04,

#if defined ( _BROWSER_NTOUCH_UI )
IDB_13_CD_CHECKING_05,
#endif

END_RSRC_BITMAP_IDS()


// Download
BEGIN_RSRC_BITMAP_IDS()
IDB_13_CD_DOWNLOAD_01,
IDB_13_CD_DOWNLOAD_02,
IDB_13_CD_DOWNLOAD_03,

#if defined ( _BROWSER_NTOUCH_UI )
IDB_13_CD_DOWNLOAD_04,
IDB_13_CD_DOWNLOAD_05,
#endif

END_RSRC_BITMAP_IDS()


// Etc
BEGIN_RSRC_BITMAP_IDS()
IDB_9MX_DETAIL_POINT,
END_RSRC_BITMAP_IDS()


// Notify
BEGIN_RSRC_BITMAP_IDS()
IDB_IDB_13_CD_NOTIFY_01,
IDB_IDB_13_CD_NOTIFY_02,
IDB_IDB_13_CD_NOTIFY_03,

#if defined ( _BROWSER_NTOUCH_UI )
IDB_IDB_13_CD_NOTIFY_04,
IDB_IDB_13_CD_NOTIFY_05,
#endif

END_RSRC_BITMAP_IDS()


// Progress1
BEGIN_RSRC_BITMAP_IDS()
IDB_PROGRESS_A,
IDB_PROGRESS_B,
IDB_PROGRESS_C,
IDB_PROGRESS_D,
IDB_PROGRESS_E,
IDB_PROGRESS_F,
IDB_PROGRESS_G,
IDB_PROGRESS_H,
IDB_PROGRESS_I,
IDB_PROGRESS_J,
IDB_PROGRESS_K,
END_RSRC_BITMAP_IDS()


// Progress2
BEGIN_RSRC_BITMAP_IDS()
IDB_PROGRESS_F1,
IDB_PROGRESS_F2,
END_RSRC_BITMAP_IDS()


// Added by smart.yj.kim 2007-03-30
// Save
BEGIN_RSRC_BITMAP_IDS()
IDB_13_CD_INSTALL_01,
IDB_13_CD_INSTALL_02,
IDB_13_CD_INSTALL_03,
IDB_13_CD_INSTALL_04,
IDB_13_CD_INSTALL_05,
#if defined (_BROWSER_MAINLCD_176X220)	//QCIF 176 X 220
IDB_13_CD_INSTALL_06,
IDB_13_CD_INSTALL_07,
#endif
END_RSRC_BITMAP_IDS()

// Added by yoonjeong.	2006.06.21
//#ifdef _BROWSER_BLACK_UI
BEGIN_RSRC_BITMAP_IDS()
IDB_13_BG_01_ALL,
END_RSRC_BITMAP_IDS()
//#endif

#ifdef _BROWSER_CONTINUE_DOWNLOADING
BEGIN_RSRC_BITMAP_IDS()
IDB_CD_SUB_PROGRESS_BG,
IDB_CD_SUB_PROGRESS_BAR,
END_RSRC_BITMAP_IDS()
#endif


#if defined ( _BROWSER_GWES_FLASH )

#	if defined ( _BR_OPERATOR_CINGULAR )
BEGIN_RSRC_BITMAP_IDS()
IDB_2ND_BROWSER_SETTING,
IDB_2ND_CINGULAR_VIDEO,
IDB_2ND_ENTER_URL,
IDB_2ND_MEDIA_NET_HOME,
IDB_2ND_SHOP_APPLICATIONS,
IDB_2ND_SHOP_GAMES,
IDB_2ND_SHOP_GRAPHICS,
IDB_2ND_SHOP_MULTIMEDIA,
IDB_2ND_SHOP_TONES,
END_RSRC_BITMAP_IDS()

#	elif defined ( _BR_OPERATOR_ROGERS )
BEGIN_RSRC_BITMAP_IDS()
IDB_INTERNET_HOME,
IDB_INTERNET_SAVED_PAGE,
IDB_INTERNET_HISTORY,
IDB_INTERNET_ADVANCED,
IDB_INTERNET_ENTER_URL,
IDB_INTERNET_BROWER_SETTING,
IDB_ROGERSMALL_EMAIL_CHAT,
IDB_ROGERSMALL_SEARCH,
IDB_ROGERSMALL_MUSIC_TONE,
IDB_ROGERSMALL_GAMES,
IDB_ROGERSMALL_GRAPHICS,
IDB_ROGERSMALL_CELEBRITY_VOICEMAIL,
IDB_ROGERSMALL_CALLER_RING_TRAX,
IDB_ROGERSMALL_NEWS_INFO,
IDB_ROGERSMALL_INTERNET,
END_RSRC_BITMAP_IDS()

#	else // for generic operator
BEGIN_RSRC_BITMAP_IDS()
IDB_INTERNET_HOME,
IDB_INTERNET_SAVED_PAGE,
IDB_INTERNET_HISTORY,
IDB_INTERNET_ADVANCED,
IDB_INTERNET_ENTER_URL,
IDB_INTERNET_BROWER_SETTING,
END_RSRC_BITMAP_IDS()
#	endif // _BR_OPERATOR_XXX

#endif // _BROWSER_GWES_FLASH

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _BR_SHP_RSRC_BITMAP_H_

/* @} */