/** 
* Samsung Handset Platform
* Copyright (c) 2006 Samsung Electronics, Inc.
* All rights reserved. 
*  
* This software is the confidential and proprietary information
* of Samsung Electronics, Inc. ("Confidential Information").  You
* shall not disclose such Confidential Information and shall use
* it only in accordance with the terms of the license agreement
* you entered into with Samsung Electronics.
*/
/*
*  This file defines the configuration params of the browser.
*  Any new configuration item needs to be defined here
*  @author Naveen Kumar SG(naveensg@samsung.com)
*  @author Sneha Bhat(sneha.bhat@samsung.com)
*/

#ifndef _SFBAL_CONFIG_H_SHP_
#define _SFBAL_CONFIG_H_SHP_

#include "Shp.h"
#include "FileMgr.h"
//#include "BrPlFile.h"
//#include "BrDispatch.h"


/****************************************************************************************************/
/*									Generic Configuration										*/
/****************************************************************************************************/ 

#define	 BAL_URL_LENGTH_MAX			512	
#define	 BAL_MIME_TYPE_LENGTH_MAX	100
#define 	BAL_PROTO_IPV4_STR_LEN_MAX PROTO_IPV4_STR_LEN_MAX

/****************************************************************************************************/
/*									File System Configuration										*/
/****************************************************************************************************/ 
#define	BAL_FILENAME_MAX_LEN	            FM_FILENAME_LEN_MAX  	
#define	BAL_FILEPATH_MAX_LEN	            FM_FILEPATH_LEN_MAX	
#define	BAL_ROOT_PATH		                   "/User/Bal"



/****************************************************************************************************/
/*									Cache related Configuration										*/
/****************************************************************************************************/ 

#define BAL_CACHE_ROOT_PATH	          "/User/Bal/Cache"
#define BAL_CACHE_MAX_SIZE                 5*1024*1024	 /*3MB*/


/****************************************************************************************************/
/*									Media Path Configuration									*/
/****************************************************************************************************/ 

#define BAL_MEDIA_VIDEO_DEFAULT_PATH	FM_PATH_MEDIA_VIDEO
#define BAL_MEDIA_VIDEO_PATH 		FM_PATH_MEDIA_VIDEO"/Movie/"
#define BAL_SLASH_CHAR			'/'
#define BAL_MEDIA_ROOT_PATH	"/Media"
#define BAL_MEDIA_SOUND_PATH	FM_PATH_MEDIA_SND


/****************************************************************************************************/
/*									Network Configuration										*/
/****************************************************************************************************/ 

#define BAL_DNS_MAX_RESOLVE_ADDRS	3
#define BAL_MAX_HTTP_REQUESTS			5

/****************************************************************************************************/
/*									         Timer	macro definitions								*/
/****************************************************************************************************/ 

#define SFBalTimer_macro			                      HTimer


#define	SFBalCreateTimer_macro(name)									 WmCreateTimer(name)
#define   SFBalDeleteTimer_macro(hTimer)								        WmDeleteTimer(hTimer)
#define   SFBalStartTimer_macro(hTimer, timeout, timerCallback, param)         WmStartTimer(hTimer, timeout, timerCallback, param)
#define   SFBalPauseTimer_macro(hTimer)								        WmCancelTimer(hTimer)
#define   SFBalIsTimerActive_macro(hTimer)								 WmIsTimerActive(hTimer)
#define   SFBalDateTimeToSeconds_macro									 TmDateTimeToSeconds
#define   SFBalSecondsToDateTime_macro									 TmSecondsToDateTime
#define	SFBalDateToDays_macro										        TmDateToDays
#define	SFBalTimerCallback_macro										 WmTimerCallBack

/****************************************************************************************************/
/*									       Debug							*/
/***************************************************************************************************/ 
#define SFBalRequireEx_macro			SysRequireEx


/****************************************************************************************************/
/*									       Misc							*/
/***************************************************************************************************/ 

#define BAL_EXCEPTION_MACRO 	MID_EXCEPTION


#define BalFile_macro	HFile			


#endif
