/** 
* Samsung Handset Platform
* Copyright (c) 2006 Samsung Electronics, Inc.
* All rights reserved. 
*  
* This software is the confidential and proprietary information
* of Samsung Electronics, Inc. ("Confidential Information").  You
* shall not disclose such Confidential Information and shall use
* it only in accordance with the terms of the license agreement
* you entered into with Samsung Electronics.
*/
/*
*  This file defines all the errors associated with the Browser modules.
*  @author Naveen Kumar SG(naveensg@samsung.com)
*  @author Sneha Bhat(sneha.bhat@samsung.com)
*/

#ifndef _SFBAL_ERROR_SHP_H_
#define _SFBAL_ERROR_SHP_H_


typedef enum 
{
	SFB_STATUS_SUCCESS = 0,	

	SFB_NETWORKERR_NO_SERVICE ,
	SFB_NETWORKERR_WRONG_APN ,
	SFB_NETWORKERR_AUTH_FAIL ,
	SFB_NETWORKERR_INVALID_PARAM ,
	SFB_NETWORKERR_TIMEOUT,
	SFB_NETWORKERR_LOCAL,
	SFB_NETWORKERR_FDN,
	SFB_NETWORKERR_UNKNOWN,

	SFB_MEMORY_FAIL,
	SFB_INVALID_TRNS_ID,
	SFB_STATUS_OUT_OF_MEMORY,
       SFB_STATUS_INVALID_PARAM,

	    /* Framework errors */
	SFB_STATUS_FW_TIMER_CREAT_FAILED,
	SFB_STATUS_FW_TIMER_START_FAILED,
	SFB_STATUS_FW_TIMER_CANCEL_FAILED,

	    /* Generic errors */
    	SFB_STATUS_ERROR,
   // gnana Auth error
   SFB_AUTH_INVALID_FORMAT,

	/* Protocol Errors */
    // gnana 
	SFB_PROTO_ERROR_NO_SERVICE ,
	SFB_PROTO_ERROR_WRONG_APN ,
	SFB_PROTO_ERROR_AUTH_FAIL ,
	SFB_PROTO_ERROR_INVALID_PARAM ,
	SFB_PROTO_ERROR_TIMEOUT,
	SFB_PROTO_ERROR_FDN,
	SFB_PROTO_ERROR_NOT_SUPPORT_3GCSD,
	SFB_PROTO_ERROR_NETWORK_FAILURE,
	SFB_PROTO_ERROR_MAX_CONNECTIONS,
	SFB_PROTO_ERROR_ACTIVE_CONNECTIONS, //  // For handling case that other app is using PDP - Sumdra
	SFB_PROTO_ERROR_MODEM_IN_USE,
	SFB_PROTO_ERROR_MODEM_IN_USE_CANCEL,
	SFB_PROTO_ERROR_NOT_SUBSCRIBED,
	SFB_PROTO_ERROR_UNKNOWN,
	SFB_PROTO_NO_RESOURCE,
	//end gnana
   	SFB_STATUS_PROTO_NETWORK_SETTINGS_NOT_DONE,
   	SFB_STATUS_PROTO_NETWORK_UNCONNECTED,
    	SFB_STATUS_PROTO_NETWORK_BUSY,
    	SFB_STATUS_PROTO_ERROR_UNSPECIFIED,		
    	SFB_STATUS_PROTO_ERROR_PROXY,
    	SFB_STATUS_PROTO_ERROR_HTTP_TRID,
    	SFB_STATUS_PROTO_ERROR_WSP_TRID,
   	SFB_STATUS_PROTO_REQ_DOESNT_EXIST,
	SFB_STATUS_PROTO_REQUEST_Q_FULL,
    	SFB_STATUS_PROTO_WAIT_Q_FULL,
    	SFB_STATUS_PROTO_REQ_TABLE_FULL,
    	SFB_STATUS_PROTO_WAIT_Q_ERROR,
    	SFB_STATUS_PROTO_ERROR_WSP_WAP_CAPS,
    	SFB_STATUS_PROTO_ERROR_WSP_CONN_FAILED,
    	SFB_STATUS_PROTO_ERROR_WSP_CONN_WAIT,
    	SFB_STATUS_PROTO_ERROR_WSP_INVOKE_FAIL,
    
	/* Protocol Errors */

		SFB_HTTPERR_INVALID_PARAM,	
		SFB_HTTPERR_UNKNOWN,			
		SFB_HTTPERR_INVALID_PROXY,
		SFB_HTTPERR_OUT_OF_MEMORY,			
		SFB_HTTPERR_NO_RESPONSE,			
		SFB_HTTPERR_INIT,					
		SFB_HTTPERR_NETDOWN,					
		SFB_HTTPERR_TIMEOUT,				
		SFB_HTTPERR_HOST_UNREACH,
		SFB_HTTPERR_CONN_RESET,			
		SFB_HTTPERR_INTERNAL,				
		SFB_HTTPERR_CHUNKEDTR,				
		SFB_HTTPERR_USER,				
		SFB_HTTPERR_TOO_BIG,
		SFB_HTTPERR_NOT_SUPPORTED_SVC,
		SFB_HTTPERR_NO_CONTENT,		
		SFB_HTTPERR_WRITEFAIL,				
		SFB_HTTPERR_AUTHFAIL,
		SFB_HTTPERR_DNSFAIL,				
		SFB_HTTPERR_UAGENT_NOT_ALLOWED,

	SFB_WAPERR_SUSPENDED,
	SFB_WAPERR_CONNECT_FAILED,
	SFB_WAPERR_SESSION_DISCONNECTED,
	SFB_WAPERR_SECURITY_DISCONNECTED,
	SFB_WAPERR_TR_ABORT,
	SFB_WAPERR_TIMEOUT,
	SFB_WAPERR_OUT_OF_MEMORY,
	SFB_WAPERR_TOO_LARGE,
	SFB_WAPERR_UNKNOWN,
	SFB_WAPERR_LOCAL,

	SFB_ABORTCODE_P_UNKNOWN,
	SFB_ABORTCODE_P_PROTO_ERR,
	SFB_ABORTCODE_P_INVALID_TID,
	SFB_ABORTCODE_P_NOT_IMPLEMENTED_CL2,
	SFB_ABORTCODE_P_NOT_IMPLEMENTED_SAR,
	SFB_ABORTCODE_P_NOT_IMPLEMENTEDU_ACK,
	SFB_ABORTCODE_P_WTP_VERSIONONE,
	SFB_ABORTCODE_P_CAPTEMP_EXCEED,
	SFB_ABORTCODE_P_NO_RESPONSE,
	SFB_ABORTCODE_P_MESSAGE_TOO_LARGE,
	SFB_ABORTCODE_U_PROTO_ERR,
	SFB_ABORTCODE_U_DISCONNECT,
	SFB_ABORTCODE_U_SUSPEND,
	SFB_ABORTCODE_U_RESUME,
	SFB_ABORTCODE_U_CONGESTION,
	SFB_ABORTCODE_U_CONNECT_ERR,
	SFB_ABORTCODE_U_MRU_EXCEEDED,
	SFB_ABORTCODE_U_PEER_REQ,
	SFB_ABORTCODE_U_NET_ERR,
	SFB_ABORTCODE_U_USER_REQ,


	SFB_ERROR_SETTINGS_NOT_DONE,
	SFB_ERROR_REQUEST_Q_FULL,
	SFB_ERROR_UNKNOWN_SEARCH_ID,
	SFB_ERROR_BLANK_SIM_MSISDN,
	SFB_ERROR_SERVER_URL_NOT_AVAILABLE,
	SFB_ERROR_INVALID_REQUEST,
	SFB_ERROR_PS_CONNECTION_USED_BY_OTHERAPP,
	SFB_ERROR_PS_CONNECTION_FULL,
	SFB_ERROR_PS_CONNECTION_FAILED,
	SFB_BROWSER_ERROR_NOMEMORY,				/*Memory runs out while loading the content*/
	SFB_BROWSER_ERROR_NOMEMORY_IMAGE,		/*Memory cannot be allocated for an image while loading the Content*/
	SFB_BROWSER_ERROR_TOTAL_SIZEOVER,		/*Error to display for Too Large Page*/
	SFB_BROWSER_ERROR_BADURL,				/*Invalid URL similar to HTTP 404*/
	SFB_BROWSER_ERROR_BADMIMETYPE,			/*Invalid MIME Type*/
	SFB_BROWSER_ERROR_MIXEDSECURETYPE,		/*Security Fail such as http:// to https:// or https:// to http:// */
	SFB_BROWSER_ERROR_INPUTHISTORY_SIZEOVER,
	SFB_BROWSER_ERROR_INPUT_REQUIRED,
	SFB_BROWSER_ERROR_SAVED_FILE,
	SFB_BROWSER_ERROR_MP_WSP,
	SFB_BROWSER_ERROR_PROFILE_SETTING_ERROR,
	/* unzip errors */
	SFB_BROWSER_DATA_ERROR,
	SFB_BROWSER_FILE_ERROR,
	SFB_ERROR_MAX,



} SFBStatus ;

#endif

