/**
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */

#ifndef _SFBAL_GWES_TYPES_H_
#define _SFBAL_GWES_TYPES_H_

#include "GWES.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define SFBalRect			WmRect
#define SFBalPoint			WmPoint

#define SF_BAL_BYTES_PER_PIXEL	BYTES_PER_PIXEL

#if defined ( _SFBAL_SUPPORT_VECTOR_FONT )
// GWES  Normal, Italic, Bold ̷ 3 set  .
// italic+bold  . GWES  .
#define		SF_BAL_GWES_VECTOR_FONT
/**
 * @enum 
 * 
 *  This is a enum about font 
 */
enum
{
	SF_BAL_FONT_NORMAL_SET = 0,
	SF_BAL_FONT_ITALIC_SET,
	SF_BAL_FONT_BOLD_SET,
	SF_BAL_FONT_ITALIC_BOLD_SET,

	SF_BAL_FONT_MAX_SET
};
#endif

/**
 * @struct 
 * 
 *  This is a struct about screen
 * @see        related information ( function name, module name, etc )
 */
 #if defined ( _SFBAL_SUPPORT_VECTOR_FONT )
typedef	struct
{
	//UINT16		type;

	//UINT16		width;
	//UINT16		height;
	//UINT32		byte_per_pixel;


	// to support multi font family, should be made as array. chaehwan 2006.03.05
	HFNT	hFont[SF_BAL_FONT_MAX_SET];
	int		selected_fontset;


} SFBalScreen;
 
 #endif


#if defined ( _SFBAL_SUPPORT_VECTOR_FONT )

/**
 * @struct _SFBalFontAttr
 * 
 *  This is a struct about  font attribute.
 * @see        related information ( function name, module name, etc )
 */
typedef struct _SFBalFontAttr
{
	BOOL	bUsed;
	BOOL	bItalic;
	BOOL	bBold;
	int		iSize;
	char*	psFontName; // reserved, to support multi font family
} SFBalFontAttr;

#endif // _SFBAL_SUPPORT_VECTOR_FONT

#define		SF_BAL_TEXT_BUFFER	4096

/* Font */

/**
 * @enum 
 * 
 *  This is a enum about font type
 */
typedef enum 
{
	SF_BAL_FONT_NONE			= -1,

	SF_BAL_FONT_9_NORMAL			= FONT_9_NORMAL,
	SF_BAL_FONT_9_BOLD			= FONT_9_BOLD,
	SF_BAL_FONT_9_ITALIC			= FONT_9_ITALIC,
	SF_BAL_FONT_9_ITALIC_BOLD	= FONT_9_ITALIC_BOLD,

	SF_BAL_FONT_12_NORMAL		= FONT_12_NORMAL,
	SF_BAL_FONT_12_BOLD			= FONT_12_BOLD,
	SF_BAL_FONT_12_ITALIC		= FONT_12_ITALIC,
	SF_BAL_FONT_12_ITALIC_BOLD	= FONT_12_ITALIC_BOLD,

	SF_BAL_FONT_14_NORMAL		= FONT_14_NORMAL,
	SF_BAL_FONT_14_BOLD			= FONT_14_BOLD,
	SF_BAL_FONT_14_ITALIC		= FONT_14_ITALIC,
	SF_BAL_FONT_14_ITALIC_BOLD	= FONT_14_ITALIC_BOLD,

	SF_BAL_FONT_16_NORMAL		= FONT_16_NORMAL,
	SF_BAL_FONT_16_BOLD			= FONT_16_BOLD,
	SF_BAL_FONT_16_ITALIC		= FONT_16_ITALIC,
	SF_BAL_FONT_16_ITALIC_BOLD	= FONT_16_ITALIC_BOLD,

	SF_BAL_FONT_18_NORMAL		= FONT_18_NORMAL,
	SF_BAL_FONT_18_BOLD			= FONT_18_BOLD,
	SF_BAL_FONT_18_ITALIC		= FONT_18_ITALIC,
	//SF_BAL_FONT_18_ITALIC_BOLD	= FONT_18_ITALIC_BOLD,

	SF_BAL_FONT_20_NORMAL		= FONT_20_NORMAL,
	SF_BAL_FONT_20_BOLD			= FONT_20_BOLD,
	SF_BAL_FONT_20_ITALIC		= FONT_20_ITALIC,
	//SF_BAL_FONT_20_ITALIC_BOLD	= FONT_20_ITALIC_BOLD,

	SF_BAL_FONT_24_NORMAL		= FONT_24_NORMAL,
	SF_BAL_FONT_24_BOLD			= FONT_24_BOLD,
	SF_BAL_FONT_24_ITALIC		= FONT_24_ITALIC,
	//SF_BAL_FONT_24_ITALIC_BOLD	= FONT_24_ITALIC_BOLD,

	SF_BAL_FONT_28_NORMAL		= FONT_28_NORMAL,
	SF_BAL_FONT_28_BOLD			= FONT_28_BOLD,
	SF_BAL_FONT_28_ITALIC		= FONT_28_ITALIC,
	//SF_BAL_FONT_28_ITALIC_BOLD	= FONT_28_ITALIC_BOLD,

} SFBalFontType;

#define SFBalBitmap		WmBitmap	
#define SFBalAniScene	WsAniScene	

#define SF_BAL_VIDEOPLUGIN_COLOR_CHROMAKEY	0xFFFE
#define SF_BAL_COLOR_CHROMAKEY				COLOR_CHROMAKEY

#if ( defined ( _SFBAL_SUPPORT_VECTOR_FONT ) && defined ( SF_BAL_GWES_VECTOR_FONT ) )
#define	SF_BAL_DEFAULT_FONT_NORMAL	SF_BAL_FONT_20_NORMAL
#define	SF_BAL_DEFAULT_FONT_ITALIC	SF_BAL_FONT_20_ITALIC
#define	SF_BAL_DEFAULT_FONT_BOLD		SF_BAL_FONT_20_BOLD
#endif // _SFBAL_SUPPORT_VECTOR_FONT

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _SFBAL_GWES_TYPES_H_

/* @} */