/**
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */

/**
 *  This file is about browser GWES(graphic).
 * 
 * @file       SFBalGwes.h
 * @author     Kunwoo Baek  (kw2.baek@samsung.com)
 */
/**
 * @addtogroup SF_BALATFORM
 * @{
 */


#ifndef _SFBAL_GWES_H_
#define _SFBAL_GWES_H_

#include "SFBalGWESTypes.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



/* for Initialize / Finalize */
BOOL		SFBalGwesInitializeGraphic();
BOOL		SFBalGwesFinalizeGraphic( void );

/* for SCREEN */
UINT16		SFBalGwesGetBytePerPixelScreen( void );


#if defined ( _SFBAL_SUPPORT_VECTOR_FONT )
/* VECTOR FONT */
HFNT	SFBalGwesGetHFontSreenInfo( void );
BOOL	SFBalGwesSetFontAttr( SFBalFontAttr in_fontattr );
HFNT	SFBalGwesCreateFontByAttr( SFBalFontAttr* pFontAttr );
#define SFBalGwesDeleteFont				WmDeleteFont
int		SFBalMakeFontID( SFBalFontAttr in_fontattr );
BOOL	SFBalGetFontAttr( int in_fontID, SFBalFontAttr* out_pfontattr );	
#endif //_SFBAL_SUPPORT_VECTOR_FONT


#if defined(USE_NATIVE_WIDGET_SUPPORT) && defined (USE_LIST_BOX_SUPPORT)

int SFBalGwesCreateListBox(HWIN hWinParent, int style, int x,int y,int w,int  h,WmEventMapEntry* gBrPlWsListEventMap);
BOOL SFBalGwesAddListItemText(HWIN hWin, const char* szItem);
BOOL SFBalGwesGetListExFocusedItem(HWIN hWin, int *index);
BOOL SFBalGwesSetListExFocusItem(HWIN hWin, WsListExTreeDepth depth, int ListIndex);
BOOL SFBalGwesSetListExAppInfo(HWIN hWin, void *pAppInfo, int depth,int ListIndex);
void* SFBalGwesGetListExAppInfo(HWIN hWin, WsListExTreeDepth depth, int ListIndex);
BOOL SFBalGwesSetListExItemBgBitmap(HWIN hWin, WmBitmap *pbmItemBg);
BOOL SFBalGwesGetListExColumnForm(HWIN hWin, HFNT (*colFont)[MAX_LISTEX_COLUMN], COLOR (*colNomalColor)[MAX_LISTEX_COLUMN], COLOR (*colSelectColor)[MAX_LISTEX_COLUMN],  int ListIndex);
BOOL SFBalGwesSetListExColumnForm(HWIN hWin, HFNT (*colFont)[MAX_LISTEX_COLUMN], COLOR (*colNomalColor)[MAX_LISTEX_COLUMN], COLOR (*colSelectColor)[MAX_LISTEX_COLUMN], WsListExTreeDepth depth, int ListIndex);
int	 SFBalGwesGetListExAllItemCount(HWIN hWin);
BOOL SFBalGwesSetListExFocusItemBgColor(HWIN hWin, COLOR color);
COLOR SFBalGwesGetListExFocusItemBgColor(HWIN hWin);
WsListExTreeDepth SFBalGwesGetListExTouchPressedItemIndex(HWIN hWin, int XPos, int YPos, int *index);

#endif //#if defined(USE_NATIVE_WIDGET_SUPPORT) && defined (USE_LIST_BOX_SUPPORT)


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif // _SFBAL_GWES_H_

/* @} */