/*
* ==============================================================================
*  Name        : BrowserSettings.hpp
*  Part of     : Browser Control.
*  Description : Implements browser settings.
*  Version     :
*
*    Copyright (c) 2007,
*    All rights reserved.
* ==============================================================================
*/
//vprajan: RVCT fix done
#include "BrowserSettings.h"
#include <ShpTypes.h>
#include <AnsiCLib.h>
BrowserSettings BrowserSettings::m_browserSettings;
//Create/ destroy methods 
BrowserSettings::BrowserSettings()
{
	
				int length = 0;
			
				mStatus_VirtualCursor	=	BROWSER_SETTINGS_VIRTUAL_CURSOR_DEFAULT_VALUE	;
				mStatus_Cookies			=	BROWSER_SETTINGS_COOKIES_DEFAULT_VALUE;
				mStatus_Cache			= 	BROWSER_SETTINGS_CACHEDEFAULT_VALUE ;
				mStatus_SmartLink		=	BROWSER_SETTINGS_SMARTLINK_DEFAULT_VALUE;	
				mStatus_AnimationDisplay	=	BROWSER_SETTINGS_ANIMATION_DISPLAY_DEFAULT_VALUE;
				mStatus_ImageSaveMode	=	BROWSER_SETTINGS_IMAGE_SAVE_MODE_DEFAULT_VALUE;
				mStatus_SplashHTML		=	BROWSER_SETTINGS_SPLASH_HTML_DEFAULT_VALUE;
				mStatus_SSR				=	BROWSER_SETTINGS_SSR_DEFAULT_VALUE;
				mStatus_VirtualCursor	=	BROWSER_SETTINGS_VIRTUAL_CURSOR_DEFAULT_VALUE	;
				mIapHandle				=	BROWSER_SETTINGS_IAPHANDLE_DEFAULT_VALUE;							
				mCacheSize				=	BROWSER_SETTINGS_CACHE_SIZEDEFAULT_VALUE;

				// Set mProxyInfo members
				mProxyInfo.auth_type	=	BROWSER_SETTINGS_SPROXYINFO_AUTH_TYPE_DEFAULT_VALUE ;
				mProxyInfo.port			=	BROWSER_SETTINGS_SPROXYINFO_PORT_DEFAULT_VALUE;
				
				length = AcStrlen(BROWSER_SETTINGS_SPROXYINFO_SERVER_NAME_DEFAULT_VALUE );
				mProxyInfo.server_name = NULL;//new char [ length + 1 ];
				//AcStrcpy( mProxyInfo.server_name , BROWSER_SETTINGS_SPROXYINFO_SERVER_NAME_DEFAULT_VALUE);
				
				length = AcStrlen(BROWSER_SETTINGS_SPROXYINFO_USER_NAME_DEFAULT_VALUE );
				mProxyInfo.user_name = NULL;//new char [ length + 1 ];
				//AcStrcpy( mProxyInfo.user_name , BROWSER_SETTINGS_SPROXYINFO_USER_NAME_DEFAULT_VALUE);
				
				length = AcStrlen(BROWSER_SETTINGS_SPROXYINFO_PASSWORD_DEFAULT_VALUE );
				mProxyInfo.password = NULL;//new char [ length + 1 ];
				//AcStrcpy( mProxyInfo.password ,  BROWSER_SETTINGS_SPROXYINFO_PASSWORD_DEFAULT_VALUE);
			
				
}
BrowserSettings::~BrowserSettings()
{
		delete mProxyInfo.server_name;
		delete mProxyInfo.user_name;
		delete mProxyInfo.password;
}
//Set settings methods
ESTATUS BrowserSettings::SetHttpProxy(const SProxyInfo* aProxyInfo)
{
	int length = 0;
	
	delete BrowserSettings::m_browserSettings.mProxyInfo.server_name;

	length = AcStrlen(aProxyInfo->server_name );
	BrowserSettings::m_browserSettings.mProxyInfo.server_name = new char [ length + 1 ];
	AcStrcpy( BrowserSettings::m_browserSettings.mProxyInfo.server_name , aProxyInfo->server_name);
			
	delete BrowserSettings::m_browserSettings.mProxyInfo.user_name;

	length = AcStrlen(aProxyInfo->user_name);
	BrowserSettings::m_browserSettings.mProxyInfo.user_name = new char [ length + 1 ];
	AcStrcpy( BrowserSettings::m_browserSettings.mProxyInfo.user_name , aProxyInfo->user_name);

	delete BrowserSettings::m_browserSettings.mProxyInfo.password;

	length = AcStrlen(aProxyInfo->password);
	BrowserSettings::m_browserSettings.mProxyInfo.password = new char [ length + 1 ];
	AcStrcpy(BrowserSettings::m_browserSettings.mProxyInfo.password,aProxyInfo->password);
	
	BrowserSettings::m_browserSettings.mProxyInfo.auth_type = aProxyInfo->auth_type;
	BrowserSettings::m_browserSettings.mProxyInfo.port = aProxyInfo->port;

	return ESuccess;
}

ESTATUS BrowserSettings::SetIAP(const IAPHANDLE aSelectedIapHandle)
{
	BrowserSettings::m_browserSettings.mIapHandle = aSelectedIapHandle;
	return ESuccess;
}

ESTATUS BrowserSettings::SetCacheSize(const unsigned int aCacheSize)
{
	BrowserSettings::m_browserSettings.mCacheSize = aCacheSize;		
	return ESuccess;
}

ESTATUS BrowserSettings::SetStatus_Cookies(const bool aPropertyValue)
{
	BrowserSettings::m_browserSettings.mStatus_Cookies = aPropertyValue;
	return ESuccess;
}

ESTATUS BrowserSettings::SetStatus_Cache(const bool aPropertyValue)
{
	BrowserSettings::m_browserSettings.mStatus_Cache = aPropertyValue;
	return ESuccess;
}

ESTATUS BrowserSettings::SetStatus_SmartLink(const bool aPropertyValue)
{
	BrowserSettings::m_browserSettings.mStatus_SmartLink = aPropertyValue;
	return ESuccess;
}

ESTATUS BrowserSettings::SetStatus_AnimationDisplay(const bool aPropertyValue)
{
	BrowserSettings::m_browserSettings.mStatus_AnimationDisplay  = aPropertyValue;
	return ESuccess;
}

ESTATUS BrowserSettings::SetStatus_ImageSaveMode(const bool aPropertyValue)
{
	BrowserSettings::m_browserSettings.mStatus_ImageSaveMode = aPropertyValue;
	return ESuccess;
}

ESTATUS BrowserSettings::SetStatus_SplashHTML(const bool aPropertyValue)
{
	BrowserSettings::m_browserSettings.mStatus_SplashHTML = aPropertyValue;
	return ESuccess;
}

ESTATUS BrowserSettings::SetStatus_SSR(const bool aPropertyValue)
{
	BrowserSettings::m_browserSettings.mStatus_SSR = aPropertyValue;
	return ESuccess;
}

ESTATUS BrowserSettings::SetStatus_VirtualCursor(const bool aPropertyValue)
{
	BrowserSettings::m_browserSettings.mStatus_VirtualCursor = aPropertyValue;
	return ESuccess;
}



//Get settings methods
ESTATUS BrowserSettings::GetHttpProxy(SProxyInfo* aProxyInfo)
{
	int length = 0;
	ESTATUS result = EFail;
	if( aProxyInfo )
	{
		aProxyInfo->port = BrowserSettings::m_browserSettings.mProxyInfo.port;
		aProxyInfo->auth_type = BrowserSettings::m_browserSettings.mProxyInfo.auth_type;
		
		length = AcStrlen(BrowserSettings::m_browserSettings.mProxyInfo.server_name);
		aProxyInfo->server_name = new char [ length + 1 ];
		AcStrcpy( aProxyInfo->server_name , BrowserSettings::m_browserSettings.mProxyInfo.server_name);

		length = AcStrlen(BrowserSettings::m_browserSettings.mProxyInfo.user_name);
		aProxyInfo->user_name = new char [ length + 1 ];
		AcStrcpy( aProxyInfo->user_name , BrowserSettings::m_browserSettings.mProxyInfo.user_name);

		length = AcStrlen(BrowserSettings::m_browserSettings.mProxyInfo.password);
		aProxyInfo->password = new char [ length + 1 ];
		AcStrcpy(aProxyInfo->password,BrowserSettings::m_browserSettings.mProxyInfo.password);

		result = ESuccess;
	}
	return result;
}

ESTATUS BrowserSettings::GetIAP(IAPHANDLE* aSelectedIapHandle)
{
	ESTATUS result = EFail;
	if(aSelectedIapHandle)
	{
		*aSelectedIapHandle = BrowserSettings::m_browserSettings.mIapHandle;
		result = ESuccess;
	}
	return result;
}

ESTATUS BrowserSettings::GetCacheSize(unsigned int * aCacheSize)
{
	ESTATUS result = EFail;
	if(aCacheSize)
	{
		*aCacheSize = BrowserSettings::m_browserSettings.mCacheSize;
		result = ESuccess;
	}
	return result;
}

bool BrowserSettings::GetStatus_Cookies()
{
		return BrowserSettings::m_browserSettings.mStatus_Cookies;
}

bool BrowserSettings::GetStatus_Cache()
{
		return BrowserSettings::m_browserSettings.mStatus_Cache;
}

bool BrowserSettings::GetStatus_SmartLink()
{
		return BrowserSettings::m_browserSettings.mStatus_SmartLink ;
}

bool BrowserSettings::GetStatus_AnimationDisplay()
{
	
		
		
		return BrowserSettings::m_browserSettings.mStatus_AnimationDisplay;
}

bool BrowserSettings::GetStatus_ImageSaveMode()
{
		return BrowserSettings::m_browserSettings.mStatus_ImageSaveMode;
}

bool BrowserSettings::GetStatus_SplashHTML()
{
		return BrowserSettings::m_browserSettings.mStatus_SplashHTML ;
}

bool BrowserSettings::GetStatus_SSR()
{
		return BrowserSettings::m_browserSettings.mStatus_SSR ;
}

bool BrowserSettings::GetStatus_VirtualCursor()
{
		return BrowserSettings::m_browserSettings.mStatus_VirtualCursor ;
}

//EOF
