@echo off
rem ======================================
rem Author: Pushparajan Vijayakumar (rajan.vp@samsung.com)
rem ======================================
rem
rem Build script for Jasmine BrowserEngine
rem

rem #####################################################################
rem
rem Build script specific environmental settings - SECTION #1
rem
rem #####################################################################

rem ===================================================
rem Standalone build system - parameters
rem ===================================================

IF "%STANDALONE_BUILD%" == "TRUE" (
IF "%STANDALONE%" == "TRUE" GOTO ERROR
)

IF "%STANDALONE%" == "TRUE" (
IF "%STANDALONE_BUILD%" == "TRUE" GOTO ERROR
)

rem ========================================
rem Build configuration for mkrules.inc
rem ========================================
set CURRENT_TARGET=RVCT
set CURRENT_CONFIG=RELEASE
set BUILD_NAME=%BUILD%_WEBKIT

rem ========================================
rem Enable the below rem statement to get DEBUG configuration
rem =======================================

rem set CURRENT_CONFIG=DEBUG

rem ========================================
rem Get the required absolute paths
rem WARNING: Below chdir has to be changed depending upon the dir structure
rem ========================================
rem TOP must always point to ROOT of Webkit Engine
set OLDDIR=%CD%
chdir ..
set TOP=%CD%
chdir %OLDDIR%

rem SHPROOT must always point to ROOT of view
set OLDDIR=%CD%
chdir ..\..\..\..\..
set SHPROOT=%CD%
chdir %OLDDIR%

rem ================================================
rem TOP = ShpWebkit = ROOT of Webkit Engine
rem MAINDIR = ShpWebkit\Make = ROOT of Build system
rem LOGDIR = ShpWebkit\Make = all logs go here
rem BUILDLOG = Change name of build.log
rem =================================================

set MAINDIR=%CD%
set LOGDIR=%MAINDIR%
set ERRORLOG=%LOGDIR%\error.log
rem set BUILDLOG=%LOGDIR%\build.log
rem Set errorlog to SHP error log

IF NOT "%BUILD_ERROR_LOG_TMP%" == "" set BUILDLOG=%SHPROOT%\ShpTarget\%BUILD_ERROR_LOG_TMP%

IF "%BUILDLOG%" == "" set BUILDLOG=%LOGDIR%\build.log


rem ===================================================
rem Change MAKEPARAMS to add parameters to GNU make
rem ===================================================
set MAKEPARAMS=%MAKEPARAMS% --quiet -I%MAINDIR%

rem =====================================================
rem Below variable used only in Makefiles
rem =====================================================
rem if "%TOPOUTPUTDIR%" == "" set TOPOUTPUTDIR=%TOP%\..\TargetBuild\objDebug
rem Use same TOPOUTPUTDIR for both NetCC and normal build
set TOPOUTPUTDIR=%TARGET%
set APPSBROWSER=%TOP%\..\TargetBuild\Libs
set BINDIR=%TOP%\..\TargetBuild\bin

rem #######################################################################
rem
rem Environmental variables      - SECTION #2
rem
rem #######################################################################
echo set PATH=%PATH% > _restorepath.bat 
rem ========================================
rem Windows Visual studio 2005 environment variables
rem ========================================
IF "%VSPATHSET%"=="TRUE" GOTO NOVSSET
set PATH=%MAINDIR%\tools;%PATH%
set VSPATHSET=TRUE

:NOVSSET

rem ========================================
rem Environment variables for RVCT build
rem 
rem WARNING: Requires RVCT 2.2 [Build 616] present in C:\apps\rvds221 !!
rem NOTE: if b.bat is ran, the below will not run
rem ========================================

IF "%SHPPATHSET%"=="TRUE" GOTO NOSET
set RVCTHOME=C:\apps\rvds221
set RVCT22BIN=%RVCTHOME%\RVCT\Programs\2.2\349\win_32-pentium
set RVCT22INC=%RVCTHOME%\RVCT\Data\2.2\349\include\windows
set RVCT22LIB=%RVCTHOME%\RVCT\Data\2.2\349\lib
set PATH=%RVCT22BIN%;%PATH%
set ARMINC=%RVCTHOME%\RVCT\Data\2.2\349\include\windows
set PATH=C:\Utils\Cygwin\bin;%PATH%

set SHPPATHSET=TRUE

:NOSET

echo "btype=%BUILD%" > temp.txt
echo "fspath=%FS_PATH%" > tempfs.txt
%SystemRoot%\System32\find "%BUILD%" temp.txt
if "%ERRORLEVEL%" == "1" GOTO AB_EXIT
%SystemRoot%\System32\find "%FS_PATH%" tempfs.txt
if "%ERRORLEVEL%" == "1" GOTO AB_EXIT
GOTO AB_OUT
:AB_EXIT
echo BUILD or FS_PATH variable not set !!..
echo Please use b.bat to use this script or use dry run scripts bSFB_[MODEL].bat
pause
exit /B
:AB_OUT

armar --vsn > vsn.txt
%SystemRoot%\System32\find "RVCT2.2 [Build 616]" vsn.txt
IF NOT "%ERRORLEVEL%"=="0" echo Please install RVCT2.2 616 patch && armcc --vsn && GOTO ERROR
echo ==================================================================
armcpp --vsn
tcpp --vsn
tcc --vsn
echo.
echo WARNING: PLEASE CHECK ALL THE ABOVE LINES DISPLAY RVCT 2.2 [Build 616] !!
echo ==================================================================
rem #######################################################################
rem
rem Start build process      - SECTION #3
rem
rem #######################################################################

echo ----------------------------------------
echo CONFIGURATION - %CURRENT_CONFIG%/%CURRENT_TARGET%
echo ----------------------------------------
rem echo Backup old log in %BUILDLOG%
rem cp -rf %BUILDLOG% %BUILDLOG%.old
rem echo Removing the older log files
rem rm -rf %BUILDLOG% 
rm -rf %ERRORLOG%

rem backup of binary and ELF
set OLDBIN=%BINDIR%\..\oldbin
rem set NUMBACK=10
dir /o /a-d %BINDIR% >nul
IF "%ERRORLEVEL%" == "1" GOTO BACKOUT

rem unlimited backup
rem dir /o /ad %OLDBIN% | wc -l  > __TMP00.DAT
rem @findstr /i /c:"%NUMBACK%" __TMP00.DAT > nul
rem IF "%ERRORLEVEL%" == "1" GOTO BACKOUT
set YYMMDD=%date:~4,2%%date:~7,2%%date:~10,4%%time:~0,2%%time:~3,2%%time:~6,2%
c:\Utils\Cygwin\bin\mkdir -p %OLDBIN%
mv %BINDIR% %OLDBIN%\bin_%YYMMDD% 2>nul

:BACKOUT
del __TMP00.DAT 2> nul

rem WORKAROUND: SCL files has two entries of same objects. So following renames are done.
echo WORKAROUND: rename the files for target
echo KJS: list.cpp - JSlist.cpp
cp -rvf %TOP%/JavaScriptCore/kjs/list.cpp %TOP%/JavaScriptCore/kjs/JSlist.cpp
echo Webcore platform: Timer.cpp - WCTimer.cpp
cp -rvf %TOP%/WebCore/platform/Timer.cpp %TOP%/WebCore/platform/WCTimer.cpp
echo Webcore DOM: Event.cpp - DOMEvent.cpp
cp -rvf %TOP%/WebCore/dom/Event.cpp %TOP%/WebCore/dom/DOMEvent.cpp

if "%1"=="" goto DEFAULT
if "%1"=="clean" goto DEFAULTCLEAN
if "%2"=="nodeps" set NODEPS=TRUE
echo ============================================================== 
make %MAKEPARAMS% -C "%MAINDIR%" -f main.gmk %1
IF NOT "%ERRORLEVEL%"=="0" GOTO ERROR
IF EXIST "%ERRORLOG%" type "%ERRORLOG%" >> %BUILDLOG%
IF EXIST "%ERRORLOG%" type "%ERRORLOG%"
echo ==============================================================
goto SUCCESS

:DEFAULT
echo =============================================================
make %MAKEPARAMS% -C "%MAINDIR%" -f main.gmk all
IF NOT "%ERRORLEVEL%"=="0" GOTO ERROR
IF EXIST "%ERRORLOG%" type "%ERRORLOG%" >> %BUILDLOG%
IF EXIST "%ERRORLOG%" type "%ERRORLOG%"
echo =============================================================
goto SUCCESS

:DEFAULTCLEAN
echo =============================================================
make %MAKEPARAMS% -C "%MAINDIR%" -f main.gmk clean 
IF NOT "%ERRORLEVEL%"=="0" GOTO ERROR
IF EXIST "%ERRORLOG%" type "%ERRORLOG%" >> %BUILDLOG%
IF EXIST "%ERRORLOG%" type "%ERRORLOG%"
echo =============================================================
goto SUCCESS

:ERROR
IF EXIST "%ERRORLOG%" type "%ERRORLOG%" >> %BUILDLOG%
IF EXIST "%ERRORLOG%" type "%ERRORLOG%"
call changecolor.bat "white on_red"
IF EXIST "%ERRORLOG%" grep -i -e "Error:.*" %ERRORLOG%
call changecolor.bat "white on_black"
echo --------------------------------------------------------
echo              Build Failed !!
echo --------------------------------------------------------
call _restorepath.bat 
set SHPPATHSET=FALSE
set VSPATHSET=FALSE
rem exit the batch script
IF "%STANDALONE_BUILD%" == "TRUE" GOTO ONPAUSE
IF "%STANDALONE%" == "TRUE" GOTO ONPAUSE
IF "%NET_COMPILE%" == "yes" GOTO ONPAUSE
exit 1
goto OUT

:SUCCESS
echo --------------------------------------------------------
echo             Check %BUILDLOG% for errors, if any
echo --------------------------------------------------------
call _restorepath.bat 
set SHPPATHSET=FALSE
set VSPATHSET=FALSE
IF "%STANDALONE_BUILD%" == "TRUE" GOTO ONPAUSE
IF "%STANDALONE%" == "TRUE" GOTO ONPAUSE
goto OUT

:ONPAUSE
pause
:OUT
set MAKEPARAMS=
