# Author: Pushparajan Vijayakumar (rajan.vp@samsung.com)
#
# Change Log:
#  * Adding NetCC feature
#
# SISO, Copyright 2008.
###############################################################################
#
# This is a Include file for Make rules
#

# Generate Depends
###############################################################################

DEPENDS := $(OBJECTS:.o=.dep)

# Disabled Dependencies because of errors
-include $(DEPENDS)

# Build rules
###############################################################################

prebuild: 
	-@if [ -f prebuild.bat ]; \
	then \
		`pwd`/prebuild.bat; \
	fi
	
createdirs: mainoutputdir
	@mkdir -p $(TARGET_BUILD_PATH)

$(TARGET_BUILD_PATH)/%.o: %.c
	@echo $<
	@$(CC) $(CFLAGS) $(DEFINES) $(INCLUDES) $(DFLAGS) $(TARGET_BUILD_PATH)/$(D_FILE) $(ERRFLAGS) $(ERRFILE) $< $(OBJ_CMD) $@ 
	@$(SED) -e "s/\\\/\//g" < $(TARGET_BUILD_PATH)/$(D_FILE) | sort | uniq > $(TARGET_BUILD_PATH)/$(DEP_FILE)
	@$(RM) $(TARGET_BUILD_PATH)/$(D_FILE)
ifeq ($(findstring TRUE, $(STANDALONE_BUILD)), TRUE)
	@perl $(MAINDIR)/tools/sandbox.pl $(TARGET_BUILD_PATH)/$(DEP_FILE) $(APPSBROWSER)/_shp_depend
endif



$(TARGET_BUILD_PATH)/%.o: %.cpp
	@echo $<
	@$(CXX) $(CXXFLAGS) $(DEFINES) $(INCLUDES) $(DFLAGS) $(TARGET_BUILD_PATH)/$(D_FILE) $(ERRFLAGS) $(ERRFILE) $< $(OBJ_CMD) $@ 
	@$(SED) -e "s/\\\/\//g" < $(TARGET_BUILD_PATH)/$(D_FILE) | sort | uniq > $(TARGET_BUILD_PATH)/$(DEP_FILE)
	@$(RM) $(TARGET_BUILD_PATH)/$(D_FILE)
ifeq ($(findstring TRUE, $(STANDALONE_BUILD)), TRUE)
	@perl $(MAINDIR)/tools/sandbox.pl $(TARGET_BUILD_PATH)/$(DEP_FILE) $(APPSBROWSER)/_shp_depend
endif

%.c: %.y


postbuild:
	-@if [ -f postbuild.bat ]; \
	then \
		`pwd`/postbuild.bat; \
	fi

$(APPSBROWSER)/$(TARGET): $(OBJECTS)
ifeq ($(findstring TRUE, $(STANDALONE_BUILD)), TRUE)
	@echo === SANDBOX MODE - No object archives generated ===
else
	@echo $? > $(MAINDIR)/_tmp_objs
	@updatearchive.bat $@ $(MAINDIR)/_tmp_objs
endif

all: prebuild createdirs $(APPSBROWSER)/$(TARGET) postbuild
	@echo "==== Build $(TARGET) ====" 


clean:
	$(RM) $(TARGET_BUILD_PATH);



