#include "MemoryLogger.h"

#ifdef CMM_LOGGING

#if __SHP__
//Commented because SFBal APIs for file are not working
#define __USE_SFBROWSER_APIS__
#endif

#ifdef __USE_SFBROWSER_APIS__
#include "ShpJasmine.h"
#include "FileMgr.h"
#include "AnsiCLib.h"

#define __FILE_EXIST(filename)			SFBalIsFileExist(filename)
#define __FILE_CREATE(filename, mode)	SFBalCreateFile(filename, mode)
#define __FILE_OPEN(filename, mode)		SFBalOpenFile(filename, mode)
#define __FILE_WRITE(file, buff, len)	SFBalWriteFile(file, buff, len)
#define __FILE_FLUSH(file)				FmFlushFile(file)	//no SFBal API for flush to file
#define __FILE_CLOSE(file)				SFBalCloseFile(file)

#define __FILE_MODE_APPEND				(BAL_FILE_APPEND | BAL_FILE_WRITE)
#define __FILE_MODE_CREATE				(BAL_FILE_CREATE | BAL_FILE_WRITE)

#define __STR_LEN						AcStrlen
#define __VSPRINTF						AcVsprintf

BalFile file = 0;
const char* kMemLogFile =	"/User/Br/Memory.log";

#else //__USE_SFBROWSER_APIS__

#include <stdio.h>
#include <string.h>
#include <stdarg.h>

bool __IsFileExist(const char* fileName)
{
	return true;
}

#define __FILE_EXIST(filename)			__IsFileExist(filename)
#define __FILE_CREATE(filename, mode)	fopen(filename, mode)
#define __FILE_OPEN(filename, mode)		fopen(filename, mode)
#define __FILE_WRITE(file, buff, len)	fwrite(buff, len, 1, file)
#define __FILE_FLUSH(file)				fflush(file)
#define __FILE_CLOSE(file)				fclose(file)

#define __FILE_MODE_APPEND				"a+"
#define __FILE_MODE_CREATE				"a+"

#define __STR_LEN						strlen
#define __VSPRINTF						vsprintf

FILE* file = 0;
const char* kMemLogFile =	"Memory.log";

#endif //__USE_SFBROWSER_APIS__


#define LOG_LINE_LENGTH		512

struct FileHelper
{
	FileHelper()
	{
		if(false == __FILE_EXIST(kMemLogFile))
			file = __FILE_CREATE(kMemLogFile, __FILE_MODE_CREATE);
		else
			file = __FILE_OPEN(kMemLogFile, __FILE_MODE_APPEND);
	}

	~FileHelper()
	{
		__FILE_CLOSE(file);
	}
};

FileHelper gFH; //global object

void FileWriteLog(const char* log)
{
	__FILE_WRITE(file, const_cast<char*>(log), __STR_LEN(log));
	__FILE_FLUSH(file);
}

void FileWriteFormattedLog(const char* fmt, ...)
{
	char log[LOG_LINE_LENGTH];
	va_list list;
	va_start(list, fmt);
	__VSPRINTF(log, fmt, list);
	__FILE_WRITE(file, reinterpret_cast<void*>(log), __STR_LEN(log));
	__FILE_FLUSH(file);
}

#endif
