#ifndef _BRIDGE_TYPES_H_
#define _BRIDGE_TYPES_H_

#ifdef __SHP__

#ifdef USE_CURL
typedef void CURL;
typedef CURL* TransportHandle;
#else // #ifdef USE_CURL
typedef int SFBRmReqId;
typedef SFBRmReqId TransportHandle;
#endif // #ifdef USE_CURL

#else // #ifdef __SHP__
typedef void * TransportHandle;
#endif // #ifdef __SHP__

typedef int gint;
typedef struct _StateChangeInfo StateChangeInfo;
typedef void (*ErrorHandler)(gint aErrorCode, char* in_szUrl);

enum eErrorCode {
    ERR_OK = 0,
    ERR_CANCEL,
    ERR_NOT_READY,
    ERR_NOT_SUPPORTED,
    ERR_DIED,        // Cancel error generated by core
	ERR_INVALID_URL, // If URL is other than HTTP, HTTPS, File type
    ERR_OUT_OF_MEMORY,
};

enum eHttpStatus {
    HTTP_OK = 200,
	HTTP_CREATED = 201,
	HTTP_ACCEPTED = 202,
	HTTP_NON_AUTH_INFO = 203,
	HTTP_NO_CONTENT = 204,
	HTTP_RESET_CONTENT = 205,
	HTTP_PARTIAL_CONTENT = 206,
    HTTP_UNAUTHORIZED = 401,
    HTTP_PROXY_AUTH_REQUIRED = 407
};

// These types are for optimized accept headers 
enum eUrlLoadType 
    {
    URL_REQUEST_TYPE_ANY,               // Any type               
    URL_REQUEST_TYPE_IMAGE,             // Load an image type     
    URL_REQUEST_TYPE_CSS,               // Load a stylesheet type 
    URL_REQUEST_TYPE_JAVA_SCRIPT,       // JavaScript type        
    URL_REQUEST_TYPE__PLUGIN,           // Load plugin resource     
    URL_REQUEST_TYPE_NONE               // No content types - related to WMLSCRIPT
    };

// HTTP Default Headers 
enum eUrlDefaultHeaderType
    {
    DEFAULT_HEADERS_NOT_ANY = 0x00, 
    DEFAULT_HEADERS_CONTENT = 0x01, 
    DEFAULT_HEADERS__CHARSET = 0x02, 
    DEFAULT_HEADERS_LANG = 0x04, 
    DEFAULT_HEADERS_ALL = 0x07
    };

enum eUrlLoadMethod
    {
    URL_GET,     // get
    URL_POST,    // post
    URL_HEAD     // head
    };

enum eContentLoadStatus {
    LOADING_STARTED,
    MORE_CONTENT,
    LOADING_COMPLETE
};

enum eTransactionEvents
    {
    NO_RESPONSE_YET = 0,
    SEND_PARTIAL_RESPONSE,
    SEND_RESPONSE_COMPLETE
    };

enum eContentDownloadType
    {
    CD_DIRECT_DOWNLOAD = 0,
    CD_OMA_DOWNLOAD,
    CD_MIDP_DOWNLOAD
    };

#endif // _BRIDGE_TYPES_H_
