#ifndef _WEBCOREIMAGECARRIER_H_
#define _WEBCOREIMAGECARRIER_H_

//  INCLUDES
#include "PlatformString.h"

using namespace WebCore;

class WebCoreImageCarrier
    {
    public:
        /**
        * Constructor
        * @param aRawData The image data
        * @param aUrl The url of the image
        * @param aAltText The alt text of the image
        * @param aImageType The type of the image
        * @param aRenderer The image renderer
        */
        WebCoreImageCarrier(String aRawData, String _url,
                           String _altText, String _imageType);

        /* IMPORT_C */ String RawData();
        /* IMPORT_C */ String Url();
        /* IMPORT_C */ String AltText();
        /* IMPORT_C */ String ImageType();

    private:
        String m_rawData;
        String m_url;
        String m_altText;
        String m_imageType;
    };


#endif

// End of File
