/*
 * Copyright (C) 1999 Lars Knoll (knoll@kde.org)
 *           (C) 1999 Antti Koivisto (koivisto@kde.org)
 * Copyright (C) 2004, 2005, 2006, 2007 Apple Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */
#if defined(SHP_SUPPORT_WML)
#ifndef WMLCardElement_h
#define WMLCardElement_h

#include "HTMLElement.h"

namespace WebCore {

class WmlCardElement:public HTMLElement
{
public:
	WmlCardElement(Document*);
	~WmlCardElement();


	String newcontext (); 
  
	String ordered ()const ; 

	String title () const ; 

	String onenterbackward ( ) const ; 
	String onenterforward ( ) const ; 

	String ontimer ( ) const ; 
	void setontimer ( const String& ) ; 

	virtual RenderObject* createRenderer(RenderArena*, RenderStyle*);

	virtual void attach () ;
	virtual void detach () ;

	virtual void handleEvent(EventType eventType, bool bForwardNavigation, bool & bIsEventHandled);
	void setEventHandled(bool bIsHandled) { m_bIsEventAlreadyHandled = bIsHandled; }
	protected:
    RefPtr<CSSMutableStyleDeclaration> m_linkDecl;

private:
	bool m_bIsEventAlreadyHandled;
};

} //namespace

#endif //WMLCardElement_h
#endif