#if defined(SHP_SUPPORT_WML)
#include "config.h"
#include "Element.h"
#include "WMLDoElement.h"
#include "AtomicString.h"
#include "CSSHelper.h"
#include "CSSPropertyNames.h"
#include "CSSValueKeywords.h"
#include "EventNames.h"
#include "HTMLDocument.h"
#include "HTMLNames.h"
#include "QualifiedName.h"
#include "WMLDocument.h"
#include "WMLBrowserContext.h"

#ifdef USE_NATIVE_WIDGET_SUPPORT
#include "NativeEditField.h"
#include "NativeComboField.h"
#endif


namespace WebCore {

using namespace HTMLNames;


//WML <do> tag att

String WMLDoElement::type() const
{
    return getAttribute(typeAttr);
}

void WMLDoElement::setType (const String &value)
{
    setAttribute(typeAttr, value);
}

String WMLDoElement::label() const
{
	String enclabel(getAttribute(labelAttr).impl() ) ;
	String * label = document()->frame()->getVariableReplacedString(enclabel) ;
	if (label)
		return *label ;
	return String() ;

	//return document()->frame()->getVariableReplacedString(getAttribute(labelAttr).domString())->copy() ;
}

void WMLDoElement::setLabel(const String &value)
{
    setAttribute(labelAttr, value);
}

String WMLDoElement::name() const
{
    return getAttribute(nameAttr);
}

void WMLDoElement::setName(const String &value)
{
    setAttribute(nameAttr, value);
}

String WMLDoElement::optional() const
{
    return getAttribute(optionalAttr);
}
void WMLDoElement::setOptional (const String &value)
{
    setAttribute(optionalAttr, value);
}

/*
this api has hardcoded strings we need to get the proper strings from the platform
*/
String WMLDoElement::getDisplayString () 
{
	String value = label() ;
	if (value.isEmpty())
	{
		if (type() == "accept")	{
			value = "Ok" ;
		}
		else if (type() == "prev")	{
			value = "Back" ;
		}
		else if (type() == "reset")	{
			value = "Reset" ;
		}
		else if (type() == "options")	{
			value = "Options" ;
		}
		else if (type() == "help")	{
			value = "Help" ;
		}
		else if (type() == "delete")	{
			value = "Delete" ;
		}
		else if (type() == "unknown")	{
			value = "Ok" ;
		}
		else	{
			value = "Ok" ;
			// here some mobile specific attribute will be defined, dunno what should be done
		}
	}
	return value ;
}

WMLDoElement::WMLDoElement(Document *doc)
    :HTMLElement( doTag,doc) 
{
}

WMLDoElement::~WMLDoElement()
{
}

void WMLDoElement::handleEvent(EventType eventType, bool bForwardNavigation, bool & bIsEventHandled)
{
	//Decide the softkey to be displayed based on <do> label and
	//options to be displayed on pressing options softkey.

	//Don't call children handleEvent here as we don't want to do the task here, 
	//We do the task only on user action like softkey selection etc, in defaultEventHanlder function.

	/*based on the above comment, i think we need to call task events here itself... its only
	at the time of user input does the control come to this API. Therefore defining a separate
	eventName for userInput for Do element--Raghu
	*/
	if (DoMenuEvent == eventType)	{
		/*
		Also i have to see if we need to handle any specific attribute values of the 'Type'
		Attribute as we are not bothered if there is no specific tag associated with it
		Opera does not do that :( so not doing the same :)
		*/
		NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
		if(pNativeEdit && pNativeEdit->isActivated())
		{
			pNativeEdit->_sendTextToBrowserEngine();
			pNativeEdit->unsetFocusedNode();
			pNativeEdit->deactivate();
			
		}


		for(Node *pChild = firstChild();pChild;pChild = pChild->nextSibling())	{
			if (pChild->hasTagName(prevTag))
				bForwardNavigation = false ;
			pChild->handleEvent(eventType, bForwardNavigation, bIsEventHandled);
		}
	}
}

}//namespace
#endif