# if defined(SHP_SUPPORT_WML)
#ifndef _WMLDOCUMENT_
#define _WMLDOCUMENT_

#include "config.h"
#include "Document.h"
#include "WMLBrowserContext.h"
#include "hashMap.h"
#include "frame.h"
namespace WebCore {
//Kishore/Raghu: WMLDocument needs to be created for wml page, deriving this class from Document
typedef HashMap<int, Node *> NodeMap ;
#if defined ( SFB_SUPPORT_WMLSCRIPT )
//Nataraj
class WMLScript ;
#endif//SFB_SUPPORT_WMLSCRIPT
class WMLDocument: public Document
{
private:
#if defined ( SFB_SUPPORT_WMLSCRIPT )
	WMLScript* wmlscript ; 
#endif//SFB_SUPPORT_WMLSCRIPT


	int m_count ;

	NodeMap *m_doElementMap ;
	bool m_bIsOOM;
	bool m_bSendReferer;
public:


	WMLDocument(DOMImplementation*, Frame*);
	~WMLDocument()
	{
	}
	bool childAllowed( Node *newChild );
	virtual void determineParseMode (const String &) { hMode = Wml ; pMode = Strict ;}
	virtual Tokenizer *createTokenizer () ;

	WMLBrowserContext* BrowserContext() { return frame()->BrowserContext();	}
#if defined ( SFB_SUPPORT_WMLSCRIPT )
	WMLScript* scriptInterface (){return wmlscript;}
#endif//SFB_SUPPORT_WMLSCRIPT	
	void setDoElement(Node *node) ;

	virtual void detach() ;
	virtual void handleRequestedGoEvent (int nodeId) ;
	void removeDoElement (int nodeId) ;
	virtual NodeMap *getDoElementMap () {return m_doElementMap ;}


	virtual int WML_ItemCount ( void ) ;
	bool isOOM() { return m_bIsOOM; }
	void setOOM(bool bOOM) { m_bIsOOM = bOOM; }
	void setSendReferer(bool bSendReferer) { m_bSendReferer = bSendReferer; }
	bool sendReferer() { return m_bSendReferer; }
};

} //namespace
#endif //__WML_DOCUMENT_H__
#endif //SHP_SUPPORT_WML
