/*
 * Copyright (C) 1999 Lars Knoll (knoll@kde.org)
 *           (C) 1999 Antti Koivisto (koivisto@kde.org)
 *           (C) 2000 Dirk Mueller (mueller@kde.org)
 * Copyright (C) 2004, 2005, 2006, 2007 Apple Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */

#if defined(SHP_SUPPORT_WML)
#ifndef WMLInputElement_h
#define WMLInputElement_h

#include "HTMLInputElement.h"

namespace WebCore {

class WMLInputElement : public HTMLInputElement {
public:
	WMLInputElement(Document* doc, HTMLFormElement* f);
    virtual void defaultEventHandler(Event*);
	virtual void parseMappedAttribute(MappedAttribute*);
	virtual void attach() ;
	virtual void detach() ;
private:
	bool m_inputValueset ;
};

} //namespace

#endif //WMLInputElement_h
#endif //SHP_SUPPORT_WML

