#if defined(SHP_SUPPORT_WML)
#include "config.h"
#include "Element.h"
#include "WMLSetvarElement.h"
#include "AtomicString.h"
#include "CSSHelper.h"
#include "CSSPropertyNames.h"
#include "CSSValueKeywords.h"
#include "EventNames.h"
#include "HTMLDocument.h"
#include "HTMLNames.h"
#include "QualifiedName.h"
#include "WMLDocument.h"
#include "WMLBrowserContext.h"

namespace WebCore {

using namespace HTMLNames;

WMLSetvarElement::WMLSetvarElement ( Document* doc)
:HTMLElement(setvarTag, doc)
{
}

WMLSetvarElement::~WMLSetvarElement()
{

}

String WMLSetvarElement::Value() const
{
	String value ;
	String *temp = document()->frame()->getVariableReplacedString (getAttribute(valueAttr).domString(), WMLBrowserContext::ENoEscape) ;
	if (temp)
		value = temp->copy() ;
	return value ;
}

void WMLSetvarElement::setValue (const String &value)
{
	setAttribute(valueAttr,value);
}

String WMLSetvarElement::Name() const
{
	//return getAttribute(nameAttr);
	String value ;
	String *temp = document()->frame()->getVariableReplacedString (getAttribute(nameAttr).domString(), WMLBrowserContext::ENoEscape);
	if (temp)
		value = temp->copy() ;
	return value ;
}

void WMLSetvarElement::setName (const String &name)
{
	setAttribute(nameAttr,name);
}

void WMLSetvarElement::parseMappedAttribute (MappedAttribute *attr)
{
	if (attr->name() == nameAttr)
	{
		/*
		i am not storing the value attribute as it is already a part of the HTMLElement class
		which is stored in the namedMappedAttr present in the Element class
		*/
		WMLDocument *doc = static_cast<WMLDocument *>(document()) ;
		String value ("");
		WMLBrowserContext::EVariableConversionType type = WMLBrowserContext::ENoEscape ;
		String variableName ;
		String *temp = document()->frame()->getVariableReplacedString(attr->value().domString(), \
												WMLBrowserContext::ENoEscape) ;
		if (temp)
			variableName = temp->copy () ;

		doc->BrowserContext()->AddVariable(variableName, value, type) ;
	}
	// we need not have to do anything with value attribute here in events we need to get the attribute and set the 
	// updated values
	HTMLElement::parseMappedAttribute(attr) ;
}

void WMLSetvarElement::handleEvent(EventType eventType, bool bForwardNavigation, bool & bIsEventHandled)
{
	// here do we receive any eventype Name??
	String name = getAttribute (nameAttr) ;
	String value = getAttribute (valueAttr) ;
	if (!name.isEmpty())	{
		WMLDocument *doc = static_cast<WMLDocument *>(document()) ;
		WMLBrowserContext::EVariableConversionType type = WMLBrowserContext::ENoEscape ;
		String variableName ;
		String *temp = document()->frame()->getVariableReplacedString(name, \
			WMLBrowserContext::ENoEscape) ;
		if (temp)
			variableName = temp->copy() ;
		String variableValue ;
		temp = document()->frame()->getVariableReplacedString(value, \
			WMLBrowserContext::ENoEscape) ;
		if (temp)
			variableValue = temp->copy() ;
		doc->BrowserContext()->SetVariableValue(variableName, variableValue) ;
	}
   //No need to call children handleEvent as there are no children for setvar 
}

} //WebCore
#endif