#if defined(SHP_SUPPORT_WML)
#ifndef __WML_TIMERELEMENT_H__
#define __WML_TIMERELEMENT_H__

#include "config.h"
#include "HTMLElement.h"
#include "HTMLNames.h"
#include "HTMLElementFactory.h"

namespace WebCore {

class DocumentFragment;
class HTMLCollection;
class HTMLFormElement;

class WMLTimerElement : public HTMLElement
{
   public:
	   WMLTimerElement ( Document*);
	  ~WMLTimerElement();


	  String Class() const;
	  void setClass (const String&);

	  String id() const;
	  void setId (const String&);

	  String Value() const;
	  void setValue (const String &value);

	  String Name() const;
	  void setName (const String &name);

	  void parseMappedAttribute(MappedAttribute*);

	  // This will be called everytime the page needs to be redrawn.
	  // So firing the timer has to happen only once and later we
	  // could do the timer mgmt in the HandleElement.
	  virtual void attach() ;
	  virtual void detach() ;
	  virtual void handleEvent(EventType eventType, bool bForwardNavigation, bool & bIsEventHandled);

	  void HandleTimerComplete(Timer<WMLTimerElement>* aTimer);

	  void StartTimer(unsigned int aTimerInterval);
	  void StopTimer();
	  void PauseTimer();
	  void RestartTimer();


	private:
		Timer<WMLTimerElement>	m_Timer;
		double					m_TimerInterval;
		String*					m_AttributeName;
		bool					m_NameAttrPresent;
		bool					m_TimerFiredFirstTime;

};
}
#endif //__WML_TIMERELEMENT_H__
#endif//SHP_SUPPORT_WML