#ifdef USE_NATIVE_WIDGET_SUPPORT

#ifndef NativeEditField_h
#define NativeEditField_h

#include "PlatformString.h"
#include "IntRect.h"
#include "Node.h"

#if PLATFORM(SHP)
#include "CMMDefs.h"
#endif // PLATFORM(SHP)

#if PLATFORM(SHP)
typedef int HWIN;
#endif



#define MAX_EDIT_BOX_TXT_LEN (1024 * 5)

namespace WebCore {

class RenderStyle;
class Document;

typedef struct NativeWidgetAttrib
{

	NativeWidgetAttrib() :
	m_strValue(""),
	m_rect(0, 0, 0, 0),
    m_cursorOffset(0),
    m_pStyle(NULL),
    m_isPassword(false),
    m_maxLength(MAX_EDIT_BOX_TXT_LEN),
	m_pDocument(NULL),
	m_nodeID(Node::ID_NONE),
	//NATARAJ  - for bug SFB00001279
	m_inputFormat("")
 {

 }

 String					m_strValue;
 IntRect				m_rect;
 unsigned int			m_cursorOffset;
 RenderStyle*			m_pStyle;
 bool					m_isPassword;
 unsigned int			m_maxLength;
 Document*				m_pDocument;
 Node::NodeId			m_nodeID;
//NATARAJ  - for bug SFB00001279
 bool					m_isEditFeild;
 String                 m_inputFormat;

} NativeWidgetAttrib;

class NativeEditField
CMM_MODIFIED
{
public :

	static NativeEditField* getNativeEditFieldInstance();
	static void destroyNativeEditFieldInstance();
	void activate(const NativeWidgetAttrib& attribute);
#if PLATFORM(SHP)
	void deactivate( bool bShow = true );
#else
	void deactivate();
#endif
	bool isActivated() const;
	String getString() const;
#if PLATFORM(SHP)
	bool isVKeyPadActivated();
	bool isKeyPadInFocus();
	void resetKeyPadFocusFlag();
	void unsetFocusedNode( bool bShow = true );
#else
	void unsetFocusedNode();
#endif

#if PLATFORM(SHP)
	//Added to unsetFocusedNode in widget as we do not create edit field
	void unsetFocusedNodeForWidget();
#endif	

	~NativeEditField();
	// bs0425.lee 2008 04.28 Add to fix edit field.
	static void _sendTextToBrowserEngine();
	const Document* getDocument() { return m_pDocument; }
	//Nataraj - for the fix B0100137742
	#if PLATFORM(SHP)
	HWIN m_handleWin;
	Node::NodeId		  m_nodeID;
	bool m_isEditFeild;
	unsigned int m_category;
	#endif


private :

	void _createEditField(const NativeWidgetAttrib& attrib);
	void _createEditArea(const NativeWidgetAttrib& attrib);
	void _createEditFieldText(const NativeWidgetAttrib& attrib);
	NativeEditField();

	Document*			  m_pDocument;
};


}  // namespace WebCore

#endif // NativeEditField_h

#endif //#ifdef USE_NATIVE_WIDGET_SUPPORT

