#include "config.h"
#include "PlatformKeyboardEvent.h"
#include "KeyboardCodes.h"
#include "NotImplemented.h"

#include "gwes.h"
//#include "BrAppEventTypes.h"

namespace WebCore {

	static inline String singleCharacterString(UINT16 val)
	{
		return String((UChar*)&val, 1);
	}

	static String keyIdentifierForShpKeyCode(UINT16 keyCode)
	{

		switch (keyCode) {
			case VK_HP_LEFT://case BR_APP_KEY_NAVI_LEFT:
				return "";
			case VK_HP_RIGHT://case BR_APP_KEY_NAVI_RIGHT:
				return "";
			case VK_HP_UP://case BR_APP_KEY_NAVI_UP:
				return "";
			case VK_HP_DOWN://case BR_APP_KEY_NAVI_DOWN:
				return "";
			case VK_HP_OK://case BR_APP_KEY_OK:
				return "";
#if 0
			case BR_APP_KEY_NUM_0:
				return "0";// (60) Numeric keypad 0 key
			case BR_APP_KEY_NUM_1:
				return "1";// (61) Numeric keypad 1 key
			case BR_APP_KEY_NUM_2:
				return  "2"; // (62) Numeric keypad 2 key
			case BR_APP_KEY_NUM_3:
				return "3"; // (63) Numeric keypad 3 key
			case BR_APP_KEY_NUM_4:
				return "4"; // (64) Numeric keypad 4 key
			case BR_APP_KEY_NUM_5:
				return "5"; //(65) Numeric keypad 5 key
			case BR_APP_KEY_NUM_6:
				return "6"; // (66) Numeric keypad 6 key
			case BR_APP_KEY_NUM_7:
				return "7"; // (67) Numeric keypad 7 key
			case BR_APP_KEY_NUM_8:
				return "8"; // (68) Numeric keypad 8 key
			case BR_APP_KEY_NUM_9:
				return "9"; // (69) Numeric keypad 9 key

			// QWERTY for Q-Bowl
			case BR_APP_KEY_QWERTY_A:
				return "A"; //  (41) A key case 'a': case 'A': return 0x41;
			case BR_APP_KEY_QWERTY_B:
				return "B"; //  (42) B key case 'b': case 'B': return 0x42;
			case BR_APP_KEY_QWERTY_C:
				return "C"; //  (43) C key case 'c': case 'C': return 0x43;
			case BR_APP_KEY_QWERTY_D:
				return "D"; //  (44) D key case 'd': case 'D': return 0x44;
			case BR_APP_KEY_QWERTY_E:
				return "E"; //  (45) E key case 'e': case 'E': return 0x45;
			case BR_APP_KEY_QWERTY_F:
				return "F"; //  (46) F key case 'f': case 'F': return 0x46;
			case BR_APP_KEY_QWERTY_G:
				return "G"; //  (47) G key case 'g': case 'G': return 0x47;
			case BR_APP_KEY_QWERTY_H:
				return "H"; //  (48) H key case 'h': case 'H': return 0x48;
			case BR_APP_KEY_QWERTY_I:
				return "I"; //  (49) I key case 'i': case 'I': return 0x49;
			case BR_APP_KEY_QWERTY_J:
				return "J"; //  (4A) J key case 'j': case 'J': return 0x4A;
			case BR_APP_KEY_QWERTY_K:
				return "K"; //  (4B) K key case 'k': case 'K': return 0x4B;
			case BR_APP_KEY_QWERTY_L:
				return "L"; //  (4C) L key case 'l': case 'L': return 0x4C;
			case BR_APP_KEY_QWERTY_M:
				return "M"; //  (4D) M key case 'm': case 'M': return 0x4D;
			case BR_APP_KEY_QWERTY_N:
				return "N"; //  (4E) N key case 'n': case 'N': return 0x4E;
			case BR_APP_KEY_QWERTY_O:
				return "O"; //  (4F) O key case 'o': case 'O': return 0x4F;
			case BR_APP_KEY_QWERTY_P:
				return "P"; //  (50) P key case 'p': case 'P': return 0x50;
			case BR_APP_KEY_QWERTY_Q:
				return "Q"; //  (51) Q key case 'q': case 'Q': return 0x51;
			case BR_APP_KEY_QWERTY_R:
				return "R"; //  (52) R key case 'r': case 'R': return 0x52;
			case BR_APP_KEY_QWERTY_S:
				return "S"; //  (53) S key case 's': case 'S': return 0x53;
			case BR_APP_KEY_QWERTY_T:
				return "T"; //  (54) T key case 't': case 'T': return 0x54;
			case BR_APP_KEY_QWERTY_U:
				return "U"; //  (55) U key case 'u': case 'U': return 0x55;
			case BR_APP_KEY_QWERTY_V:
				return "V"; //  (56) V key case 'v': case 'V': return 0x56;
			case BR_APP_KEY_QWERTY_W:
				return "W"; //  (57) W key case 'w': case 'W': return 0x57;
			case BR_APP_KEY_QWERTY_X:
				return "X"; //  (58) X key case 'x': case 'X': return 0x58;
			case BR_APP_KEY_QWERTY_Y:
				return "Y"; //  (59) Y key case 'y': case 'Y': return 0x59;
			case BR_APP_KEY_QWERTY_Z:
				return "Z"; //  (5A) Z key case 'z': case 'Z': return 0x5A;
#endif 
			case VK_HP_ASTERISK: //case BR_APP_KEY_ASTERISK:	
				return "*"; 
			case VK_HP_SHARP://case BR_APP_KEY_SHARP:		
				return "#";

			// VDJ: Unhandled keycodes
			case VK_HP_SIDEUP:// BR_APP_KEY_SIDE_UP:
			case VK_HP_SIDEDOWN: //case BR_APP_KEY_SIDE_DOWN:	
			case VK_HP_SEND://case BR_APP_KEY_SEND:
			case VK_HP_END://case BR_APP_KEY_END:
			case VK_HP_LEFTEASY://case BR_APP_KEY_LEFT_EASY:
			case VK_HP_RIGHTEASY://case BR_APP_KEY_RIGHT_EASY:
	        default:
	            return singleCharacterString(keyCode);
		}
	}

	static int windowsKeyCodeForKeyEvent(UINT16 keycode)
	{
		switch (keycode) {
			case VK_HP_0:
				return VK_NUMPAD0;// (60) Numeric keypad 0 key
			case VK_HP_1:
				return VK_NUMPAD1;// (61) Numeric keypad 1 key
			case VK_HP_2:
				return  VK_NUMPAD2; // (62) Numeric keypad 2 key
			case VK_HP_3:
				return VK_NUMPAD3; // (63) Numeric keypad 3 key
			case VK_HP_4:
				return VK_NUMPAD4; // (64) Numeric keypad 4 key
			case VK_HP_5:
				return VK_NUMPAD5; //(65) Numeric keypad 5 key
			case VK_HP_6:
				return VK_NUMPAD6; // (66) Numeric keypad 6 key
			case VK_HP_7:
				return VK_NUMPAD7; // (67) Numeric keypad 7 key
			case VK_HP_8:
				return VK_NUMPAD8; // (68) Numeric keypad 8 key
			case VK_HP_9:
				return VK_NUMPAD9; // (69) Numeric keypad 9 key
			case VK_HP_ASTERISK:
				return VK_MULTIPLY; // (6A) Multiply key
			case VK_HP_A:
				return VK_A; //  (41) A key case 'a': case 'A': return 0x41;
			case VK_HP_B:
				return VK_B; //  (42) B key case 'b': case 'B': return 0x42;
			case VK_HP_C:
				return VK_C; //  (43) C key case 'c': case 'C': return 0x43;
			case VK_HP_D:
				return VK_D; //  (44) D key case 'd': case 'D': return 0x44;
			case VK_HP_E:
				return VK_E; //  (45) E key case 'e': case 'E': return 0x45;
			case VK_HP_F:
				return VK_F; //  (46) F key case 'f': case 'F': return 0x46;
			case VK_HP_G:
				return VK_G; //  (47) G key case 'g': case 'G': return 0x47;
			case VK_HP_H:
				return VK_H; //  (48) H key case 'h': case 'H': return 0x48;
			case VK_HP_I:
				return VK_I; //  (49) I key case 'i': case 'I': return 0x49;
			case VK_HP_J:
				return VK_J; //  (4A) J key case 'j': case 'J': return 0x4A;
			case VK_HP_K:
				return VK_K; //  (4B) K key case 'k': case 'K': return 0x4B;
			case VK_HP_L:
				return VK_L; //  (4C) L key case 'l': case 'L': return 0x4C;
			case VK_HP_M:
				return VK_M; //  (4D) M key case 'm': case 'M': return 0x4D;
			case VK_HP_N:
				return VK_N; //  (4E) N key case 'n': case 'N': return 0x4E;
			case VK_HP_O:
				return VK_O; //  (4F) O key case 'o': case 'O': return 0x4F;
			case VK_HP_P:
				return VK_P; //  (50) P key case 'p': case 'P': return 0x50;
			case VK_HP_Q:
				return VK_Q; //  (51) Q key case 'q': case 'Q': return 0x51;
			case VK_HP_R:
				return VK_R; //  (52) R key case 'r': case 'R': return 0x52;
			case VK_HP_S:
				return VK_S; //  (53) S key case 's': case 'S': return 0x53;
			case VK_HP_T:
				return VK_T; //  (54) T key case 't': case 'T': return 0x54;
			case VK_HP_U:
				return VK_U; //  (55) U key case 'u': case 'U': return 0x55;
			case VK_HP_V:
				return VK_V; //  (56) V key case 'v': case 'V': return 0x56;
			case VK_HP_W:
				return VK_W; //  (57) W key case 'w': case 'W': return 0x57;
			case VK_HP_X:
				return VK_X; //  (58) X key case 'x': case 'X': return 0x58;
			case VK_HP_Y:
				return VK_Y; //  (59) Y key case 'y': case 'Y': return 0x59;
			case VK_HP_Z:
				return VK_Z; //  (5A) Z key case 'z': case 'Z': return 0x5A;

			case VK_HP_END:
				return VK_END; // (23) END key
			case VK_HP_HOME:
				return VK_HOME; // (24) HOME key

			//case BR_APP_KEY_NAVI_LEFT:
			case VK_HP_LEFT:
				return VK_LEFT; // (25) LEFT ARROW key

			case VK_HP_UP:
				return VK_UP; // (26) UP ARROW key

			//case BR_APP_KEY_NAVI_RIGHT:
			case VK_HP_RIGHT:
				return VK_RIGHT; // (27) RIGHT ARROW key
			case VK_HP_DOWN:
				return VK_DOWN; // (28) DOWN ARROW key
			case VK_HP_OK:
			case VK_HP_ENTER :
				return VK_SELECT; // (29) SELECT key

			case VK_HP_SPACE:
				return VK_SPACE; // (20) SPACEBAR
			case VK_HP_CAPSLOCK :
				return VK_CAPITAL; // (14) CAPS LOCK key
			case VK_HP_ALT :
				return VK_MENU; // (12) ALT key
			case VK_HP_NUM_LOCK :
				return VK_NUMLOCK; // (90) NUM LOCK key

			//case BR_APP_KEY_CLEAR:
			case VK_HP_CLEAR: //fall throu
			case VK_HP_BACKSPACE :
				return VK_BACK; // (08) BACKSPACE key
			
			
			case VK_HP_MAIL :
				//TBD
			case VK_HP_FN :
				// TBD
			default:
				return 0;
		}
	}

	PlatformKeyboardEvent::PlatformKeyboardEvent(int keyCode, bool isKeyUp)
    : m_text(keyIdentifierForShpKeyCode( (UINT16)keyCode) )
    , m_unmodifiedText(keyIdentifierForShpKeyCode((UINT16)keyCode))
    , m_keyIdentifier(keyIdentifierForShpKeyCode((UINT16)keyCode))
    , m_autoRepeat(false)
	, m_isKeyUp(isKeyUp)
    , m_windowsVirtualKeyCode(windowsKeyCodeForKeyEvent((UINT16)keyCode))
    , m_shiftKey(0) // TBD
    , m_ctrlKey(0)// TBD
    , m_altKey(0)// TBD
    , m_metaKey(0)// TBD

	{
	}

void PlatformKeyboardEvent::disambiguateKeyDownEvent(Type type, bool backwardCompatibilityMode)
{
    // Can only change type from KeyDown to RawKeyDown or Char, as we lack information for other conversions.
    ASSERT(m_type == KeyDown);
    m_type = type;

    if (backwardCompatibilityMode)
        return;

    if (type == RawKeyDown) {
        m_text = String();
        m_unmodifiedText = String();
    } else {
        m_keyIdentifier = String();
        m_windowsVirtualKeyCode = 0;
    }
}

bool PlatformKeyboardEvent::currentCapsLockState()
{
    notImplemented();
    return false;
}


}