#ifdef USE_NATIVE_WIDGET_SUPPORT
#include "NativeEditField.h"
#include "NotImplemented.h"
#include "IntRect.h"
#include "FontPlatformData.h"
#include "ShpJasmine.h"
#include "FontDescription.h"
#include "RenderStyle.h"
#include "Document.h"
#include "Frame.h"
#include "Page.h"
#include "FocusController.h"
#include "EventHandler.h"
#include "PlatformKeyboardEvent.h"
#include "FrameView.h"
#include "IFrameView.h"
#include "HTMLInputElement.h"
#include "HTMLTextAreaElement.h"
#ifdef SFB_WIDGET
#include "CString.h"
#endif

#ifdef SFB_GWES_TRANSFORM
#include "ChromeClient.h"
#endif

//Re-Eng - browser Engine should not have calls to platfrom or application directly
//#include "BrAppControl.h"

#define MAX_FONT_SIZE 8
//Keeping the minimum height and width for edit area =28 as it is the minimum required to accomodate scroll, borders and one character: hema
#define MINIMUM_WIDTH_AND_HEIGHT_EDITAREA 28
//Minimum width required to draw the edit area, below this width edit area will not be drawn.: CQ 4213
#define MINIMUM_WIDTH_REQUIRED_EDITAREA 10
#define SCROLLWIDTH 6

bool bKeyPadInFocus = false;

#ifdef SUPPORT_AUTO_FORM_FILL

#include "AutoFormFill.h"
#include "EventHandler.h"
#include "TextEvent.h"
#include "EventNames.h"
#include "HTMLInputElement.h"
#include "FrameLoader.h"
#define INVALID_INDEX	-1

#endif // SUPPORT_AUTO_FORM_FILL

//vamsi Bresson concept for Edit field

#ifdef SFB_BROWSER_NTOUCH_UI

#include "GWES.h"
#include "DevFlip.h"
#include "SysCompIDs.h"
#include "RsrcForm.h"
//#include "WsRsrcForm.h"

#include "RsrcMgr.h"
//#include "RsrcStrings.h"

#define _BROWSER_MAX_STRING 1024 /* Tahseen 17/10/08 - Edit Field Max Len*/
#define _BROWSER_MAX_STRING_WIDGET 1024
static MCHAR strValue[_BROWSER_MAX_STRING_WIDGET] = {0,};
/**
 * @struct
 *
 *  This is a struct about progress bar info
 * @see        related information ( function name, module name, etc )
 */
typedef struct
{
	HWIN	hWinMain;
	HWIN	hWinDest;
	int		iDestLimitLength;

	HWIN	hWinVEdit;
	HWIN	hWinVEArea;
	HWIN	hWinMiniEditor;
	HWIN    hWinExitMessageBox; /* For CQ 4018 */

} WkNativeWsVEditInfo;


static WkNativeWsVEditInfo*		pVEditInfo = NULL;

#endif //SFB_BROWSER_NTOUCH_UI

//forward declarations


namespace WebCore {
// CQ 3322 Fix
BOOL bMove;

//vamsi Bresson concept for Edit field
#ifdef SFB_BROWSER_NTOUCH_UI

# define EDITFIELD_PASSWORD_MAX_LEN 100
/* event handlers for edit field */
DECLARE_EVENT_MAP( WkNativeEditFieldEventMap );
/* For CQ 4018 */
DECLARE_EVENT_MAP ( WkNativeWsVEditExitMsgBoxEventMap );

DECLARE_HANDLE_EV_PRESSED(WkNativeEditFieldEventKeyPressed);
DECLARE_HANDLE_EV_TOUCH_RELEASED(WkNativeEditFieldEventTouchReleased);

BEGIN_EVENT_MAP( WkNativeEditFieldEventMap, 2)
	HANDLE_EV_PRESSED(WkNativeEditFieldEventKeyPressed)
	HANDLE_EV_TOUCH_RELEASED(WkNativeEditFieldEventTouchReleased)
END_EVENT_MAP()

#else

/* event handlers for edit field */
DECLARE_EVENT_MAP( WkNativeEditFieldEventMap );

DECLARE_HANDLE_EV_PRESSED(WkNativeEditFieldEventKeyPressed);

BEGIN_EVENT_MAP( WkNativeEditFieldEventMap, 1)
	HANDLE_EV_PRESSED(WkNativeEditFieldEventKeyPressed)
END_EVENT_MAP()

#endif // SFB_BROWSER_NTOUCH_UI

/* event handlers for edit area */
DECLARE_EVENT_MAP( WkNativeEditAreaEventMap );
DECLARE_HANDLE_EV_PRESSED(WkNativeEditAreaEventKeyPressed);
//ADDED to handle the touch relaesed event for edit area: CQ 3005:Thariq 
DECLARE_HANDLE_EV_TOUCH_RELEASED(WkNativeEditAreaEventTouchReleased);
//CQ 3322 Fix
DECLARE_HANDLE_EV_TOUCH_MOVE(WkNativeEditAreaEventTouchMove);

BEGIN_EVENT_MAP( WkNativeEditAreaEventMap, 3)
	HANDLE_EV_PRESSED(WkNativeEditAreaEventKeyPressed)
//ADDED to handle the touch relaesed event for edit area: CQ 3005:Thariq 
	HANDLE_EV_TOUCH_RELEASED(WkNativeEditAreaEventTouchReleased)
//CQ 3322 Fix
	HANDLE_EV_TOUCH_MOVE(WkNativeEditAreaEventTouchMove)
END_EVENT_MAP()

//vamsi Bresson concept for Edit field
#ifdef SFB_BROWSER_NTOUCH_UI

DECLARE_HANDLE_EV_ROTATE	( WkNativeWsVirtualEditMainRotate );
DECLARE_HANDLE_EV_EXPOSE	( WkNativeWsVirtualEditMainExpose );

DECLARE_HANDLE_EV_NOTIFY	( WkNativeWsVirtualEditDefaultNotify );
DECLARE_HANDLE_EV_PRESSED	( WkNativeWsVirtualEditDefaultPressed );
DECLARE_HANDLE_EV_PRESSED	( WkNativeWsVirtualEditPadDefaultPressed );
/* For CQ 4018 */
DECLARE_HANDLE_EV_PRESSED  ( WkNativeWsVirtualEditMsgBoxKeyReleased );

#ifdef SFB_WIDGET
DECLARE_HANDLE_EV_NOTIFY	( WkNativeWsVirtualEditForWidgetDefaultNotify );
DECLARE_HANDLE_EV_PRESSED	( WkNativeWsVirtualEditForWidgetDefaultPressed );
//Added for B0100143814
DECLARE_HANDLE_EV_PRESSED  ( WkNativeWsVirtualEditForWidgetMsgBoxKeyReleased );
#endif

/* Event Map */
BEGIN_EVENT_MAP( gMainWindowEventMap, 2 )
    HANDLE_EV_ROTATE		( WkNativeWsVirtualEditMainRotate )
    HANDLE_EV_EXPOSE		( WkNativeWsVirtualEditMainExpose )
END_EVENT_MAP()

BEGIN_EVENT_MAP( gWkNativeWsVEditEventMap, 2 )
	HANDLE_EV_PRESSED		( WkNativeWsVirtualEditDefaultPressed )
	HANDLE_EV_NOTIFY		( WkNativeWsVirtualEditDefaultNotify )
END_EVENT_MAP()

/*  For CQ 4018 -VE Exit MessageBox  Event map */
BEGIN_EVENT_MAP(WkNativeWsVEditExitMsgBoxEventMap, 1)
	HANDLE_EV_PRESSED       ( WkNativeWsVirtualEditMsgBoxKeyReleased )
END_EVENT_MAP()

#ifdef SFB_WIDGET
BEGIN_EVENT_MAP( gWkNativeWsVEditForWidgetEventMap, 2 )
	HANDLE_EV_PRESSED		( WkNativeWsVirtualEditForWidgetDefaultPressed )
	HANDLE_EV_NOTIFY		( WkNativeWsVirtualEditForWidgetDefaultNotify )
END_EVENT_MAP()
//Added for B0100143814
BEGIN_EVENT_MAP(WkNativeWsVEditForWidgetExitMsgBoxEventMap, 1)
	HANDLE_EV_PRESSED       ( WkNativeWsVirtualEditForWidgetMsgBoxKeyReleased )
END_EVENT_MAP()
#endif

HWIN WkNativeGetVEditHandle();
void WkNativeSetVEditHandle( HWIN hWin );

#ifdef SFB_WIDGET
HWIN WkNativeWsCreateVirtualEditForWidget(const NativeWidgetAttrib& attrib)
{
	HWIN	hWinVEdit = INVALID_HOBJ;
	HWIN	hWinVEArea = INVALID_HOBJ;
	HWIN	hWinMain = INVALID_HOBJ;
	WsEditCategory category ;
	WmRect	rcClientRect = {0,};

	WmScreenMetrics		metricsMain;
	WmGetScreenMetrics( &metricsMain, SCREEN_MAIN );

	if ( INVALID_HOBJ != WkNativeGetVEditHandle() )
		return INVALID_HOBJ;
	AcMemset(strValue,0x00,_BROWSER_MAX_STRING_WIDGET);
	NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
	const Document* pDoc =  pNativeEdit->getDocument();

	// For getting the Input format attribute 
	String inFormat = attrib.m_inputFormat.deprecatedString();
	int len = inFormat.length();
	int count = 0;
	char* format = (char*)MemAlloc(len+1);
	AcMemset(format,0x00,(len+1));

	AcStrncpy(format,inFormat.ascii().data(),len);
	
	// 0. Create static global context
	pVEditInfo = (WkNativeWsVEditInfo*)MemAlloc( sizeof(WkNativeWsVEditInfo) );
	if ( !pVEditInfo )
	{
		goto Catch_Error;
	}
	AcMemset( pVEditInfo, 0x00, sizeof(WkNativeWsVEditInfo) );

	// 1. Create Main Window
	hWinMain = WsCreateMain( 0, 0, metricsMain.screenW, metricsMain.screenH,
							MAIN_STYLE_INDICATOR|MAIN_STYLE_SOFTKEY|MAIN_STYLE_DISPLAY_DIRECTION,
							SCREEN_MAIN, WmGetEventMap(gMainWindowEventMap) );
	if ( INVALID_HOBJ == hWinMain )
	{
		goto Catch_Error;
	}
	WsSetMainDisplayDirection( hWinMain, MAIN_DISPLAY_DIRECTION_AUTO );
	pVEditInfo->hWinMain = hWinMain;

	// Widget wont create an Edit Field
	pVEditInfo->hWinDest = INVALID_HOBJ;

	hWinVEdit = WsCreateVirtualEditForm( hWinMain, VIRTUALEDIT_STYLE_NORMAL,
										MID_SYSBASE, FORM_SYS_VIRTUALEDIT, FORM_LAYOUT,
										WmGetEventMap(gWkNativeWsVEditForWidgetEventMap) );
	if ( INVALID_HOBJ == hWinVEdit )
	{
		goto Catch_Error;
	}
	hWinVEArea = WsGetVeEditWindow( hWinVEdit );
	WkNativeSetVEditHandle( hWinVEdit );
	pVEditInfo->hWinVEArea = hWinVEArea;

	WsSetEditSmartLetterMode( hWinVEArea, EDIT_SMART_LETTERMODE_NONE );
	
	if(Node::ID_TEXTAREA == pDoc->focusedNode()->nodeId())
	{
		for(int i = 0; i<len ; i++)
			{
				if(WTF::isASCIIDigit(format[i]))
					count = (count * 10) + (int)(format[i] - '0');
				else if(format[i]== 'N')
					count++;
			}
		category = F_ALPHA|F_NUMERIC|F_SYMBOL;
	}
	else
	{
		SFBalWsSetVeEnableCR( hWinVEdit , FALSE );
		if( !inFormat.isNull() )
		{
			if (inFormat.contains("N",false))
			{
				WsSetEditAreaInputMode(hWinVEArea, EDIT_INPUTMODE_NUMERIC);
				category = F_NUMERIC; //Fix for B0100146151
			}
			else if ((inFormat.contains("A")) || (inFormat.contains("X")) || (inFormat.contains("M")))
			{
				WsSetEditAreaInputMode(hWinVEArea, EDIT_INPUTMODE_ALPHA);
				WsSetEditAreaInputAlphabetMode( hWinVEArea, EDIT_LETTERMODE_CAPITAL );
				category = F_ALPHA|F_NUMERIC|F_SYMBOL;
			
			}
			else if ((inFormat.contains("a")) || (inFormat.contains("x")) || (inFormat.contains("m")))
			{
				WsSetEditAreaInputMode(hWinVEArea, EDIT_INPUTMODE_ALPHA);
				WsSetEditAreaInputAlphabetMode( hWinVEArea, EDIT_LETTERMODE_SMALL );
				category = F_ALPHA|F_NUMERIC|F_SYMBOL;
			}
			

			for(int i = 0; i<len ; i++)
			{
				if(WTF::isASCIIDigit(format[i]))
					count = (count * 10) + (int)(format[i] - '0');
				else if(format[i]== 'N'||format[i]== 'n')
					count++;
			}
			
		}
		else
			category = F_ALPHA|F_NUMERIC|F_SYMBOL;
	}

	if(count < 1)			// No format attribute present so setting it to widget default
		count = _BROWSER_MAX_STRING_WIDGET;  

	//WsSetEditAreaInputAlphabetMode( hWinVEArea, (WsEditLetterMode)EDITAREA_INPUT_ALPHABETMODE_SMALL );

	//4. Get Text from Input Element
	//NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();

	if( pNativeEdit )
	{
		//const Document* pDoc =  pNativeEdit->getDocument();
		HTMLInputElement* pInputElement = 0;
		String str;
		int strlen =0;

		if(Node::ID_TEXTAREA == pDoc->focusedNode()->nodeId())
        {
            HTMLTextAreaElement* pTextArea = static_cast<HTMLTextAreaElement *> (pDoc->focusedNode());
			str = pTextArea->value();
			//value = (char*)MemAlloc(sizeof(char)*(pTextArea->value().length()+1));
			//AcMemset(value,0x00,sizeof(char)*(pTextArea->value().length()+1));
			//AcStrncpy(value,pTextArea->value().utf8().data(),pTextArea->value().length());

        }
        else if(Node::ID_INPUT == pDoc->focusedNode()->nodeId())
        {
            pInputElement = static_cast<HTMLInputElement *> (pDoc->focusedNode());			
			str = pInputElement->value();
			//value = (char*)MemAlloc(sizeof(char)*(pInputElement->value().length()+1));
			//AcMemset(value,0x00,sizeof(char)*(pInputElement->value().length()+1));
			//AcStrncpy(value,pInputElement->value().utf8().data(),pInputElement->value().length());

		}
		
		if (!str.isEmpty())
			strlen = str.length();
		
		MCHAR	mszTitle[10] = {0, };
		int		nTextLen = 0;

		

		if (count)
			pVEditInfo->iDestLimitLength = count ;
		else
			pVEditInfo->iDestLimitLength = _BROWSER_MAX_STRING_WIDGET;

		// To Support Oil Calculator widget, Conformance Hack to match NF
		if( attrib.m_maxLength < count )
		{
			pVEditInfo->iDestLimitLength = attrib.m_maxLength ;
			count = attrib.m_maxLength ;
			if( count < 5 )
			{
				WsSetEditAreaInputMode( hWinVEArea , EDIT_INPUTMODE_NUMERIC );
				//category = F_NUMERIC|F_SYMBOL;
			}
		}
	
		//pmszText = (MCHAR*)MemAlloc( sizeof(MCHAR)*(pVEditInfo->iDestLimitLength +1) );
		//AcMemset( pmszText, 0x00, sizeof(MCHAR)*(pVEditInfo->iDestLimitLength+1) );
		//nTextLen = AcStrlen(value);
		//WmConvert2PCode(pmszText,sizeof(pmszText),(char*)value);

		if ( Node::ID_INPUT == pDoc->focusedNode()->nodeId() && 
			pInputElement->inputType() == pInputElement->PASSWORD )
		{
			//Changed the form to create a edit field with password style.							
			WsSetVeEditWindowForm( hWinVEdit, WINDOW_EDITFIELD,
								EDITFIELD_STYLE_TITLE_TOP|EDITFIELD_STYLE_NORMAL|EDITFIELD_STYLE_PASSWORD, -1, -1, -1 );
				
			hWinVEArea = WsGetVeEditWindow( hWinVEdit );
			pVEditInfo->hWinVEArea = hWinVEArea;
				
			WsSetEditFieldCategory( hWinVEArea, F_ALPHA|F_T9|F_QWERTY, TRUE );
			//if ( nTextLen > 0 )
			if (strlen > 0 )
				WsSetEditFieldText( hWinVEArea, (MCHAR *)str.charactersWithNullTermination() );
				SFBalSetEditFieldInputTypeCategory( hWinVEArea, F_HWR, FALSE );
		}
		else
		{
			//WsSetEditAreaCategory( hWinVEArea, F_ALPHA|F_T9|F_QWERTY|F_SYMBOL|F_NUMERIC, TRUE );
			WsSetEditAreaLimitLength( hWinVEArea, count );
			WsSetEditAreaCategory( hWinVEArea, category, TRUE );
					
			if (strlen > 0 )
			{
				WsSetEditAreaText( hWinVEArea, (MCHAR *)str.charactersWithNullTermination());
				AcWcscpy((wchar_t*)strValue,(wchar_t*)str.charactersWithNullTermination());
			}
		}
	}

	
	WmSetFocusWindow( hWinVEdit );

	WmDrawWindow( hWinMain, TRUE );
	WmShowWindow( hWinMain );

	if(format)
		MemFree(format);

//	WkNativeStateSetTopSymbolPopup( TRUE );
	return hWinVEdit;

Catch_Error:

	return INVALID_HOBJ;

}

BOOL
WkNativeWsVirtualEditForWidgetDefaultNotify( WmState* pState, WmEvent* pEvent )
{
	switch ( pEvent->notify.nType )
	{
		case VEDIT_NOTIFY_SELECTED:		// Done
		{
			MCHAR	mszText[_BROWSER_MAX_STRING_WIDGET + 1] = {0, };
			char	text[_BROWSER_MAX_STRING_WIDGET + 1] = {0, };
			int		nTextLen = 0;
			int		nType = -1;

			nTextLen = WsGetVeEditTextLength( pVEditInfo->hWinVEdit );
			WsGetVeEditText( pVEditInfo->hWinVEdit, mszText,_BROWSER_MAX_STRING_WIDGET  );

			NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();

			if( pNativeEdit )
			{
				const Document* pDoc =  pNativeEdit->getDocument();
				UChar Ustr[_BROWSER_MAX_STRING_WIDGET + 1] = {0, };
				AcWcscpy(Ustr,(const UChar*)mszText);
				String str(Ustr);

				if(Node::ID_TEXTAREA == pDoc->focusedNode()->nodeId())
				{
					HTMLTextAreaElement* pTextArea = static_cast<HTMLTextAreaElement *> (pDoc->focusedNode());
					pTextArea->setValue(str);					
				}
				else if(Node::ID_INPUT == pDoc->focusedNode()->nodeId())
				{
					HTMLInputElement* pInputElement = static_cast<HTMLInputElement *> (pDoc->focusedNode());
					pInputElement->setValue(str);				
				}

				pNativeEdit->unsetFocusedNodeForWidget();				
			}			
		}

		//	No break, just destroy widnow
		case VEDIT_NOTIFY_CANCELED:		// Cancel
		{
			// To Rotate back if exiting from Qwerty Mode!
			if( FlipGetDegreeRotated() )
				OemFlipRotateInd(0);

			WmDestroyWindow( pVEditInfo->hWinMain );
			pVEditInfo->hWinMain = INVALID_HOBJ;

			WkNativeSetVEditHandle( INVALID_HOBJ );

			if ( pVEditInfo )
			{
				if ( pVEditInfo->hWinVEdit == INVALID_HOBJ )
				{
					MemFree( pVEditInfo );
					pVEditInfo = NULL;
				}
			}			
		}
		default:
		break;
	}

	return TRUE;
}

BOOL
WkNativeWsVirtualEditForWidgetDefaultPressed( WmState* pState, WmEvent* pEvent )
{
	int		length = 0;
	switch ( pEvent->key.keyCode )
	{
	#if defined ( _BROWSER_ENABLED_CLEAR_BACK_KEY )
		case VK_HP_CLEAR:
	#endif
		case VK_HP_RIGHTEASY:
			{
			length = WsGetVeEditTextLength( pVEditInfo->hWinVEdit );
			if ( length > 0 )
			{	
				pVEditInfo->hWinExitMessageBox = WsCreateMessageBox( pVEditInfo->hWinMain, MESSAGEBOX_STYLE_YESNO,
														  MESSAGEBOX_ICON_DIALOG,
														  INFINITE,
														  NULL,
														  RsrcLoadString(IDS_COM_POP_CREATEMSG_EXIT_VIRTUAL_KEYBOARD_WITHOUT_SAVING_Q),
														  WmGetEventMap( WkNativeWsVEditForWidgetExitMsgBoxEventMap ));

				if ( pVEditInfo->hWinExitMessageBox == INVALID_HOBJ )
				{
					SysDebug( (MID_EXCEPTION, "__WsVeCreateExitMessageBox: ExitMessageBox is failed to create\n") );
					return FALSE;
				}				
	
				WmSetFocusWindow(pVEditInfo->hWinExitMessageBox);
				WmDrawWindow(pVEditInfo->hWinExitMessageBox, TRUE);
				WmShowWindow(pVEditInfo->hWinExitMessageBox);				
				
			}
			else
			{
			NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
			const Document* pDoc =  pNativeEdit->getDocument();
			//Changes for B0100141808	
			if(Node::ID_TEXTAREA == pDoc->focusedNode()->nodeId())
			{
				HTMLTextAreaElement* pTextArea = static_cast<HTMLTextAreaElement *> (pDoc->focusedNode());
				String strTemp((UChar*)strValue);
				pTextArea->setValue(strTemp);
			}
			else if(Node::ID_INPUT == pDoc->focusedNode()->nodeId())
			{
				HTMLInputElement* pInputElement = static_cast<HTMLInputElement *> (pDoc->focusedNode());
				String strTemp((UChar*)strValue);
				pInputElement->setValue(strTemp);
			}		
				WkNativeSetVEditHandle( INVALID_HOBJ );
				WmDestroyWindow( pVEditInfo->hWinMain );
				if ( pVEditInfo )
				{
						pVEditInfo->hWinMain = INVALID_HOBJ;
						MemFree( pVEditInfo );
						pVEditInfo = NULL;
				}
				if( FlipGetDegreeRotated() )
					OemFlipRotateInd(0);
			}
		}
		break;
		case VK_HP_END:
		{
			NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
			const Document* pDoc =  pNativeEdit->getDocument();
			
			if(Node::ID_TEXTAREA == pDoc->focusedNode()->nodeId())
			{
				HTMLTextAreaElement* pTextArea = static_cast<HTMLTextAreaElement *> (pDoc->focusedNode());
				String strTemp((UChar*)strValue);
				pTextArea->setValue(strTemp);
			}
			else if(Node::ID_INPUT == pDoc->focusedNode()->nodeId())
			{
				HTMLInputElement* pInputElement = static_cast<HTMLInputElement *> (pDoc->focusedNode());
				String strTemp((UChar*)strValue);
				pInputElement->setValue(strTemp);
			}		
			
			// To Rotate back if exiting from Qwerty Mode!
			if( FlipGetDegreeRotated() )
				OemFlipRotateInd(0);

			WmDestroyWindow( pVEditInfo->hWinMain );
			pVEditInfo->hWinMain = INVALID_HOBJ;

			WkNativeSetVEditHandle( INVALID_HOBJ );

			if ( pVEditInfo )
			{
				if ( pVEditInfo->hWinVEdit == INVALID_HOBJ )
				{
					MemFree( pVEditInfo );
					pVEditInfo = NULL;
				}
			}
		}
		break;

		default:
			WmCallNextKeyPressedHandler( pState, pEvent );
			break;
	}

	return TRUE;
}

// We need to unFocus the Input Element of HTML without any activation/deactivation of EditField
// Widget Specific
void NativeEditField::unsetFocusedNodeForWidget()
{
	// Unset the focus node here as we are not activating edit field
	if(m_pDocument)
	{
		if(isActivated())
		{
		FrameView* view = m_pDocument->frame()->view();
		while (view->parent())
		{
			view = static_cast<FrameView*>(view->parent());
		}
		view->update();					
		// defocussed after updating the FrameView.
		m_pDocument->page()->focusController()->setFocusedNode(0, m_pDocument->frame());
	}
}
}

#endif

HWIN
WkNativeWsCreateVirtualEdit( HWIN hWinMain, HWIN hWinDest )
{
	HWIN	hWinVEdit = INVALID_HOBJ;
	HWIN	hWinVEArea = INVALID_HOBJ;

	WmRect	rcClientRect = {0,};

	WmScreenMetrics		metricsMain;
	WmGetScreenMetrics( &metricsMain, SCREEN_MAIN );

	if ( INVALID_HOBJ != WkNativeGetVEditHandle() )
		return INVALID_HOBJ;

	// 0. Create static global context
	pVEditInfo = (WkNativeWsVEditInfo*)MemAlloc( sizeof(WkNativeWsVEditInfo) );
	if ( !pVEditInfo )
	{
		goto Catch_Error;
	}
	AcMemset( pVEditInfo, 0x00, sizeof(WkNativeWsVEditInfo) );

	// 1. Create Main Window
	if ( PhsGetStatus(PS_LCDTYPE) == PHS_LCD_VERTICAL )	
		hWinMain = WsCreateMain( 0, 0, metricsMain.screenW, metricsMain.screenH,
							MAIN_STYLE_INDICATOR|MAIN_STYLE_SOFTKEY|MAIN_STYLE_DISPLAY_DIRECTION,
							SCREEN_MAIN, WmGetEventMap(gMainWindowEventMap) );
	else
		hWinMain = WsCreateMain( 0, 0, metricsMain.screenW, metricsMain.screenH, 
								MAIN_STYLE_INDICATOR|MAIN_STYLE_NO_SOFTKEY|MAIN_STYLE_DISPLAY_DIRECTION,
								SCREEN_MAIN, WmGetEventMap(gMainWindowEventMap) );
	if ( INVALID_HOBJ == hWinMain )
	{
		goto Catch_Error;
	}

	WsSetMainDisplayDirection( hWinMain, MAIN_DISPLAY_DIRECTION_AUTO );
	pVEditInfo->hWinMain = hWinMain;

	// 2. Get Destination Window ( VirtualEditPad   Edit window )
	if( !WmIsWindowValid(hWinDest) )
	{
		goto Catch_Error;
	}
	pVEditInfo->hWinDest = hWinDest;

	// 3. Create Virtual Edit Window
#if 0
	WmGetWindowClientRect( hWinMain, &rcClientRect );
	hWinVEdit = WsCreateVirtualEdit( hWinMain, VIRTUALEDIT_STYLE_NORMAL,
										0, 0, rcClientRect.w, rcClientRect.h,
										WmGetEventMap(gWkNativeWsVEditEventMap) );
#else
	hWinVEdit = WsCreateVirtualEditForm( hWinMain, VIRTUALEDIT_STYLE_NORMAL,
										MID_SYSBASE, FORM_SYS_VIRTUALEDIT, FORM_LAYOUT,
										WmGetEventMap(gWkNativeWsVEditEventMap) );
#endif
	if ( INVALID_HOBJ == hWinVEdit )
	{
		goto Catch_Error;
	}
	hWinVEArea = WsGetVeEditWindow( hWinVEdit );
	WkNativeSetVEditHandle( hWinVEdit );
	pVEditInfo->hWinVEArea = hWinVEArea;
	//Nataraj - fix for B0100137742
	NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
	WsEditInputMode eWsEditInputMode;
	//added to handle edit area inputmode
	if(pNativeEdit->m_nodeID == Node::ID_TEXTAREA)
		WsGetEditAreaInputMode(pNativeEdit->m_handleWin , &eWsEditInputMode);
	else
	{
		//amitg@samsung.com ECIM B0100145387
		SFBalWsSetVeEnableCR( hWinVEdit , FALSE );
		WsGetEditFieldInputMode(pNativeEdit->m_handleWin , &eWsEditInputMode);
	}

	switch(eWsEditInputMode)
	{
		case EDIT_INPUTMODE_ALPHA:
		case EDIT_INPUTMODE_T9:
		{
			WsEditLetterMode eWsEditLetterMode;
			WsEditAreaLetterMode eWsEditAreaLetterMode;
			if(pNativeEdit->m_nodeID == Node::ID_TEXTAREA)
				SFBalGetEditAreaInputAlphabetMode(pNativeEdit->m_handleWin,(int *)&eWsEditLetterMode);
			else
				SFBalGetEditFieldInputAlphabetMode(pNativeEdit->m_handleWin,(int *)&eWsEditLetterMode);
			//WsSetEditAreaInputAlphabetMode( hWinVEArea, eWsEditLetterMode );	
			switch(eWsEditLetterMode)
			{
			case EDIT_LETTERMODE_SMALL: eWsEditAreaLetterMode = EDITAREA_LETTERMODE_SMALL;break;
			case EDIT_LETTERMODE_CAPITAL: eWsEditAreaLetterMode = EDITAREA_LETTERMODE_CAPITAL;break;
			case EDIT_LETTERMODE_SHIFT:
			default:
				eWsEditAreaLetterMode = EDITAREA_LETTERMODE_NORMAL; 
			}
			WsSetEditAreaLetterMode(hWinVEArea, eWsEditAreaLetterMode);
			break;
		}
		case EDIT_INPUTMODE_NUMERIC:
		{
			WsSetEditAreaInputMode( hWinVEArea , EDIT_INPUTMODE_NUMERIC );
			break;
		}
	}

//	WsSetEditSmartLetterMode( hWinVEArea, EDIT_SMART_LETTERMODE_NONE );
//	WsSetEditAreaInputAlphabetMode( hWinVEArea, (WsEditLetterMode)EDITAREA_INPUT_ALPHABETMODE_SMALL );
//	WsSetEditAreaInputMode( hWinVEArea, EDIT_INPUTMODE_ALPHA );
//	WsSetEditAreaCharacterMode( hWinVEArea, EDIT_CHARACTER_UNICODE );

	// 4. Set Edit Window Text
	{
		MCHAR*	pmszText = NULL;
		int		nType = -1;

		WmGetWindowType( hWinDest, &nType );
		switch( nType )
		{
		case WINDOW_EDITFIELD:
			{
				MCHAR	mszTitle[10] = {0, };
				int		nTextLen = 0;
				int		style;

				pVEditInfo->iDestLimitLength = WsGetEditFieldLimitLength( hWinDest );
				pmszText = (MCHAR*)MemAlloc( sizeof(MCHAR)*(pVEditInfo->iDestLimitLength + 1));//Changes for CQ 4312
				AcMemset( pmszText, 0x00, sizeof(MCHAR)*(pVEditInfo->iDestLimitLength + 1) );

				nTextLen = WsGetEditFieldTextLength( hWinDest );

				if ( nTextLen > 0 )
					WsGetEditFieldText( hWinDest, pmszText, sizeof(MCHAR)*(nTextLen+1) );

				style = WmGetWindowStyle( hWinDest );
				if ( style & EDITFIELD_STYLE_PASSWORD )
				{
					//Changed the form to create a edit field with password style.							

					WsSetVeEditWindowForm( hWinVEdit, WINDOW_EDITFIELD, 
								EDITFIELD_STYLE_TITLE_AUTOROTATE | EDITFIELD_STYLE_NORMAL | EDITFIELD_STYLE_INDEX | EDITFIELD_STYLE_PASSWORD, 
								MID_SYSBASE, FORM_SYS_VIRTUALEDIT, FORM_ITEM_3 );

					// added EDITFIELD_STYLE_TITLE_TOP in style to have a Password as title					
					hWinVEArea = WsGetVeEditWindow( hWinVEdit );
					pVEditInfo->hWinVEArea = hWinVEArea;
					if(pVEditInfo->iDestLimitLength>0)
					{
						//added to check that the limit length is coming proper
					if(pVEditInfo->iDestLimitLength > EDITFIELD_PASSWORD_MAX_LEN ) 
						pVEditInfo->iDestLimitLength = EDITFIELD_PASSWORD_MAX_LEN;
						// limitting the length of the edit field
					WsSetEditFieldLimitLength( hWinVEArea, pVEditInfo->iDestLimitLength );
					}
					style = WmGetWindowStyle( hWinVEArea );
					
					if((style & EDITFIELD_STYLE_TITLE_TOP)||(style & (EDITFIELD_STYLE_TITLE_LEFT))||(style & (EDITFIELD_STYLE_TITLE_AUTOROTATE)) )
					{
					WmConvert2PCode( mszTitle, sizeof(mszTitle), "PASSWORD" );
					WsSetEditFieldTitle( hWinVEArea, mszTitle );
					}
						//Changed for Adding the option of numerics and symbols for password field: CQ 3485
					WsSetEditFieldCategory( hWinVEArea, F_ALPHA|F_T9|F_QWERTY|F_SYMBOL|F_NUMERIC, TRUE );
					if ( nTextLen > 0 )
						WsSetEditFieldText( hWinVEArea, pmszText );
					SFBalSetEditFieldInputTypeCategory( hWinVEArea, F_HWR, FALSE );
				}
				else
				{
					WsSetEditAreaLimitLength( hWinVEArea, pVEditInfo->iDestLimitLength );
					if(pNativeEdit->m_category)
					{
						WsSetEditAreaCategory( hWinVEArea, pNativeEdit->m_category, TRUE );
					}
					else
					{
						WsSetEditAreaCategory( hWinVEArea, F_ALPHA|F_T9|F_QWERTY|F_SYMBOL|F_NUMERIC, TRUE );
					}	
					if ( nTextLen > 0 )
						WsSetEditAreaText( hWinVEArea, pmszText );
				}
			}
			break;
		case WINDOW_EDITAREA:
			{
				int		nTextLen = 0;

				pVEditInfo->iDestLimitLength = WsGetEditAreaLimitLength( hWinDest );
				pmszText = (MCHAR*)MemAlloc( sizeof(MCHAR)*(pVEditInfo->iDestLimitLength + 1));
				AcMemset( pmszText, 0x00, sizeof(MCHAR)*(pVEditInfo->iDestLimitLength + 1) );
				nTextLen = WsGetEditAreaTextLength( hWinDest );
				if ( nTextLen > 0 )
					WsGetEditAreaText( hWinDest, pmszText, sizeof(MCHAR)*(nTextLen+1) );
				WsSetEditAreaCategory( hWinVEArea, F_ALPHA|F_T9|F_QWERTY|F_SYMBOL|F_NUMERIC, TRUE );
				WsSetEditAreaLimitLength( hWinVEArea, pVEditInfo->iDestLimitLength );
				WsSetEditAreaText( hWinVEArea, pmszText );
	
			}
			break;
		default:
			break;
		}
		if ( pmszText != NULL )
			MemFree( pmszText );
	}

	WmSetFocusWindow( hWinVEdit );

	WmDrawWindow( hWinMain, TRUE );
	WmShowWindow( hWinMain );

//	WkNativeStateSetTopSymbolPopup( TRUE );
	return hWinVEdit;


Catch_Error:

	return INVALID_HOBJ;
}

void
WkNativeSetVEditHandle( HWIN hWin )
{
	if ( pVEditInfo )
	{
		pVEditInfo->hWinVEdit = hWin;
	}

//	if ( hWin == INVALID_HOBJ )
//		WkNativeStateSetTopSymbolPopup( FALSE );

	return;
}

HWIN
WkNativeGetVEditHandle()
{
	if ( pVEditInfo )
	{
		return pVEditInfo->hWinVEdit;
	}

	return INVALID_HOBJ;
}

void
WkNativeSetVEEditorHandle( HWIN hWin )
{
	if (pVEditInfo)
	{
		pVEditInfo->hWinMiniEditor = hWin;
	}

	return;
}

HWIN
WkNativeGetVEEditorHandle()
{
	if ( pVEditInfo )
	{
		return pVEditInfo->hWinMiniEditor;
	}

	return INVALID_HOBJ;
}

void
WkNativeDestroyVEdit()
{
	if ( pVEditInfo )
	{
		//if ( pVEditInfo->hWinVEdit == hWin )
		if(WmIsWindowValid(pVEditInfo->hWinMain))
			WmDestroyWindow( pVEditInfo->hWinMain );
	}

	if ( pVEditInfo )
	{
		MemFree( pVEditInfo );
		pVEditInfo = NULL;
	}
	return;
}

BOOL
WkNativeWsVirtualEditMainRotate( WmState* pState, WmEvent* pEvent )
{
	HWIN	hDestWindow = INVALID_HOBJ;
	int		winStyle = 0;

	hDestWindow = pEvent->key.hDestWindow;

	if( SFBalIsLcdHorizontal( SCREEN_MAIN ) == TRUE )
	{
		winStyle = WmGetWindowStyle( hDestWindow );
		winStyle &= ~MAIN_STYLE_SOFTKEY;
		WmSetWindowStyle( hDestWindow, winStyle );
	}
	else
	{
		winStyle = WmGetWindowStyle( hDestWindow );
		winStyle |= MAIN_STYLE_SOFTKEY;
		WmSetWindowStyle( hDestWindow, winStyle );
	}

	return TRUE;
}

BOOL
WkNativeWsVirtualEditMainExpose( WmState* pState, WmEvent* pEvent )
{
	WmDrawWindow( pEvent->expose.hDestWindow, TRUE );
	WmShowWindow( pEvent->expose.hDestWindow );

	return TRUE;
}

BOOL
WkNativeWsVirtualEditDefaultNotify( WmState* pState, WmEvent* pEvent )
{
	switch ( pEvent->notify.nType )
	{
		case VEDIT_NOTIFY_SELECTED:		// Done
		{
			if(FlipGetDegreeRotated())
				bKeyPadInFocus = true;
			MCHAR	mszText[_BROWSER_MAX_STRING + 1] = {0, };
			int		nTextLen = 0;
			int		nType = -1;
			//Checking the validity of the window "pVEditInfo->hWinDest" :3372
			if(WmIsWindowValid(pVEditInfo->hWinDest))
			{
				if(WmIsWindowValid(pVEditInfo->hWinVEdit))
						{
			nTextLen = WsGetVeEditTextLength( pVEditInfo->hWinVEdit );
			WsGetVeEditText( pVEditInfo->hWinVEdit, mszText, _BROWSER_MAX_STRING  );
						}
			WmGetWindowType( pVEditInfo->hWinDest, &nType );

			switch ( nType )
			{
				case WINDOW_EDITFIELD:
					WsSetEditFieldText( pVEditInfo->hWinDest, mszText );
					break;
				case WINDOW_EDITAREA:
					WsSetEditAreaText( pVEditInfo->hWinDest, mszText );
					break;
				default:
					break;
			}
		}
		}

		//	No break, just destroy widnow
		case VEDIT_NOTIFY_CANCELED:		// Cancel
		{
			//Changes for B0100141808	
			WkNativeSetVEditHandle( INVALID_HOBJ );
			WmDestroyWindow( pVEditInfo->hWinMain );


			if ( pVEditInfo )
			{
				pVEditInfo->hWinMain = INVALID_HOBJ;
					MemFree( pVEditInfo );
					pVEditInfo = NULL;
			}
			// To Rotate back if exiting from Qwerty Mode!
			if( FlipGetDegreeRotated() )
				OemFlipRotateInd(0);
		}
		default:
		break;
	}

	return TRUE;
}

BOOL
WkNativeWsVirtualEditDefaultPressed( WmState* pState, WmEvent* pEvent )
{
/* For CQ  4018 */
	int		length = 0;
	switch ( pEvent->key.keyCode )
	{
	#if defined ( _BROWSER_ENABLED_CLEAR_BACK_KEY )
		case VK_HP_CLEAR:
	#endif
		case VK_HP_RIGHTEASY:
		{
			// To Rotate back if exiting from Qwerty Mode!
/* For CQ 4018 */
			length = WsGetVeEditTextLength( pVEditInfo->hWinVEdit );
			if ( length > 0 )
			{	
				pVEditInfo->hWinExitMessageBox = WsCreateMessageBox( pVEditInfo->hWinMain, MESSAGEBOX_STYLE_YESNO,
														  MESSAGEBOX_ICON_DIALOG,
														  INFINITE,
														  NULL,
														  RsrcLoadString(IDS_COM_POP_CREATEMSG_EXIT_VIRTUAL_KEYBOARD_WITHOUT_SAVING_Q),
														  WmGetEventMap( WkNativeWsVEditExitMsgBoxEventMap ));

				if ( pVEditInfo->hWinExitMessageBox == INVALID_HOBJ )
				{
					SysDebug( (MID_EXCEPTION, "__WsVeCreateExitMessageBox: ExitMessageBox is failed to create\n") );
					return FALSE;
				}				
	
				WmSetFocusWindow(pVEditInfo->hWinExitMessageBox);
				WmDrawWindow(pVEditInfo->hWinExitMessageBox, TRUE);
				WmShowWindow(pVEditInfo->hWinExitMessageBox);				
				break;		
			}
			else
			{

			//Changes for B0100141808	

			WkNativeSetVEditHandle( INVALID_HOBJ );
			WmDestroyWindow( pVEditInfo->hWinMain );
			if ( pVEditInfo )
			{
					pVEditInfo->hWinMain = INVALID_HOBJ;
					MemFree( pVEditInfo );
					pVEditInfo = NULL;
			}
			if( FlipGetDegreeRotated() )
				OemFlipRotateInd(0);
		}
		}
		break;
		case VK_HP_END:
		{
			//Changes for B0100141808	

			WkNativeSetVEditHandle( INVALID_HOBJ );
			WmDestroyWindow( pVEditInfo->hWinMain );
			if ( pVEditInfo )
			{pVEditInfo->hWinMain = INVALID_HOBJ;
					MemFree( pVEditInfo );
					pVEditInfo = NULL;
			}
			// To Rotate back if exiting from Qwerty Mode!
			if( FlipGetDegreeRotated() )
				OemFlipRotateInd(0);
		}
		break;
		default:
			WmCallNextKeyPressedHandler( pState, pEvent );
			break;
	}

	return TRUE;
}

BOOL
WkNativeWsVirtualEditMsgBoxKeyReleased( WmState* pState, WmEvent* pEvent )
{
	

	switch ( pEvent->key.keyCode )
	{
		case VK_HP_LEFTEASY:
		case VK_HP_OK:
		{		

			//Changes for B0100141808	

			WkNativeSetVEditHandle( INVALID_HOBJ );
			WmDestroyWindow( pVEditInfo->hWinMain );
			if ( pVEditInfo )
			{
				pVEditInfo->hWinMain = INVALID_HOBJ;
					MemFree( pVEditInfo );
					pVEditInfo = NULL;
			}
			if( FlipGetDegreeRotated() )
				OemFlipRotateInd(0);
		}
		break;
/* For CQ 4018 */
		case VK_HP_RIGHTEASY:	
		{
			WmDestroyWindow(pVEditInfo->hWinExitMessageBox);
			WmSetFocusWindow(pVEditInfo->hWinVEdit);
			WmDrawWindow(pVEditInfo->hWinMain, TRUE);
			WmShowWindow(pVEditInfo->hWinMain);
			break;
		}

		default:
			WmCallNextKeyPressedHandler( pState, pEvent );
			break;
	}

	return TRUE;
}

BOOL
WkNativeWsVirtualEditForWidgetMsgBoxKeyReleased( WmState* pState, WmEvent* pEvent )
{
	

	switch ( pEvent->key.keyCode )
	{
		case VK_HP_LEFTEASY:
		case VK_HP_OK:
		{		
			NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
			const Document* pDoc =  pNativeEdit->getDocument();
			
			if(Node::ID_TEXTAREA == pDoc->focusedNode()->nodeId())
			{
				HTMLTextAreaElement* pTextArea = static_cast<HTMLTextAreaElement *> (pDoc->focusedNode());
				String strTemp((UChar*)strValue);
				pTextArea->setValue(strTemp);
			}
			else if(Node::ID_INPUT == pDoc->focusedNode()->nodeId())
			{
				HTMLInputElement* pInputElement = static_cast<HTMLInputElement *> (pDoc->focusedNode());
				String strTemp((UChar*)strValue);
				pInputElement->setValue(strTemp);
			}
			
			WkNativeSetVEditHandle( INVALID_HOBJ );
			WmDestroyWindow( pVEditInfo->hWinMain );
			if ( pVEditInfo )
			{
				pVEditInfo->hWinMain = INVALID_HOBJ;
					MemFree( pVEditInfo );
					pVEditInfo = NULL;
			}
			if( FlipGetDegreeRotated() )
				OemFlipRotateInd(0);
		}
		break;
/* For CQ 4018 */
		case VK_HP_RIGHTEASY:	
		{
			WmDestroyWindow(pVEditInfo->hWinExitMessageBox);
			WmSetFocusWindow(pVEditInfo->hWinVEdit);
			WmDrawWindow(pVEditInfo->hWinMain, TRUE);
			WmShowWindow(pVEditInfo->hWinMain);
			break;
		}

		default:
			WmCallNextKeyPressedHandler( pState, pEvent );
			break;
	}

	return TRUE;
}


BOOL WkNativeEditFieldEventTouchReleased(WmState* pState, WmEvent* pEvent)
{
	//SFB00003268
	NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
	if(pNativeEdit && pNativeEdit->isActivated())
	{
		const Document* pDoc =  pNativeEdit->getDocument();
		if(pDoc->page()->isPageLoadingComplete())
	WkNativeWsCreateVirtualEdit( INVALID_HOBJ, pEvent->notify.hDestWindow );
	}
	return true;
}

//ADDED to handle the touch relaesed event for edit area: CQ 3005:Thariq 
//CQ 3322 Fix : Indiatimes
BOOL WkNativeEditAreaEventTouchMove(WmState* pState, WmEvent* pEvent)
{
	bMove = true;
	return true;
}

BOOL WkNativeEditAreaEventTouchReleased(WmState* pState, WmEvent* pEvent)
{
	//CQ 3322 Fix : Indiatimes
	if (!bMove)
	WkNativeWsCreateVirtualEdit( INVALID_HOBJ, pEvent->notify.hDestWindow );
	else
		bMove = false;
	return true;
}

#endif //SFB_BROWSER_NTOUCH_U


#ifdef SUPPORT_AUTO_FORM_FILL

static void GetValuesForAutoComplete()
{
	NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();

	if(pNativeEdit && pNativeEdit->isActivated())
	{
		const Document* pDoc =  pNativeEdit->getDocument();
		ASSERT(pDoc);

		String editFieldName;
		Vector<String> attrValueList;

		for(int j=0; j < pDoc->focusedNode()->attributes()->length(); j++)
		{
			if("name" == pDoc->focusedNode()->attributes()->attributeItem(j)->name())
			{
				editFieldName =	pDoc->focusedNode()->attributes()->attributeItem(j)->value();
				attrValueList = AutoFormFill::GetAllValues(editFieldName);
				break;
			}
		}

	}

	//Send Vector to control
}

static void AutoCompleteRemainingFields(String userName)
{
	NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();

	if(pNativeEdit && pNativeEdit->isActivated())
	{
		const Document* pDoc =  pNativeEdit->getDocument();

		ASSERT(pDoc);

		String editFieldName = "";

		if (pDoc->focusedNode() != NULL  && pDoc->focusedNode()->attributes() != NULL)
		{
			for(int j = 0; j < pDoc->focusedNode()->attributes()->length(); j++)
			{
				if("name" == pDoc->focusedNode()->attributes()->attributeItem(j)->name())
				{
					editFieldName =	pDoc->focusedNode()->attributes()->attributeItem(j)->value();
					break;
				}
			}
		}

		ElementMapType elementMapType;

		String URL (pDoc->frame()->loader()->outgoingReferrer());

		String strFormName = "";

        if(Node::ID_TEXTAREA == pDoc->focusedNode()->nodeId())
        {
            HTMLTextAreaElement* pTextArea = static_cast<HTMLTextAreaElement *> (pDoc->focusedNode());
			strFormName = pTextArea->form()->name();
        }
        else if(Node::ID_INPUT == pDoc->focusedNode()->nodeId())
        {
            HTMLInputElement* pInputElement = static_cast<HTMLInputElement *> (pDoc->focusedNode());

			if(pInputElement && pInputElement->form())
			strFormName = pInputElement->form()->name();
        }
		
		if(NULL == strFormName)
			strFormName = "";
		
			AutoFormFill::StartTransaction(URL,strFormName);


		if("" != editFieldName && "" != userName)
			elementMapType = AutoFormFill::GetValuesOfAllElement(editFieldName,userName);

		String elementName;
		String elementValue;
		String attrName;
		int iValueAttrIndex = INVALID_INDEX;
		bool bIsTypeAttributePresent = false;
		bool bIsElementSupported = false;

		Node *n = pDoc->firstChild();

		while (n)
		{
			if (n && ( (Node::ID_TEXTAREA == n->nodeId()) || (Node::ID_INPUT == n->nodeId()) ) && n->isHTMLElement() && n->hasAttributes() && n != pDoc->focusedNode())
			{
				bIsTypeAttributePresent = false;
				bIsElementSupported = false;
				elementName = "";
				iValueAttrIndex = INVALID_INDEX;

				for(int i = 0; i < n->attributes()->length(); i++)
				{
					attrName = n->attributes()->attributeItem(i)->localName();

					if("type" == attrName)
					{
						bIsTypeAttributePresent = true;

						if(AutoFormFill::IsElementTypeSupported(n->attributes()->attributeItem(i)->value()))
							bIsElementSupported = true;
					}

					if("name" == attrName)
					{
						elementName = n->attributes()->attributeItem(i)->value();
					}
					else if ("value" == attrName)	//chk for "Value" aatr. Store Index
					{
						iValueAttrIndex = i;
					}
				}

				//if "type" attribute is not present then assume "TEXT" input type
				if (true == bIsElementSupported || false == bIsTypeAttributePresent)
				{
					if(!elementName.isEmpty())
					{
						//AutoComplete : NodeName Found. Search in HashMap for value.
						elementValue = elementMapType.get(elementName);

						if(!elementValue.isEmpty())
						{
							AtomicString attrValue(elementValue);

							if (INVALID_INDEX != iValueAttrIndex)
							{
								//If "Value" Attr present replace old value
								//reinterpret_cast<HTMLInputElement *>(n)->setValue(String(attrValue));
								reinterpret_cast<HTMLInputElement *>(n)->setValue(elementValue);
							}
							else
							{
								//Add new "Value" Attr
								AtomicString attrName("value");
								RefPtr<MappedAttribute> a = new MappedAttribute(attrName, attrValue);
								n->attributes()->insertAttribute(a.release(), false);
							}
						}
					}
				}
			}

			n = n->nextLeafNode();
		}
	}
}

#endif //SUPPORT_AUTO_FORM_FILL

// bs0425.lee 2008.04.28 modified to fix edit field.
void NativeEditField:: _sendTextToBrowserEngine()
{

	NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
	if(pNativeEdit && pNativeEdit->isActivated())
	{
		String str = pNativeEdit->getString();
		const Document* pDoc =  pNativeEdit->getDocument();
		ASSERT(pDoc);
        Node* pFocusedNode = pDoc->focusedNode();

        if(pFocusedNode)
        {
            if(Node::ID_TEXTAREA == pFocusedNode->nodeId())
            {
                HTMLTextAreaElement* pTextArea = static_cast<HTMLTextAreaElement *> (pFocusedNode);
                pTextArea->setValue(str);
            }
            else if(Node::ID_INPUT == pFocusedNode->nodeId())
            {
                HTMLInputElement* pInputElement = static_cast<HTMLInputElement *> (pFocusedNode);
                pInputElement->setValue(str);
            }
        }


#ifdef SUPPORT_AUTO_FORM_FILL
		if( pFocusedNode && Node::ID_INPUT == pFocusedNode->nodeId() )
		{
			HTMLInputElement* pInputElement = static_cast<HTMLInputElement *> (pFocusedNode);
			const AtomicString passwd("password");
			if( pInputElement->type() != passwd)
		AutoCompleteRemainingFields(str);
		}
#endif //SUPPORT_AUTO_FORM_FILL

	}
}

/* event callback */
BOOL WkNativeEditFieldEventKeyPressed(WmState* pState, WmEvent* pEvent)
{

	bool fEventAbsorbed = false;
	switch ( pEvent->key.keyCode )
	{
	case VK_HP_OK:
	case VK_HP_UP:
	case VK_HP_DOWN:
		{
			NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
			if(pNativeEdit && pNativeEdit->isActivated())
			{
				pNativeEdit->_sendTextToBrowserEngine();
				pNativeEdit->unsetFocusedNode();
				pNativeEdit->deactivate();
				fEventAbsorbed = true;
			}

		    break;
		}

	case VK_HP_RIGHTEASY:
		{
			NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
			//if(pNativeEdit && pNativeEdit->getString().length() <= 0 )
			if(pNativeEdit && pNativeEdit->isActivated())/*CQ 4026 - tahseen - 24/10/08*/
			{
				pNativeEdit->_sendTextToBrowserEngine();
				pNativeEdit->unsetFocusedNode();
				pNativeEdit->deactivate();
				fEventAbsorbed = true;
			}
			break;
		}
		case VK_HP_LEFTEASY:
		{
			NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
			if(pNativeEdit && pNativeEdit->isActivated())
			{
				pNativeEdit->_sendTextToBrowserEngine();
				pNativeEdit->unsetFocusedNode();
				pNativeEdit->deactivate();
				fEventAbsorbed = true;
//				BrAppControlCreateBrowsingOptionMenu();
			}
			break;
		}
		default:
			break;

	}//end case

	if(!fEventAbsorbed)
	{
		WmCallNextKeyPressedHandler(pState, pEvent);
	}

	return TRUE;
}

BOOL WkNativeEditAreaEventKeyPressed(WmState* pState, WmEvent* pEvent)
{

	bool fEventAbsorbed = false;
	switch ( pEvent->key.keyCode )
	{
	case VK_HP_OK:

		{
			NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
			if(pNativeEdit && pNativeEdit->isActivated())
			{
				pNativeEdit->_sendTextToBrowserEngine();
				pNativeEdit->unsetFocusedNode();
				pNativeEdit->deactivate();
				fEventAbsorbed = true;
			}

		    break;
		}

	case VK_HP_RIGHTEASY:
		{
			NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
			if(pNativeEdit && pNativeEdit->getString().length() <= 0 )
			{
				pNativeEdit->unsetFocusedNode();
				pNativeEdit->deactivate();
				fEventAbsorbed = true;
			}
			break;
		}
		case VK_HP_LEFTEASY:
		{
			NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
			if(pNativeEdit && pNativeEdit->isActivated())
			{
				pNativeEdit->_sendTextToBrowserEngine();
				pNativeEdit->unsetFocusedNode();
				pNativeEdit->deactivate();
				fEventAbsorbed = true;
//				BrAppControlCreateBrowsingOptionMenu();
			}
			break;
		}
		case VK_HP_UP:
		{
				if ( WsEditAreaCursorIsInFirstLine(pEvent->notify.hDestWindow) == FALSE )
				{
					break;
				}
				fEventAbsorbed = true;
				break;


		}
		case VK_HP_DOWN:

			{
				if ( WsEditAreaCursorIsInFirstLine(pEvent->notify.hDestWindow) == FALSE )
				{
					break;
				}
				fEventAbsorbed = true;
				break;

			}
		default:
			break;

	}//end case

	if(!fEventAbsorbed)
	{
		WmCallNextKeyPressedHandler(pState, pEvent);
	}

	return TRUE;

/*	NativeEditField* pNativeEdit = NativeEditField::getNativeEditFieldInstance();
	if ( VK_HP_RIGHTEASY == pEvent->key.keyCode )
	{
		if(pNativeEdit && pNativeEdit->getString().length() <= 0 )
		{
			pNativeEdit->unsetFocusedNode();
			pNativeEdit->deactivate();
			return TRUE;
		}
	}
	else if ( VK_HP_OK == pEvent->key.keyCode )
	{
		if(pNativeEdit && pNativeEdit->isActivated())
		{
			pNativeEdit->_sendTextToBrowserEngine();
			pNativeEdit->unsetFocusedNode();
			pNativeEdit->deactivate();
			return TRUE;
		}
	}

	WmCallNextKeyPressedHandler(pState, pEvent);
	return TRUE;*/


}

static NativeEditField* g_pNativeField = NULL;
NativeEditField* NativeEditField::getNativeEditFieldInstance()
{
	if(NULL == g_pNativeField)
	{
		g_pNativeField = new NativeEditField();
	}

	return g_pNativeField;
}

void NativeEditField::destroyNativeEditFieldInstance()
{
	NativeEditField* pNativeField = NativeEditField::getNativeEditFieldInstance();
	if (pNativeField && pNativeField->isActivated())
	{
		pNativeField->deactivate();
	}
	delete g_pNativeField;
	g_pNativeField = NULL;
}

NativeEditField::NativeEditField() :
	m_handleWin(INVALID_HOBJ),
	m_pDocument(NULL),
	m_nodeID(Node::ID_NONE),
	//m_inputFormatIsNumeric("")
	m_category(0)
{

}

NativeEditField::~NativeEditField()
{
	if(m_handleWin != INVALID_HOBJ)
	{
		deactivate();
	}
}

void NativeEditField::_createEditField(const NativeWidgetAttrib& attrib)
{
	IntRect rect(attrib.m_rect);
	int iEditStyle = EDITFIELD_STYLE_THIN_BORDER;

	int hWin = INVALID_HOBJ;
	int hGC = INVALID_HOBJ;
	//Fix for Cq 3712
	getDocument()->frame()->page()->chrome()->client()->getWindowHandles(&hWin,&hGC);
	WmRect rectTemp;
	WmGetWindowClientRect( hWin, &rectTemp );
	int visibleWidth = rectTemp.w;	
	int visibleHeight =rectTemp.h;

#if defined(SFB_GWES_TRANSFORM)
	float zoomFactor = m_pDocument->page()->chrome()->client()->getZoomFactor();

		int frameRectX = m_pDocument->frame()->view()->contentsX();
		int frameRectY = m_pDocument->frame()->view()->contentsY();

		IntRect viewPortRect = m_pDocument->page()->chrome()->client()->viewportRect();

		rect.setX((rect.x() - (viewPortRect.x() - frameRectX)) * zoomFactor);
		rect.setY((rect.y() - (viewPortRect.y() - frameRectY)) * zoomFactor);

		rect.setWidth(rect.width() * zoomFactor);

		if(rect.x() < 0)
		{
			//reduce the width by the length which is hidden
			rect.setWidth(rect.width() + rect.x());
			rect.setX(0);
		}
		if(rect.x() <= 0)
		{
		if((rect.width() + rect.x()) > visibleWidth - SCROLLWIDTH)
			rect.setWidth(visibleWidth - rect.x()- SCROLLWIDTH);
		}

		rect.setHeight(rect.height() * zoomFactor);
	
#endif

	if(attrib.m_isPassword)
	 iEditStyle |= EDITFIELD_STYLE_PASSWORD;
	else
	 iEditStyle |= EDITFIELD_STYLE_NORMAL;

	 iEditStyle |= EDITFIELD_STYLE_NO_BACKGROUND;
	 //B0100135759 issue in Poland database: Hema
	#ifdef EF_FREESIZE
	 iEditStyle |=EDITFIELD_STYLE_FREE_SIZE;
	#endif
	if((WmIsWindowValid(hWin)) && (rect.width()>0) && ( rect.height()>0))
	{
	m_handleWin = WsCreateEditField ( hWin, iEditStyle, rect.x(), rect.y(), rect.width(), rect.height(), WmGetEventMap(WkNativeEditFieldEventMap) );
	if(attrib.m_maxLength > _BROWSER_MAX_STRING)/* Tahseen 17/10/08 - Edit Field Len Max*/ 
	{
		WsSetEditFieldLimitLength(m_handleWin, _BROWSER_MAX_STRING);
	}
	else
	{
	WsSetEditFieldLimitLength(m_handleWin, attrib.m_maxLength);
	}
	RenderStyle* style = attrib.m_pStyle;

	FontDescription fontDesc = style->fontDescription();
	FontPlatformData fontData(fontDesc, fontDesc.family().family());

	WmSetWindowFont(m_handleWin, fontData.getFontHandle());

	if(attrib.m_strValue.length())
	{
		String strVal(attrib.m_strValue);
		WsSetEditFieldText (m_handleWin, (MCHAR *) ( strVal.charactersWithNullTermination()) );
		WsSetEditFieldCursorPos(m_handleWin, attrib.m_cursorOffset);
	}

	WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_ALPHA);

	SFBalSetEditFieldInputAlphabetMode(m_handleWin, EDIT_LETTERMODE_SMALL);

	}

	m_nodeID = Node::ID_INPUT;
	
}

void NativeEditField::_createEditArea(const NativeWidgetAttrib& attrib)
{
	//int x=0; //Sneha. Change done for demo. Need to revert back later
	IntRect rect(attrib.m_rect);
	
	int hWin = INVALID_HOBJ;
	int hGC = INVALID_HOBJ;
	
	getDocument()->frame()->page()->chrome()->client()->getWindowHandles(&hWin,&hGC);
	WmRect rectTemp;
	WmGetWindowClientRect( hWin, &rectTemp );
	int visibleWidth = rectTemp.w;	
	int visibleHeight =rectTemp.h;
	//int visibleWidth = m_pDocument->frame()->view()->visibleWidth();
	//int visibleHeight = m_pDocument->frame()->view()->visibleHeight();

#if defined(SFB_GWES_TRANSFORM)
	float zoomFactor = m_pDocument->page()->chrome()->client()->getZoomFactor();

		int frameRectX = m_pDocument->frame()->view()->contentsX();
		int frameRectY = m_pDocument->frame()->view()->contentsY();
		
		IntRect viewPortRect = m_pDocument->page()->chrome()->client()->viewportRect();

		rect.setX((rect.x() - (viewPortRect.x() - frameRectX)) * zoomFactor);
		rect.setY((rect.y() - (viewPortRect.y() - frameRectY)) * zoomFactor);

		rect.setWidth(rect.width() * zoomFactor);
		
		if(rect.x() < 0)
		{
			//reduce the width by the length which is hidden
			rect.setWidth(rect.width() + rect.x());
			rect.setX(0);
		}
		if((rect.width() + rect.x()) > visibleWidth)
			rect.setWidth(visibleWidth - rect.x());

		rect.setHeight(rect.height() * zoomFactor);
	
#endif

	//added a variable height/Width which adjusts its value if the height is greater than visibleHeight/visibleWidth otherwise its kept same.
	//this is done so that user can deactivate the edit box.- Hema for CQ bug 1883
	int Height=0;
	int Width =0;
	if( (rect.height() + rect.y() ) > visibleHeight)
	{
		//Reduces the Height of the edit box if it is greater than visible Height.CQ bug 1883
		Height = 0.75 * visibleHeight ;
	}
	else
		Height= rect.height();
	
	if( (rect.width() + rect.x() ) > visibleWidth)
	{
		//Reduces the width of the edit box if it is greater than visible width.CQ bug 1883
		Width = 0.75 * visibleWidth;
	}
	else
	Width = rect.width();
	//Minimum width required to draw the edit area, below this width edit area will not be drawn.: CQ 4213 Hema
	if(MINIMUM_WIDTH_REQUIRED_EDITAREA < Width)
	{
	//Keeping the minimum value of height and width for edit area CQ 2527: Hema
	if(Width < MINIMUM_WIDTH_AND_HEIGHT_EDITAREA)
	{	
		Width = MINIMUM_WIDTH_AND_HEIGHT_EDITAREA;
		 rect.setWidth(MINIMUM_WIDTH_AND_HEIGHT_EDITAREA);
	}
	if(Height < MINIMUM_WIDTH_AND_HEIGHT_EDITAREA)
	{
		Height = MINIMUM_WIDTH_AND_HEIGHT_EDITAREA;
		 rect.setHeight(MINIMUM_WIDTH_AND_HEIGHT_EDITAREA);
	}
	}
	
	//Making the width and height as positive if in some case it goes negative.(fail safe)
	if( 0 > Width )
			Width *= -1;
	if( 0 > Height )
			Height *= -1;
	
	int iEditStyle = EDITAREA_STYLE_NOINDEX | EDITAREA_STYLE_DRAW_BORDER;

	//Minimum width required to draw the edit area, below this width edit area will not be drawn.: CQ 4213
	if(Width > MINIMUM_WIDTH_REQUIRED_EDITAREA  && Height > 0) // Fail safe check
	{
    /* int hWin = INVALID_HOBJ;
	int hGC = INVALID_HOBJ;
	getDocument()->frame()->page()->chrome()->client()->getWindowHandles(&hWin,&hGC);*/

	m_handleWin = WsCreateEditArea ( hWin, iEditStyle, rect.x(), rect.y(), Width, Height, WmGetEventMap(WkNativeEditAreaEventMap) );

	bMove = false;			//CQ 3322 Fix : Indiatimes

	//WsSetEditAreaLimitLength(m_handleWin, attrib.m_maxLength);
	if(attrib.m_maxLength > _BROWSER_MAX_STRING)/* Tahseen 17/10/08 - Edit Field Len Max*/ 
	{
		WsSetEditAreaLimitLength(m_handleWin, _BROWSER_MAX_STRING);
	}
	else
	{
	WsSetEditAreaLimitLength(m_handleWin, attrib.m_maxLength);
	}

	RenderStyle* style = attrib.m_pStyle;
	//WsSetEditAreaBgColor(m_handleWin, RGB565Ex( style->backgroundColor().rgb() ) );
	//WsSetEditAreaFontColor(m_handleWin, YELLOW );

	FontDescription fontDesc = style->fontDescription();
	FontPlatformData fontData(fontDesc, fontDesc.family().family());
	WsSetEditAreaFont(m_handleWin, fontData.getFontHandle());

	if(attrib.m_strValue.length())
	{
		String strVal(attrib.m_strValue);
		WsSetEditAreaText (m_handleWin, (MCHAR *) ( strVal.charactersWithNullTermination()) );
		WsSetEditAreaCursorPos(m_handleWin, attrib.m_cursorOffset);
	}

	WsSetEditAreaInputMode(m_handleWin, EDIT_INPUTMODE_ALPHA);

	m_nodeID = Node::ID_TEXTAREA;
	}
}

void NativeEditField::_createEditFieldText(const NativeWidgetAttrib& attrib)
{
	
	IntRect rect(attrib.m_rect);
	int iEditStyle = EDITFIELD_STYLE_THIN_BORDER;

	int hWin = INVALID_HOBJ;
	int hGC = INVALID_HOBJ;

	//Fix for Cq 3712
	getDocument()->frame()->page()->chrome()->client()->getWindowHandles(&hWin,&hGC);
	WmRect rectTemp;
	WmGetWindowClientRect( hWin, &rectTemp );
	int visibleWidth = rectTemp.w;	
	int visibleHeight =rectTemp.h;


#if defined(SFB_GWES_TRANSFORM)
	float zoomFactor = m_pDocument->page()->chrome()->client()->getZoomFactor();

		int frameRectX = m_pDocument->frame()->view()->contentsX();
		int frameRectY = m_pDocument->frame()->view()->contentsY();

		IntRect viewPortRect = m_pDocument->page()->chrome()->client()->viewportRect();

		rect.setX((rect.x() - (viewPortRect.x() - frameRectX)) * zoomFactor);
		rect.setY((rect.y() - (viewPortRect.y() - frameRectY)) * zoomFactor);

		rect.setWidth(rect.width() * zoomFactor);
		
		if(rect.x() < 0)
		{
			//reduce the width by the length which is hidden
			rect.setWidth(rect.width() + rect.x());
			rect.setX(0);
		}
		if(rect.x() >= 0)
		{
		if((rect.width() + rect.x()) > visibleWidth- SCROLLWIDTH)
			rect.setWidth(visibleWidth - rect.x()- SCROLLWIDTH);
		}

		rect.setHeight(rect.height() * zoomFactor);
	
#endif

	 iEditStyle |= EDITFIELD_STYLE_NORMAL;

	 iEditStyle |= EDITFIELD_STYLE_NO_BACKGROUND;
	//B0100135759 issue in Poland database.: Hema
	#ifdef EF_FREESIZE
	 iEditStyle |= EDITFIELD_STYLE_FREE_SIZE;
	#endif
	if((WmIsWindowValid(hWin)) && (rect.width()>0) && ( rect.height()>0))
	{
m_handleWin = WsCreateEditField ( hWin, iEditStyle, rect.x(), rect.y(), rect.width(), rect.height(), WmGetEventMap(WkNativeEditFieldEventMap) );
    	
	//WsSetEditFieldLimitLength(m_handleWin, attrib.m_maxLength);

	if(attrib.m_maxLength > _BROWSER_MAX_STRING)/* Tahseen 17/10/08 - Edit Field Len Max*/ 
	{
		WsSetEditFieldLimitLength(m_handleWin, _BROWSER_MAX_STRING);
	}
	else
	{
	WsSetEditFieldLimitLength(m_handleWin, attrib.m_maxLength);
	}

	RenderStyle* style = attrib.m_pStyle;

	FontDescription fontDesc = style->fontDescription();
	FontPlatformData fontData(fontDesc, fontDesc.family().family());
         WmSetWindowFont(m_handleWin, fontData.getFontHandle());
	if(attrib.m_strValue.length())
	{
		String strVal(attrib.m_strValue);
		WsSetEditFieldText (m_handleWin, (MCHAR *) ( strVal.charactersWithNullTermination()) );
		WsSetEditFieldCursorPos(m_handleWin, attrib.m_cursorOffset);
	}
	//Nataraj - fix for B0100137742
		String css = attrib.m_inputFormat.deprecatedString();
		const UChar *cssPropertyValue = css.charactersWithNullTermination();
		if ( cssPropertyValue != NULL ) 
		{
			if ( cssPropertyValue[0] == 'N' )
				WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_NUMERIC);
			//NATARAJ  - for bug SFB00001279
			else if (( attrib.m_inputFormat == "*N") || (attrib.m_inputFormat == "*n"))
				WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_NUMERIC);
			else if ( attrib.m_inputFormat == "*a")
			{
				WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_ALPHA);
				SFBalSetEditFieldInputAlphabetMode( m_handleWin, EDIT_LETTERMODE_SMALL );
			}
			else if ( attrib.m_inputFormat == "*A")
			{
				WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_ALPHA);
				SFBalSetEditFieldInputAlphabetMode( m_handleWin, EDIT_LETTERMODE_CAPITAL );
			}
			else if( attrib.m_inputFormat == "*x")
			{
				WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_ALPHA);
				SFBalSetEditFieldInputAlphabetMode( m_handleWin, EDIT_LETTERMODE_SMALL );
			}
			else if( attrib.m_inputFormat == "*X")
			{
				WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_ALPHA);
				SFBalSetEditFieldInputAlphabetMode( m_handleWin, EDIT_LETTERMODE_CAPITAL );
			}
			else if(WTF::isASCIIDigit(cssPropertyValue[0]))
			{
				int count = 0;//(int)cssPropertyValue[0] - '0';
				char szLen[4] = {0x00,0x00,0x00,0x00};
				int idx = 0;
				for (;idx < 4;idx++)
				{
					if (WTF::isASCIIDigit(cssPropertyValue[idx]))
						szLen[idx] = cssPropertyValue[idx];
					else 
						break;
				}
				count = AcAtoi(szLen);
				WsSetEditFieldLimitLength(m_handleWin, count);
				switch(cssPropertyValue[idx])
				{
					case 'a': 
					case 'x': 
					case 'm': 
						{
							SFBalSetEditFieldInputAlphabetMode( m_handleWin, EDIT_LETTERMODE_SMALL );
							WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_ALPHA);
							break;
						}
					case 'A': 
					case 'X': 
					case 'M': 
						{
							SFBalSetEditFieldInputAlphabetMode( m_handleWin, EDIT_LETTERMODE_CAPITAL );
							WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_ALPHA);
							break;
						}

					case 'n': 
					case 'N': 
						{
							WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_NUMERIC);
							break;
						}
					default:
						{
							WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_ALPHA);
						}
				}
			}
			else
				WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_ALPHA);

			/* Set the Categoty */
			WsEditCategory category = 0;
			for(int i = 0; cssPropertyValue[i] != '\0'; i++)
			{
				switch(cssPropertyValue[i])
				{
				case 'a': 
				case 'A':
						category = category | F_ALPHA | F_SYMBOL;
						break;
				case 'n':
				case 'N':
						category |= F_NUMERIC;
						WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_NUMERIC);
						break;
				case 'x':
				case 'X':
						category = category | F_ALPHA | F_NUMERIC | F_SYMBOL;
						break;
				case 'm':
				case 'M':
						category = 	F_ALPHA | F_T9 | F_NUMERIC | F_SYMBOL | F_QWERTY ;
						break;
				default: ;
				}
			}
			m_category = category;

		}
		else
				WsSetEditFieldInputMode(m_handleWin, EDIT_INPUTMODE_ALPHA);

		m_nodeID = Node::ID_INPUT;
	}
	
}

void NativeEditField::activate(const NativeWidgetAttrib& attrib)
{
        m_pDocument = attrib.m_pDocument;

	int hWin = INVALID_HOBJ;
	int hGC = INVALID_HOBJ;

	getDocument()->page()->chrome()->client()->getWindowHandles(&hWin,&hGC);

	ASSERT(INVALID_HOBJ == m_handleWin);
	ASSERT(attrib.m_pStyle);

	// Incase of widgets, the widget window may not be the focus window
	// In a browser instance,the browser window is the focus window
	// So this is a widget specific change
	// For widgets we are directly creating the virtual keypad instead of activating the edit field
	///* Fix for BugID - SFB00000341*/
#ifdef SFB_WIDGET
	HWIN hFocusedWnd = WmGetFocusWindow();

	//if(hFocusedWnd != hWin)
	if (getDocument()->page()->chrome()->client()->isOneClickMode())//CQ4515 fix
	{
		WkNativeWsCreateVirtualEditForWidget(attrib);
		return;
	}
#endif

	//To enable edit field in case of landscape view: CQ 3494&3496
	////vamsi landscape support - TODO Callback needs to be registered to UI via chrome client
	//{
	//	MCHAR	mszText[50], mszOK[5];
	//	WmConvert2PCode( mszText, sizeof ( mszText ), "Text Entry Not Supported in Landscape Mode" );
	//	WmConvert2PCode( mszOK, sizeof ( mszOK ), "OK" );

	//	if(PhsGetStatus(PS_LCDTYPE) == PHS_LCD_HORIZONTAL)
	//	{
	//		WsCreateModalMessageBoxEx( WmGetParentWindow(hWin), MESSAGEBOX_ICON_WARNING, 2000, NULL,
	//		mszText, mszOK, NULL, NULL );
	//		return;
	//	}
	//}

	m_nodeID = attrib.m_nodeID;

	if(attrib.m_isPassword)
	{
		_createEditField(attrib);
	}
	else
	{
		if(m_nodeID==Node::ID_INPUT)
			_createEditFieldText(attrib);
		else
			_createEditArea(attrib);

	}

    //checking if m_handleWin is valid, if not we are defocusiing the node.
	if(WmIsWindowValid(m_handleWin))
			WmSetFocusWindow(m_handleWin);
	else
			unsetFocusedNode();
	//WmShowWindow(gHWin);//not required here as we are doing show window in Webcontrol::showScreen()//sneha
}
void NativeEditField::deactivate( bool bShow )
{

	WkNativeDestroyVEdit();

	if(WmIsWindowValid(m_handleWin))
	{
         	int hWin = INVALID_HOBJ;
	int hGC = INVALID_HOBJ;

        Frame* frame = getDocument() ? getDocument()->frame() : NULL;
        if(frame)
        {
	        frame->page()->chrome()->client()->getWindowHandles(&hWin,&hGC);
        }

	WmDestroyWindow(m_handleWin);

	if( bShow )
	{
        if(INVALID_HOBJ != hWin)
        {
		WsDrawMainSoftKey(WmGetParentWindow(hWin));
		WsShowMainSoftKey(WmGetParentWindow(hWin));
		WsDrawIndicatorInputMode(WmGetParentWindow(hWin));
		WsShowIndicatorInputMode(WmGetParentWindow(hWin));
        }
	}

	m_handleWin = INVALID_HOBJ;
	m_pDocument = NULL;
	m_nodeID    = Node::ID_NONE;
	m_category  = 0;
	}
}

bool NativeEditField::isActivated() const
{
	return (INVALID_HOBJ != m_handleWin) ? true : false;
}

String NativeEditField::getString() const
{
	String str("");

	int iLen = 	(Node::ID_INPUT == m_nodeID) ? WsGetEditFieldTextLength(m_handleWin) : WsGetEditAreaTextLength(m_handleWin);

	if(iLen > 0)
	{
        MCHAR* pszStr = (MCHAR*) MemoryManager::Alloc(sizeof(MCHAR) * (iLen + 1));
		ASSERT(pszStr);
		AcMemset(pszStr, 0, sizeof(MCHAR) * (iLen + 1));

		(Node::ID_INPUT == m_nodeID) ? WsGetEditFieldText(m_handleWin, pszStr, iLen) : WsGetEditAreaText(m_handleWin, pszStr, iLen);

		String str( (const UChar *) pszStr);

		MemoryManager::Free(pszStr);
		pszStr = NULL;

		return str;
	}

    return String("");
}
# if PLATFORM(SHP)
bool NativeEditField::isVKeyPadActivated()
{
	HWIN hWin = WkNativeGetVEEditorHandle();
	if ( hWin != INVALID_HOBJ )
	{
		if (WmIsWindowValid(hWin))
		{
			return true;
		}		
	}
	return false;
}

bool NativeEditField::isKeyPadInFocus()
{
	return bKeyPadInFocus;
}
void NativeEditField::resetKeyPadFocusFlag()
{
	bKeyPadInFocus = false;
}
# endif

void NativeEditField::unsetFocusedNode(bool bShow)
{
	if(m_pDocument)
	{
		//Changes done for cq bug 2092 - Hema

		if(isActivated())  
		{
		FrameView* view = m_pDocument->frame()->view();
		while (view->parent())
		{
			view = static_cast<FrameView*>(view->parent());
		}
		
		if( bShow )
		view->update();
		}
		// defocussed after updating the FrameView.
		m_pDocument->page()->focusController()->setFocusedNode(0, m_pDocument->frame());

	}
}

#ifdef SFB_GLOBAL_STATIC_HANDLING
void initNativeEditFieldGlobals()
{
    g_pNativeField = NULL;
}
#endif

}  // namespace WebCore


#endif //#ifdef USE_NATIVE_WIDGET_SUPPORT

