#include "shp.h"
#include "GWES.h"
#include "SFBDrawWidget.h"
#define INVALID_COLOR	( (COLOR) -1 )

#define SFB_LINK_COLOR			0x001f
#define SFB_POINT_COLOR	BLACK
#define SFB_CHAR_SMALL_XX		0
#define SFB_CHAR_SMALL_X		1
#define SFB_CHAR_SMALL			2
#define SFB_CHAR_NORMAL			3
#define SFB_CHAR_BIG			4
#define SFB_CHAR_BIG_X			5




int SFBGetCharWidth(char chIn, int size, int bold, int italic, int underline)
{
	char buf[2*3];
	MCHAR mbuf[2];
	int	 width,height;
	HFNT	font;

	return 8;

	buf[0] = chIn;
	buf[1] = 0;

	/* get suitable font */
	font = SFBGetFont( size, bold, italic, underline, FALSE );

	WmConvert2PCode(mbuf, sizeof(mbuf), buf);
	WmGetTextExtent(font, mbuf, &width, &height);

	return width;
}
void SFBDrawRect(HGC hGC,int x1, int y1, int x2, int y2, int thickness, COLOR color)
{	
	COLOR colorOld;

	WmGetFgColor(hGC, &colorOld);
	if ( color == INVALID_COLOR)
		color = BLACK;
	WmSetFgColor(hGC, color);
	if (thickness == 0)
		WmSetLineWidth(hGC,1);
	else
		WmSetLineWidth(hGC,2);

}

void
SFBDrawText( HGC hGC,int x, int y, char* szText, int size, BOOL bBold, BOOL bItalic, BOOL bUnderline, 
		   BOOL bLink, BOOL bFocused, COLOR color, COLOR bgColor )
{
	
	MCHAR	mszText[50];
	MCHAR	mbuf[1024];
	MCHAR*  pText = NULL;
	UCHAR*	pSrc = (UCHAR*)szText;
	int			width, height, len1, len2;
	
	if ( szText == NULL ) return;
	
	/* get suitable font */
	WmSetFont(hGC,FONT_12_NORMAL);
	
	len1 = len2 = AcStrlen( szText );
	pText = mbuf;
	//WmConvert2PCode( mbuf,  len1,( UCHAR* )szText);
	WmGetGCTextExtent(hGC, mbuf, &width, &height);

	if ( width <= 0 || height <= 0 )  return;

	/* reverse color if pointed */
	if ( bFocused )
	{
		WmSetFgColor(hGC, WHITE);

		if ( color != INVALID_COLOR ) WmSetBgColor( hGC, ( unsigned short )color );
		else WmSetBgColor( hGC,LIGHTGRAY  );
	}

	WmConvert2PCode( mszText, sizeof(mszText),( UCHAR* )szText);
	WmDrawText(hGC,x,y,mszText);

	/* restore color*/
	WmSetFgColor(hGC,BLACK);
	WmSetBgColor(hGC,WHITE);
}
int
SFBGetFont( int size, BOOL bBold, BOOL bItalic, BOOL bUnderline, BOOL bLink )
{
	/* check size */
	if ( size == SFB_CHAR_SMALL_XX )
	{
		if ( bItalic )
		{
			return FONT_12_ITALIC;
		}
		else if ( bBold )
		{
			return FONT_12_BOLD;
		}
		else
		{
			return FONT_12_NORMAL;
		}
	}
	else if (size == SFB_CHAR_SMALL_X)
	{
		if ( bItalic )
		{
			return FONT_14_ITALIC;
		}
		else if ( bBold )
		{
			return FONT_14_BOLD;
		}
		else
		{
			return  FONT_14_NORMAL;
		}
	}
	else if (size == SFB_CHAR_SMALL)
	{
		if ( bItalic )
		{
			return FONT_16_ITALIC;
		}
		else if ( bBold )
		{
			return FONT_16_BOLD;
		}
		else
		{
			return FONT_16_NORMAL;
		}
	}
	else if (size == SFB_CHAR_NORMAL)
	{
		if ( bItalic )
		{
			return FONT_18_ITALIC;
		}
		else if ( bBold )
		{
			return FONT_18_BOLD;
		}
		else
		{
			return  FONT_18_NORMAL;
		}
	}
	else if (size == SFB_CHAR_BIG)
	{
		if ( bItalic )
		{
			return FONT_20_ITALIC;
		}
		else if ( bBold )
		{
			return FONT_20_BOLD;
		}
		else
		{
			return  FONT_20_NORMAL;
		}
	}
	else if (size == SFB_CHAR_BIG_X)
	{
		if ( bItalic )
		{
			return FONT_24_ITALIC;
		}
		else if ( bBold )
		{
			return FONT_24_BOLD;
		}
		else
		{
			return FONT_24_NORMAL;
		}
	}

	return FONT_18_NORMAL;
}

int	 SFBGetTextWidth(char* szIn, int size, int bold, int italic, int underline)
{
	MCHAR mbuf[260];
	char  buf[260*3];
	UCHAR*	pSrc = NULL;
	MCHAR*  pText = NULL;
	int	 width,height, len;
	HFNT	font=INVALID_HOBJ;
	int		length;	

	// get suitable font
	font = SFBGetFont( size, bold, italic, underline, FALSE);

	length = AcStrlen(szIn);
	if (length >= 256)
	{
		length = 256;
		AcStrncpy(buf, szIn, length-1);
		buf[length-1] = '\0';//0;
	}
	else
	{
		AcStrncpy(buf, szIn, length);
		buf[length] = '\0';//0;
	}

	pSrc = ( UCHAR* )buf;
	pText = mbuf;
	len = length;

	WmConvert2PCode( mbuf, len ,pSrc);

	WmGetTextExtent(font,mbuf,&width, &height);
	return width;
}

void 
SFBDrawFillRect(HGC hGC,int x1, int y1, int x2, int y2, int color)
{
	if(y2-y1 <=0 || x2-x1<=0)
		return;
	if(color == INVALID_COLOR)
		WmClearGCRectArea(hGC,x1,y1,x2-x1,y2-y1); 
	else
	{
		WmDrawFilledRect(hGC, (unsigned short)color, x1,y1,x2-x1,y2-y1);		
	}
}

void
SFBDrawLine(HGC hGC,int x1, int y1, int x2, int y2, int width, COLOR color, int style )
{

	UCHAR	pattern[20];
	char	mask = ( char )0x80;
	int		length, index, i;
		
	AcMemset( pattern, 0, sizeof( pattern ) );

	WmSetLineWidth(hGC,width);
	if( color != INVALID_COLOR)
		WmSetFgColor(hGC, color);
	if ( style == SFB_BORDER_STYLE_DOTTED || style == SFB_BORDER_STYLE_DASHED )
	{
		if ( style == SFB_BORDER_STYLE_DOTTED )
		{
			length = width * 2;
			index = 0;
			for ( i = 0; i < width; i++ )
			{
				pattern[index] |= ( char )( mask >> ( i % 8 ) );
				if ( i > 0 && ( i % 8 ) == 0 ) index++;
			}
		}
		else if ( style == SFB_BORDER_STYLE_DASHED )
		{
			length = width * 3;
			index = 0;
			for ( i = 0; i < width*2; i++ )
			{
				pattern[index] |= ( char )( mask >> ( i % 8 ) );
				if ( i > 0 && ( i % 8 ) == 0 ) index++;
			}
		}
		WmSetLineType( hGC, LINE_DASH );
		WmSetDashLineInfo( hGC, length, pattern );
	}
//verifying the value of hGC before passing it to WmDrawLine
	if (( hGC != INVALID_HOBJ) && (WmVerifyGC(hGC) == TRUE ))
{
	if(x1 != x2) 
	WmDrawLine(hGC,x1,y1,x2,y2);
		else
	{
	if (y1 != y2)
	WmDrawLine(hGC,x1,y1,x2,y2);
	}

	WmSetLineType( hGC, LINE_SOLID );
	WmSetLineWidth(hGC,1);
	WmSetFgColor(hGC, BLACK);
	}
}
void SFBDrawButton(HGC hGC,int x1, int y1, int x2, int y2, char* szText, int isPointed, int colorBg)
{	
	int idx=0;
	int	isOverSize = FALSE;
	int	buttonWidth = x2-x1 -1 ;
	int	offset2 = SFBGetTextWidth("", SFB_CHAR_BIG, FALSE,FALSE,FALSE);
	int	strWidth = SFBGetTextWidth(szText, SFB_CHAR_BIG, FALSE,FALSE,FALSE);
	char buf[256];
	
	x2 -= 1;

	AcMemset(buf, 0, sizeof(char)*256);

	if (strWidth >= x2 - x1)
		isOverSize = TRUE;

	if (isOverSize)	
	{
		for (idx = 0, strWidth = 0; szText[idx]; idx++)
		{				
			buf[idx] = szText[idx];
			strWidth += SFBGetCharWidth(szText[idx],SFB_CHAR_BIG,FALSE,FALSE,FALSE);
			if ( strWidth + offset2 >= buttonWidth)
				break;							
		}

		//buf[idx] = '.';
		//buf[idx + 1] = '.';
		buf[idx +0] = ' ';
		//buf[idx + 1] = 0;
	}	
	else
		AcStrcpy(buf,szText);
	
	if (isPointed==1)
		SFBDrawFillRect(hGC,x1,y1,x2,y2, DARKGRAY);
	else
		SFBDrawFillRect(hGC,x1,y1,x2,y2, LIGHTGRAY);

	SFBDrawLine(hGC,x1, y1+1, x2-1, y1+1, 2,   WHITE, SFB_BORDER_STYLE_SOLID );
	SFBDrawLine(hGC,x1+1, y1+1, x1+1, y2-1, 2, WHITE, SFB_BORDER_STYLE_SOLID );
	
	SFBDrawLine(hGC,x1+1, y2-1, x2-1, y2-1, 2, DARKGRAY, SFB_BORDER_STYLE_SOLID );
	SFBDrawLine(hGC,x2-1, y1+1, x2-1, y2-1, 2, DARKGRAY, SFB_BORDER_STYLE_SOLID );

	SFBDrawLine(hGC,x1, y2-1, x2-1, y2-1, 1, DARKGRAY, SFB_BORDER_STYLE_SOLID );
	SFBDrawLine(hGC,x2-1, y1, x2-1, y2-1, 1, DARKGRAY, SFB_BORDER_STYLE_SOLID );

	SFBDrawLine(hGC,x1, y2, x2, y2, 1, BLACK, SFB_BORDER_STYLE_SOLID );
	SFBDrawLine(hGC,x2, y1, x2, y2, 1, BLACK, SFB_BORDER_STYLE_SOLID );

	SFBDrawText(hGC,x1 + (x2-x1-strWidth),y1 + 3, buf, 1, 0, 0, 0, FALSE, FALSE, BLACK, (COLOR)(-1));
	if (isPointed)
		SFBDrawRect(hGC,x1,y1,x2,y2,0,colorBg);
}
/*(x2-x1-strWidth)/2*/
