/*
* ==============================================================================
*  Name        : HttpLoader.cpp
*  Part of     : WebKit / ResourceLoader
*  Interface   : 
*  Description : Implementation of HttpLoader
*  Version     : %Version%
* ==============================================================================
*/

// INCLUDE FILES
#include "types.h"
#include "HttpLoader.h"
#include "HttpTransaction.h"
#include "ContentDispatcher.h"

// EXTERNAL DATA STRUCTURES

// EXTERNAL FUNCTION PROTOTYPES

// CONSTANTS
//

// MACROS

// LOCAL CONSTANTS AND MACROS

// MODULE DATA STRUCTURES

// LOCAL FUNCTION PROTOTYPES

// FORWARD DECLARATIONS

// ============================= LOCAL FUNCTIONS ===============================


// ============================ MEMBER FUNCTIONS ===============================

// -----------------------------------------------------------------------------
// HttpLoader::HttpLoader
// C++ default constructor
// -----------------------------------------------------------------------------
//
HttpLoader::HttpLoader(ContentDispatcher* _contentDispatcher, WebKitLoader *pWebkitLoader ):
			UrlLoader( _contentDispatcher ), m_pWebkitLoader( pWebkitLoader )
    {
    }

// Destructor
HttpLoader::~HttpLoader()
    {
    Close();
    }


// -----------------------------------------------------------------------------
// HttpLoader::Headers
// 
// 
// -----------------------------------------------------------------------------
//
eErrorCode HttpLoader::Headers( BaseTransaction* _transaction, UrlResponseInfo* _response )
    {
    return UrlLoader::Headers( _transaction, _response );
    }

// -----------------------------------------------------------------------------
// HttpLoader::Request
//
//
// -----------------------------------------------------------------------------
//
eErrorCode HttpLoader::Request(UrlRequestInfo* _requestInfo )
    {
    return UrlLoader::Request( _requestInfo );
    }


// -----------------------------------------------------------------------------
// HttpLoader::Close
//
//
// -----------------------------------------------------------------------------
//
void HttpLoader::Close()
    {
        CancelAll();
    }

// -----------------------------------------------------------------------------
// HttpLoader::HandleError
//
//
// -----------------------------------------------------------------------------
//
bool HttpLoader::HandleError(
    BaseTransaction* _transaction,
    eHttpStatus _error )
    {
    return UrlLoader::HandleError( _transaction, _error );
    }

// -----------------------------------------------------------------------------
// HttpLoader::CancelAll
//
//
// -----------------------------------------------------------------------------
//
eErrorCode HttpLoader::CancelAll(eErrorCode _error )
    {
    return UrlLoader::CancelAll( _error );
    }


// -----------------------------------------------------------------------------
// HttpLoader::CreateTransaction
//
//
// -----------------------------------------------------------------------------
//
BaseTransaction* HttpLoader::CreateTransaction(UrlRequestInfo* _urlRequestInfo )
    {
    return new HttpTransaction( _urlRequestInfo, this);
    }

//  End of File

