    /*
* ==============================================================================
*  Name        : FileTransaction.cpp
*  Part of     : WebKit / ResourceLoader
*  Interface   :
*  Description : Implementation of FileTransaction
*  Version     : %Version%
*/

// INCLUDE FILES
#include "types.h"
#include "FileTransaction.h"
#include "TransactionManager.h"
#ifdef __CMM__
#include <AnsiCLib.h>
# else 
#include "Shp.h"
# endif



#ifdef __CMM__
#include <allocs.h>
#endif

#ifdef USE_CURL
typedef class TransactionManagerCURL TransactionManager;
#endif

// EXTERNAL DATA STRUCTURES

// EXTERNAL FUNCTION PROTOTYPES

// CONSTANTS

// MACROS

// LOCAL CONSTANTS AND MACROS

// MODULE DATA STRUCTURES

// LOCAL FUNCTION PROTOTYPES

// FORWARD DECLARATIONS

// ============================= LOCAL FUNCTIONS ===============================


// ============================ MEMBER FUNCTIONS ===============================

// -----------------------------------------------------------------------------
// FileTransaction::FileTransaction
// C++ default constructor
// -----------------------------------------------------------------------------
//
FileTransaction::FileTransaction(
    UrlRequestInfo* _urlRequestInfo,
    ITransactionObserver* _transactionObserver)
    : BaseTransaction( _urlRequestInfo, _transactionObserver ),
      m_handle( NULL )
    {
    }


// Destructor
FileTransaction::~FileTransaction()
    {
    }

// -----------------------------------------------------------------------------
// FileTransaction::DoSubmit
//
//
// -----------------------------------------------------------------------------
//
eErrorCode FileTransaction::DoSubmit()
    {
    // <TODO> : Do a cache check before submitting the transaction
    TransactionManager::sharedInstance()->add(this);
    return ERR_OK;
    }

// -----------------------------------------------------------------------------
// FileTransaction::CancelTransaction
//
//
// -----------------------------------------------------------------------------
//
void FileTransaction::CancelTransaction(
    eErrorCode _error )
    {
    // cancel
    TransactionManager::sharedInstance()->cancel(this);
    //
    BaseTransaction::CancelTransaction( _error );
    }

// -----------------------------------------------------------------------------
// FileTransaction::CreateHeaderResponse
// <TODO>
//
// -----------------------------------------------------------------------------
//
void FileTransaction::CreateHeaderResponse()
    {
    UrlResponseHeaderInfo* header = new UrlResponseHeaderInfo();
    //
    header->SetTransId( TransactionId() );
    //
    header->SetTopLevel( m_urlRequestInfo->TopLevel() );

    //add back the fragment if it exists
    if(header->ResponseUrl())
        {
        char* buf = (char *)malloc(AcStrlen(header->ResponseUrl()) + 1);
        AcStrcpy(buf, header->ResponseUrl());

        if(m_fragment)
            {
            AcStrcat(buf, "#");
            AcStrcat(buf, m_fragment);
            }
        header->SetResponseUrl( buf );
        }
    header->SetRequestUrl( m_urlRequestInfo->CurrentUrl() );

    //transfer the ownership to response info
    m_responseInfo->SetHeaderInfo(header);
    }

// -----------------------------------------------------------------------------
// FileTransaction::HandleGotResponseHeaders
//
// Blank implementation since file requests doesn't get any header callbacks
// -----------------------------------------------------------------------------
//
void FileTransaction::HandleGotResponseHeaders( )
    {
    }

// -----------------------------------------------------------------------------
// FileTransaction::HandleResponseBodyData
//
//
// -----------------------------------------------------------------------------
//
void FileTransaction::HandleResponseBodyData(void* _body, int _len)
    {
    // get it from the transaction
    //
    AddBodyData( _body, _len );
    }

//  End of File

