/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		IPropertyMap.h
 * @brief		Define interface IDOM of WebControl
 * @author	Chaehwan Li (chaehwan.li@samsung.com)
 * @version	1.0
 * @date		2008.03.14	v1.0		Created
 */

#ifndef __IPropertyMap_Defined
#define __IPropertyMap_Defined

#include "IUnknown.h"
#include "WebDefs.h"

namespace	WebControl
{

class IPropertyMap : public IUnknown
{
public:
	/**
	* Client must free the pValue instance
	*/
	virtual HRESULT getValue( int key, void **pValue ) = 0;
};

} // namespace WebControl

#endif // __IPropertyMap_Defined