/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		IUnknown.h
 * @brief		Define base interface for all interfaces of WebControl
 * @author	Sangheon Kim (sangheon.kim@samsung.com)
 * @version	1.0
 * @date		2008.03.26	v1.0		Created
 */

#ifndef __IUnknown_Defined
#define __IUnknown_Defined

namespace	WebControl
{

class IUnknown
{
public:

	virtual ~IUnknown();

	/**
	* Client must not use c++ delete to free object of WebControl.
	* Plz use Release.
	*/
	void operator delete( void *p )
	{
		((IUnknown*)(p))->Release();
	}

	/**
	* delete this object
	*/
	virtual void Release();
};


} // namespace WebControl

#endif // __IUnknown_Defined