/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		IWML.h
 * @brief		Define interface IWMLDo of WebControl
 * @author	Chaehwan Li (chaehwan.li@samsung.com)
 * @version	1.0
 * @date		2008.03.14	v1.0		Created
 */

#ifndef __IWML_Defined
#define __IWML_Defined

#include "WebDefs.h"

namespace	WebControl
{

class IWMLDo
{
public:

	/*
	 * @desc gets the number of WML Button
	 * @param 
	 * @return int number
	 */
	virtual HRESULT getCount( int *out_count ) = 0;

	/*
	 * @desc gets the Data with index of WML Button
	 * @param in_Index : index
	 * @param out_pszBuffer : pointer to buffer
	 * @param in_BufferLen : length of buffer
	 * @return HRESULT TRUE/FALSE
	 */
	virtual HRESULT GetName( char* out_pszBuffer, int in_nBufferLen, int in_Index ) = 0;

	/*
	 * @desc passes the selected index of WML button to Browser engine
	 * @param in_Index : index
	 * @return HRESULT TRUE/FALSE
	 */
	virtual HRESULT DoAction( int in_Index ) = 0;

};

} // namespace WebControl

#endif // __IWML_Defined