/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		WebElementPropertyMap.h
 * @brief		implement WebElementPropertyMap
 * @author	Sangheon Kim (sangheon77.kim@samsung.com)
 * @version	1.0
 * @date		2008.04.01	v1.0		Created
 */
#ifndef __WebElementPropertyMap_Defined
#define __WebElementPropertyMap_Defined


#include "IPropertyMap.h"


namespace WebCore {
    class HitTestResult;
}

namespace	WebControl
{

class WebElementPropertyMap : public IPropertyMap
{
public:
	WebElementPropertyMap( WebCore::HitTestResult& result);

private:
	~WebElementPropertyMap();
	WebCore::HitTestResult* m_pHitResult;

public:
	virtual HRESULT getValue( int key, void **pValue );

};



} // namespace  WebControl

#endif // __WebFrame_Defined