/*
 * Copyright (c) S/W Platform, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics. 
 */
/** 
 * @file		WebImage.h
 * @brief		implement WebImage
 * @author	Sangheon Kim (sangheon77.kim@samsung.com)
 * @version	1.0
 * @date		2008.04.01	v1.0		Created
 */
#ifndef __WebImage_Defined
#define __WebImage_Defined

#include "WebControlConfig.h"
#include "IContents.h"

namespace WebCore {
    class HitTestResult;
}

namespace	WebControl
{

class WebImage : public IImage
{
public:
	WebImage( WebCore::HitTestResult& result);

private:
	~WebImage();
	WebCore::HitTestResult* m_pHitResult;

public:
	/*
	 * @desc gets codec type
	 * @param out_pszBuffer : pointer to buffer
	 * @param in_nBufferLen : length of buffer
	 * @return HRESULT TRUE/FALSE
	 */
	virtual HRESULT getCodecType( ImgCodecType *out_codec );

	virtual HRESULT getURL( char* out_pszBuffer, int in_pnBufferLen );

	/*
	* @desc gets raw data
	* @param out_pszBuffer : pointer to buffer
	* @param in_nBufferLen : buffer length
	* @return HRESULT TRUE/FALSE
	*/
	virtual HRESULT getRawData( char* out_pszBuffer, int in_nBufferLen );

	/*
	 * @desc gets Raw data size
	 * @param 
	 * @return int total size
	 */
	virtual HRESULT getRawDataSize( int *out_size );

};



} // namespace  WebControl

#endif // __WebImage_Defined