/*
 * Samsung Handset Platform
 * Copyright (c) 2000 Software Center, Samsung Electronics, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung Electronics.
 */

#ifndef _SHP_TYPES_H_
#define _SHP_TYPES_H_

#include <stdio.h>
#include "ShpConfig.h"

typedef unsigned char		UCHAR;
typedef unsigned short		USHORT;
typedef unsigned int		UINT;
typedef unsigned long		ULONG;

/* Machine independence */
typedef signed   char		INT8;
typedef unsigned char		UINT8;
typedef signed short				INT16;
typedef unsigned short		UINT16;

#ifndef ADDR
typedef unsigned int		ADDR;
#endif // ADDR

typedef unsigned int		DID;
#include <wchar.h>


typedef wchar_t			wctype_t;

//Type definition for the return type of secure APIs 
typedef unsigned long 	AcErrnoT;


/* Machine independence */
typedef  long int				INT32; 
typedef unsigned long		UINT32;
typedef long	long			INT64;
typedef unsigned long long	UINT64;

#ifndef NULL
#	define NULL				(void*)0
#endif // !NULL

#ifndef BOOL
typedef int					BOOL;
#endif // BOOL

#ifndef TRUE
#define TRUE				1
#endif // TRUE
#ifndef FALSE
#define FALSE				0
#endif // FALSE

/* Programming concept */
typedef unsigned char		BYTE;
typedef unsigned short		WORD;
typedef unsigned long		DWORD;


typedef int					HObj;
#define INVALID_HOBJ		(-1)

#define OBJNAME_MAX			32

#define NULLSTR				("")

/*
 * I18N
 */
typedef unsigned short MCHAR;

#define MB_NULL					0
#define	MB_NEWLINE				10


/*
 * General definition of masks for bit field access
 */
/*
 * Definition of different lenght of masks from 1 to 32 but possible to extend on more.
 */
#define MASKL1  0x01		/*          1  */
#define MASKL2  0x03		/*         11  */
#define MASKL3  0x07		/*        111  */
#define MASKL4  0x0F		/*       1111  */
#define MASKL5  0x1F		/*      11111  */
#define MASKL6  0x3F		/*     111111  */
#define MASKL7  0x7F		/*    1111111  */
#define MASKL8  0xFF		/*   11111111  */
#define MASKL9	0x01FF		/*  ...        */
#define MASKL10	0x03FF
#define MASKL11	0x07FF
#define MASKL12	0x0FFF
#define MASKL13	0x1FFF
#define MASKL14	0x3FFF
#define MASKL15	0x7FFF
#define MASKL16	0xFFFF
#define MASKL17	0x01FFFF
#define MASKL18	0x03FFFF
#define MASKL19	0x07FFFF
#define MASKL20	0x0FFFFF
#define MASKL21	0x1FFFFF
#define MASKL22	0x3FFFFF
#define MASKL23	0x7FFFFF
#define MASKL24	0xFFFFFF
#define MASKL25	0x01FFFFFF
#define MASKL26	0x03FFFFFF
#define MASKL27	0x07FFFFFF
#define MASKL28	0x0FFFFFFF
#define MASKL29	0x1FFFFFFF
#define MASKL30	0x3FFFFFFF
#define MASKL31	0x7FFFFFFF
#define MASKL32	0xFFFFFFFF

#ifndef INFINITE
#	define INFINITE	0xFFFFFFFF
#endif
/*
 * Macro to get a value in a byte in accordance with
 *    - The length in bits of the value
 *    - Its position in the byte
 */
#define GETMSK(val, pos, msk)	((val & (msk << pos) ) >> pos)
/* Macro to put a value in a byte */
#define PUTMSK(var, val, pos)	(var | (val<<pos))

typedef enum
{
	DLL_CREATE,
	DLL_DELETE,
	DLL_START,
	DLL_STOP,
	DLL_DISPATCH_USER		// User-defined extensions
} DllDispatchType;

#endif // _SHP_TYPES_H
