#ifndef _WM_GRP_TYPE_H_
#define _WM_GRP_TYPE_H_

#include "WmGrp.h"
#include "WmGrpConfig.h"
#include "DisplayAbstractionModule.h"

#include "alex_egl.h"
#include "vgu.h"

typedef ULONG	COLOR32;			
typedef USHORT	COLOR16;			
typedef UCHAR		 ALPHA;

typedef	HObj	HGC;
typedef HObj	HFNT;

typedef    enum {
	SCREEN_0	   =  0,
} WmScreen;     

#define SCREEN_MAIN		SCREEN_0 

typedef    enum {
	CLIP_REJECT,
} WmClip;	

typedef	   enum {
	LINE_SOLID,
	LINE_DOT,	
	LINE_DASH,	
} WmLineType;

typedef	   enum {
	ARC_ONLY,
} WmArcType;

typedef    enum {
	COMPRESS_INVALID = -1,
	COMPRESS_NONE,
} WmCompressType;	

typedef struct tagWMPOINT {
	int		x;
	int		y;
} WmPoint;

typedef struct tagWMRECT {
	int		x; 
	int		y;
	int		w; 
	int		h;
} WmRect;

typedef struct tagWMBOX {
	int		x1; 
	int		y1;
	int		x2; 
	int		y2;
} WmBox;

typedef struct tagREGDATA {
	int	size;
	int	numRects;
}WmRegData;

typedef struct tagREGION {
	WmBox extents;
	WmRegData* data;
}WmRegion;

typedef	struct tagSCREENINFO{
	COLOR16*	   pMemFrmbuf;			
	COLOR16*	   pOverFrmbuf;		
} WmScreenInfo;

typedef struct tagWMBITMAP {
	WmCompressType  compressType;	  
	int				rectW;			
	int				rectH;			  
	UCHAR		    bitsPerPixel;	 
	BOOL		    bUseChromakey; 	 
	ULONG			colorChromakey;	 
	BOOL			bUseReplacement;  
	ULONG			colorReplacement;
	void*			pBits;			  
} WmBitmap;

typedef struct tagGCATTRIBUTE {
	HFNT		 hFont;				
	int			bitsPerPixel;	
} WmGCAttrib;

typedef struct tagGRAPHICSCONTEXT {
	WmRect					   rcGC;     
	WmRect					   rcClipGC;  
	WmRect					   rcFrmbuf;  
	BOOL					   bMemGC;	  
	COLOR*					   pMem;	 	
	WmGCAttrib				   gcAttrib;  
} WmGC;

#endif 
