#ifndef _WS_ECOM_H_
#define _WS_ECOM_H_

#ifdef __cplusplus
extern "C" {
#endif

ECOM_INTERFACE(EGWESWinSet)
{
	BOOL	(*SetEditAreaFont)			(HWIN hWin, HFNT hFont);
	BOOL	(*ShowIndicatorInputMode)	( HWIN hWinMain );
	BOOL	(*DrawIndicatorInputMode)	( HWIN hWinMain );
	BOOL	(*GetVeEditText)			( HWIN hWin, MCHAR* pmszTextBuf, int length );
	int		(*GetVeEditTextLength)		(HWIN hWin);
	HWIN	(*GetVeEditWindow)				(HWIN hVeWin);
	BOOL	(*SetVeEditWindowForm)			(HWIN hVeWin, int winType, int EditStyle, int did, int form, int item);
	BOOL	(*SetEditAreaInputAlphabetMode)	(HWIN hWin, WsEditLetterMode capsMode);
	BOOL	(*SetEditSmartLetterMode)		(HWIN hWin, WsEditSmartLetterMode smartLetterMode);
	HWIN	(*CreateVirtualEditForm) 		(HWIN hWinParent, int virtualEditStyle, int did, int form, int item, WmEventMapEntry* pEventMap );
	BOOL 	(*SetMainDisplayDirection)		(HWIN hWin, int iDirection);

	HWIN	(*CreateEditArea)		  ( HWIN hWinParent, int editAreaStyle, int rectX, int rectY, int rectW, int rectH, WmEventMapEntry* pEventMap );
	int		(*GetEditAreaLimitLength) ( HWIN hWin );
	BOOL	(*SetEditAreaLimitLength) ( HWIN hWin, int length );
	BOOL	(*SetEditAreaText)		  ( HWIN hWin, MCHAR* mszText );
	BOOL	(*GetEditAreaText)		  ( HWIN hWin, MCHAR* pmszTextBuf, int length );
	int     (*GetEditAreaTextLength)  ( HWIN hWin );
	BOOL	(*SetEditAreaCategory)	  ( HWIN hWin, WsEditCategory category, BOOL bEnable );
	BOOL	(*SetEditAreaInputMode)   ( HWIN hWin, WsEditInputMode inputMode );
	BOOL	(*GetEditAreaInputMode)   ( HWIN hWin, WsEditInputMode* pInputMode );
	BOOL	(*SetEditAreaLetterMode) ( HWIN hWin, WsEditAreaLetterMode letterMode );
	BOOL	(*SetEditAreaCursorPos) ( HWIN hWin, int cursorPos );
	BOOL 	(*EditAreaCursorIsInFirstLine) ( HWIN hWin );
	HWIN	(*CreateEditField)			 ( HWIN hWinParent, int editFieldStyle, int rectX, int rectY, int rectW, int rectH, WmEventMapEntry* pEventMap );
	int		(*GetEditFieldLimitLength)   ( HWIN hWin );
	BOOL	(*SetEditFieldLimitLength)   ( HWIN hWin, int length );
	BOOL	(*SetEditFieldText)		     ( HWIN hWin, MCHAR* mszText );
	BOOL	(*GetEditFieldText)		     ( HWIN hWin, MCHAR* pmszTextBuf, int length );
	int		(*GetEditFieldTextLength)	 ( HWIN hWin );
	BOOL	(*GetEditFieldInputMode)     ( HWIN hWin ,WsEditInputMode* pInputMode );
	BOOL	(*SetEditFieldInputMode)     ( HWIN hWin, WsEditInputMode inputMode );
	BOOL	(*SetEditFieldCategory)      ( HWIN hWin, WsEditCategory category, BOOL bEnable );
	BOOL	(*SetEditFieldTitle)		 ( HWIN hWin, MCHAR* mszTitle );
	BOOL	(*SetEditFieldCursorPos)	 ( HWIN hWin, int cursorPos );
	HWIN	(*CreateMain) (int rectX,
						  int rectY, 
						  int rectW, 
						  int rectH, 
						  int style,
						  int screen,
						  WmEventMapEntry* pMainEventMap ); 
	BOOL	(*DrawMainSoftKey) ( HWIN hWin );
	BOOL	(*ShowMainSoftKey) ( HWIN hWin );
	HWIN	(*CreateMessageBox)		   ( HWIN hWinParent, WsMessageBoxStyle messageBoxStyle, WsMessageBoxIconStyle iconType, ULONG timeout, MCHAR* mszTitle, MCHAR* mszText, WmEventMapEntry* pEventMap );
	HWIN	(*CreatePopup)		( HWIN hWinParent, int style, int rectX, int rectY, int rectW, int rectH);
	HWIN	(*CreateSimple)    ( HWIN hWinParent, int rectX, int rectY, int rectW, int rectH, WmEventMapEntry* pMainEventMap );
	HWIN	(*CreateComboBox) 					( HWIN hWinParent, int style, int iMaxDropLineCount, int rectX, int rectY, int rectW, int rectH, WmEventMapEntry* pEventMap );
	BOOL	(*ShowComboBoxDrop)					( HWIN hWinComboBox, BOOL bShow );
	BOOL	(*SetComboBoxCurSelItem) 			( HWIN hWinComboBox, int iIndex );
	int		(*GetComboBoxCurSelItemIndex) 		( HWIN hWinComboBox );
	BOOL	(*AddComboBoxTextItem) 				( HWIN hWinComboBox, MCHAR* mszText );
	BOOL	(*EnableComboBoxItem)				( HWIN hWinComboBox, int iIndex, BOOL bEnable );
	BOOL	(*GetComboBoxItemEnabled)			( HWIN hWinComboBox, int iIndex );
};

#	define WsSetEditAreaFont			(__WsGetVtbl()->SetEditAreaFont)
#	define WsShowIndicatorInputMode		(__WsGetVtbl()->ShowIndicatorInputMode)
#	define WsGetVeEditWindow					(__WsGetVtbl()->GetVeEditWindow)
#	define WsSetVeEditWindowForm				(__WsGetVtbl()->SetVeEditWindowForm)
#	define WsSetEditAreaInputAlphabetMode		(__WsGetVtbl()->SetEditAreaInputAlphabetMode)
#	define WsSetEditSmartLetterMode				(__WsGetVtbl()->SetEditSmartLetterMode)
#	define WsCreateVirtualEditForm 				(__WsGetVtbl()->CreateVirtualEditForm )
#	define WsSetMainDisplayDirection			(__WsGetVtbl()->SetMainDisplayDirection)
#	define WsGetVeEditText						(__WsGetVtbl()->GetVeEditText)
#	define WsDrawIndicatorInputMode				(__WsGetVtbl()->DrawIndicatorInputMode)
#	define WsGetVeEditTextLength				(__WsGetVtbl()->GetVeEditTextLength)
#	define WsCreateEditArea					(__WsGetVtbl()->CreateEditArea)
#	define WsGetEditAreaLimitLength			(__WsGetVtbl()->GetEditAreaLimitLength)
#	define WsSetEditAreaLimitLength			(__WsGetVtbl()->SetEditAreaLimitLength)
#	define WsSetEditAreaText				(__WsGetVtbl()->SetEditAreaText)
#	define WsGetEditAreaText				(__WsGetVtbl()->GetEditAreaText)
#	define WsGetEditAreaTextLength			(__WsGetVtbl()->GetEditAreaTextLength)
#	define WsSetEditAreaCategory			(__WsGetVtbl()->SetEditAreaCategory)
#	define WsSetEditAreaInputMode			(__WsGetVtbl()->SetEditAreaInputMode)
#	define WsGetEditAreaInputMode			(__WsGetVtbl()->GetEditAreaInputMode)
#	define WsSetEditAreaLetterMode			( __WsGetVtbl()->SetEditAreaLetterMode )
#	define WsSetEditAreaCursorPos			( __WsGetVtbl()->SetEditAreaCursorPos )
#	define WsEditAreaCursorIsInFirstLine	( __WsGetVtbl()->EditAreaCursorIsInFirstLine )
#	define WsCreateEditField				(__WsGetVtbl()->CreateEditField)
#	define WsGetEditFieldLimitLength		(__WsGetVtbl()->GetEditFieldLimitLength)
#	define WsSetEditFieldLimitLength		(__WsGetVtbl()->SetEditFieldLimitLength)
#	define WsSetEditFieldText				(__WsGetVtbl()->SetEditFieldText)
#	define WsGetEditFieldText				(__WsGetVtbl()->GetEditFieldText)
#	define WsGetEditFieldTextLength			(__WsGetVtbl()->GetEditFieldTextLength)
#	define WsGetEditFieldInputMode			(__WsGetVtbl()->GetEditFieldInputMode)
#	define WsSetEditFieldInputMode			(__WsGetVtbl()->SetEditFieldInputMode)
#	define WsSetEditFieldCategory			(__WsGetVtbl()->SetEditFieldCategory)
#	define WsSetEditFieldTitle				(__WsGetVtbl()->SetEditFieldTitle)
#	define WsSetEditFieldCursorPos			(__WsGetVtbl()->SetEditFieldCursorPos)
#	define WsCreateMain						(__WsGetVtbl()->CreateMain)					
#	define WsDrawMainSoftKey					(__WsGetVtbl()->DrawMainSoftKey)
#	define WsShowMainSoftKey					(__WsGetVtbl()->ShowMainSoftKey)
#	define WsCreateMessageBox				(__WsGetVtbl()->CreateMessageBox)
#	define WsCreateSimple					(__WsGetVtbl()->CreateSimple)
#	define WsCreateComboBox 				(__WsGetVtbl()->CreateComboBox)			
#	define WsShowComboBoxDrop				(__WsGetVtbl()->ShowComboBoxDrop)
#	define WsSetComboBoxCurSelItem 			(__WsGetVtbl()->SetComboBoxCurSelItem)
#	define WsGetComboBoxCurSelItemIndex 	(__WsGetVtbl()->GetComboBoxCurSelItemIndex)
#	define WsAddComboBoxTextItem 			(__WsGetVtbl()->AddComboBoxTextItem)
#	define WsEnableComboBoxItem				(__WsGetVtbl()->EnableComboBoxItem)
#	define WsGetComboBoxItemEnabled			(__WsGetVtbl()->GetComboBoxItemEnabled)

typedef struct
{
	DECLARE_ECOM_VTBL(EGWESWinSet)
	UINT32		refCount;
} TGWESWinSet;

#ifdef __cplusplus
}
#endif

#endif