#ifndef _WS_EDITCOMMON_H_
#define _WS_EDITCOMMON_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "shp.h"
#include "WsCommon.h"
#include "WmLngInputMethod.h"

typedef enum {
	EDIT_INPUTMODE_ALPHA,	
	EDIT_INPUTMODE_T9,			
	EDIT_INPUTMODE_NUMERIC,	
	EDIT_INPUTMODE_SYMBOL,		
	EDIT_INPUTMODE_QWERTY,		
} WsEditInputMode;

typedef enum {
	EDIT_INPUTTYPE_HWR,		
} WsEditInputType;

typedef enum{
	EDIT_NUMERICMODE_NORMAL,		
}WsEditNumericModeType;

typedef enum {
	EDIT_INPUTOPTION_NORMAL,	
}WsEditInputOption;

typedef enum {
	EDIT_LETTERMODE_SMALL,				
	EDIT_LETTERMODE_SHIFT,				
	EDIT_LETTERMODE_CAPITAL,			
}WsEditLetterMode;

typedef enum {
	EDIT_SMART_LETTERMODE_NONE,			
}WsEditSmartLetterMode;

typedef enum {
	EDIT_CHARACTER_GSM,					
}WsEditCharacterMode;

#define F_ALPHA		(1<<EDIT_INPUTMODE_ALPHA)
#define F_T9		(1<<EDIT_INPUTMODE_T9)
#define F_NUMERIC	(1<<EDIT_INPUTMODE_NUMERIC)
#define F_SYMBOL	(1<<EDIT_INPUTMODE_SYMBOL)
#define F_QWERTY (1<<EDIT_INPUTMODE_QWERTY)

typedef unsigned int	WsEditCategory;

#define F_HWR	  (1<<EDIT_INPUTTYPE_HWR)

typedef unsigned int	WsEditInputTypeCategory;

typedef struct tagEDITINFO
{
	HWIN	hWin;												
}WsEditInfo;

BOOL WsSetEditSmartLetterMode(HWIN hWin, WsEditSmartLetterMode smartLetterMode);

#ifdef __cplusplus
}
#endif

#endif